/* This code is to  study the cross correction
 * for the CLIMATE network/
 *
 *by Jingfang
 * 2015.11.15
 *
 *
 * */
#include "climate.h"
#include "distance.h"
#include <iostream>
#include <math.h>
#include <vector>
#include <stdlib.h>
#include <time.h>
#include <ctime>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <cmath>
#include <string>
#include <mpi.h>


using namespace  std;


int main(int argc,char **argv)
{
    int rank;
    int size;



    MPI_Init(&argc,&argv);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank); 
    for(int i=rank;i<10;i+=size)
    {
        //readdata1();

        caulation1(i);
        //test(i,rank);
    }
    MPI_Finalize();

    return 0;

}
/* 
void test(int i_start, int rank, int size)
{
    ofstream fout1,fout2;
    stringstream ss;
    string stagestr;
        ss.clear();
        ss << rank;
        ss >> stagestr;
        string a="air_"; // output filename
        string b="_.dat";
        string filename = out_file+a+stagestr+b;
        fout1.open(filename.c_str(),std::fstream::app);
        fout1 << i_start<<"," <<rank<< "\n"; // output everything needed.
        fout1.close();
    

}
 */
string int2str(int i)
{
    string s;
    stringstream ss(s);
    ss << i;

    return ss.str();
}
void readdata1()
{

    string finalname1,finalname2;
    ifstream fintemp1,fintemp2;
    stringstream ss;
    //double a;
    //int N=N;
    //int N1=N1;

    finalname1 =in_file;
    fintemp1.open(finalname1.c_str());
    if(!fintemp1)
    {

        cout<<finalname1<<" does not exit!"<<endl;
        exit(1);
    }
    double r;

    for(int i=0;i<N;i++)
    {
        srand(i);
        int k=0;
        for(int y=0;y<41;y++)
        {
            int yy=rand()%41;
            for (int m=0;m<12;m++)
            {
                int mm=rand()%12;
                for (int d=0;d<months[m];d++)
                {
                    int k=yy*365+mdays[mm]+d;
                    fintemp1>>r;
                    datanet[i][k]=r;
                }
            }
        }
    }








    finalname2 =in_file1;
    fintemp2.open(finalname2.c_str());
    if(!fintemp2)
    {

        cout<<finalname2<<" does not exit!"<<endl;
        exit(1);
    }
    double rr;

    for(int i=0;i<N1;i++)
    {
        srand(i);
        int k=0;
        for(int y=0;y<41;y++)
        {
            int yy=rand()%41;
            for (int m=0;m<12;m++)
            {
                int mm=rand()%12;
                for (int d=0;d<months[m];d++)
                {
                    int k=yy*365+mdays[mm]+d;
                    fintemp2>>rr;
                    datanet1[i][k]=rr;
                }
            }
        }
    }



    fintemp1.close();
    fintemp2.close();


}




void caulation1(int rank)
{

    ofstream fout1,fout2;
    stringstream ss,ss1;
    string stagestr,stagestr1,stagestr2;


    double ccf,maxccf,meanccf,minccf;
    int maxind,minind;
    int tauvalues[taumax*2+1];
    double Wmin,Wmax;
    double TDmax,TDmin,TDabs,Cabs,Wabs;
    double P0lag;
    for(int x=-taumax;x<=taumax;x++)
    {
        tauvalues[x+taumax]=x; // the list of time delay values (from -tau_max to +tau_max)
    }

    int yearx = rank;
    int monthXX=10;




    ss.clear();
    ss << yearx+2010;
    ss >> stagestr;
    for (int s=1; s<monthXX;s++)
   {
    readdata1();
    int monthx = 1;
    ss1.clear();
    ss1 << (rank+1)*10+s;
    ss1 >> stagestr1;
    string a="s_ICET_links_30d_tau20_8040_allyear"; // output filename
    string b=".dat";
    string filename = out_file+stagestr1+a+b;
    fout1.open(filename.c_str());
    //int stagelengthx = mdays[monthx+1] - mdays[monthx];

   // int startpoint = (rank+1)*365+mdays[monthx];


    double ccflist1[2*taumax+1];
    double ww,cc,nn,wn,cn;
    double W,C,WN,CN;

     

    for (int node1=0;node1<N;node1++)
    {
        int i=node1;
        ww=0.0;
        cc=0.0;
        nn=0.0;
        wn=0.0;
        cn=0.0;
        //srand(i);
        srand(rank*10+s+node1);
        int v11= rand ()% 40;
    //    srand(time(NULL));
        int v21= rand ()%12;
        int startpoint2= (v11+1)*365+mdays[v21];
        //cout<<v11<<" "<<v21<<endl;
        for (int node2 =0;node2<N1;node2++)
            {
                int j=node2;
                maxccf=-1000;
                maxind=-1000;
                meanccf=0;
                minccf=1000;
                minind=1000;
                srand(rank*10+s+node2);
//srand(rank*10+s+node1);
                int v1= rand ()% 40;
  //              srand(time(NULL));
                int v2= rand ()%12;
              //  cout<<v1<<" "<<" "<<v2<<" "<<rank<<" "<<s<<" "<<endl;
                int startpoint1= (v1+1)*365+mdays[v2];
                for(int tau=taumax;tau>=0;tau--)
                {
                    ccf=corrcoef(i,j,startpoint2-tau,startpoint1,stagelength);
                    //cout<<ccf<<endl;
                    ccflist1[taumax-tau]=ccf; // calculate the first half of the cross-correlation
                    meanccf+=ccf/(2*taumax+1); // calculate the mean of the cross-correlation step by step
                    if (ccf>maxccf)
                    {
                        maxccf=ccf; // take the maximal cross-correlation
                        maxind=taumax-tau; // take the index for the maximal cross-correlation
                    }
                    if (ccf<minccf)
                    {
                        minccf=ccf; // take the minimal cross-correlation
                        minind=taumax-tau; // take the index for the minimal cross-correlation
                    }
                    if (tau==0)
                    {
                        P0lag=ccf; // the correlation at 0 time delay.
                    }
                }
                for(int tau=1;tau<=taumax;tau++)
                {
                    ccf=corrcoef(i,j,startpoint2,startpoint1-tau,stagelength);
                    //cout<<ccf<<endl;
                    ccflist1[taumax+tau]=ccf; // calculate the second half of the cross-correlation
                    meanccf=meanccf+ccf/(2*taumax+1);
                    if (ccf>maxccf)
                    {
                        maxccf=ccf;
                        maxind=taumax+tau;
                    }
                    if (ccf<minccf)
                    {
                        minccf=ccf;
                        minind=taumax+tau;
                    }
                }
                Wmax=(maxccf-meanccf)/(stdv(ccflist1,0,2*taumax,meanccf)); // calculate positive link weight
                Wmin=(minccf-meanccf)/(stdv(ccflist1,0,2*taumax,meanccf)); // calculate negative link weight
                TDmax=tauvalues[maxind]; // timedelay for the positive peak
                TDmin=tauvalues[minind]; // timedelay for the negative peak
                if(fabs(maxccf) > fabs(minccf))
                {
                    TDabs = TDmax;
                    Cabs = maxccf;
                    Wabs = Wmax;
                }
                else
                {
                    TDabs = TDmin;
                    Cabs = minccf;
                    Wabs = Wmin;
                }
               // cout<<maxccf<<endl;
                fout1 << i << " " << j <<" " << Wmax << " " << Wmin << " " << TDmax << " " << TDmin <<" "<<TDabs<<" " << P0lag << " " << maxccf << " " << minccf <<" " << Cabs << " " << Wabs << " " << TDabs << "\n"; // output everything needed.
    }


   }

    fout1.close();}
}

