#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Dec 29 18:24:39 2020

@author: meng
"""

import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
import csv
path="/home/meng/bupt_data/data/seaice/"
ao=np.loadtxt(path+'AO.dat')
aoi=ao[:,2][360:840]
def function1():

    #wx=np.zeros(shape=(480,8040))
    #cx=np.zeros(shape=(480,8040))
    outfile=open(path+'degrees_ICET.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_ICET_degree.dat")
            
            w=data[:,0]
            c=data[:,1]
           
            for i in range(8040):
                outfile.write('%.6f %.6f \n'%(w[i],c[i]))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()
    
    
    
def function11():

    #wx=np.zeros(shape=(480,8040))
    #cx=np.zeros(shape=(480,8040))
    outfile=open(path+'degrees_ICET_1y.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_ICET_degree_1y.dat")
            
            w=data[:,0]
            c=data[:,1]
           
            for i in range(8040):
                outfile.write('%.6f %.6f \n'%(w[i],c[i]))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()
        
def function_autocorr():

    #wx=np.zeros(shape=(480,8040))
    #cx=np.zeros(shape=(480,8040))
    outfile=open(path+'autocorr.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_TT_autocorr.dat")
            
            w=data
            #c=data[:,1]
           
            for i in range(8040):
                outfile.write('%.6f \n'%(w[i]))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()
    

def corrAO():
    path='/home/meng/bupt_data/data/seaice/'
    sy=1
    data=np.loadtxt(path+"degrees_60N_sy_"+str(sy)+".dat")
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_degreesy60Nsy1.dat','w')
  
    x=np.reshape(data[:,0],(480,8040))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        
    outfile.close()
    
def degree_direct():
    path='/home/meng/bak_bupt/newproj/data/'
    data0=np.loadtxt(path+'ICETdegrees_TT_direct_tau30.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    xx0=np.reshape(data0[:,2],(480,8040))
    yy0=np.zeros(shape=(480,8040))
    for k in range(480):
        cut=np.sort(xx0[k])[7236]
        z=np.where(np.array(xx0[k])>cut)[0]
        yy0[k,z]=1
    zz0=[sum(yy0[:,k]) for k in range(8040)]
    
    data=np.loadtxt(path+'ICETdegrees_TT_direct_tau30_sa.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    xx=np.reshape(data[:,2],(480,8040))
    yy=np.zeros(shape=(480,8040))
    for k in range(480):
        cut=np.sort(xx[k])[7236]
        z=np.where(np.array(xx0[k])>cut)[0]
        yy[k,z]=1
    zz=[sum(yy[:,k]) for k in range(8040)]
    
    
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')


    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=42,linewidth=3,rotation=0)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=42,linewidth=3,rotation=0)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color0=[np.mean(xx0[:,k]) for k in range(8040)]
    m.scatter(x,y,150,marker='o',c=color0,cmap='magma')
   
    cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
   # label_1 =  [2,3,4]
    #cb.set_ticks(label_1)    
    cb.ax.tick_params(labelsize=42)  
    #plt.clim(130,160)
    #plt.clim(2.5,4)    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(24, 15)    
    
    figure = plt.gcf() # get current figure
                    # 
    figure.set_size_inches(20,10)
        
    plt.savefig("/home/meng/fig/seaice/TtoICE.png")
 

    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'degrees_TT_direct_tau30_s.dat')
      
    xx=np.reshape(data[:,1],(480,8040))

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')


    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=42,linewidth=3,rotation=0)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=42,linewidth=3,rotation=0)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=[np.mean(xx[:,k]) for k in range(8040)]
    m.scatter(x,y,150,marker='o',c=color,cmap='magma')
   
    cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
   # label_1 =  [2,3,4]
    #cb.set_ticks(label_1)    
    cb.ax.tick_params(labelsize=42)  
    #plt.clim(130,160)
    #plt.clim(2.5,4)    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(24, 15)    
    
    figure = plt.gcf() # get current figure
                    # 
    figure.set_size_inches(20,10)
        
    plt.savefig("/home/meng/fig/seaice/TtoICEs.png")



    outfile=open(path+'corrAO_ICEtoT_N.dat','w')


    xx=np.reshape(data[:,2],(480,8040))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        z1=[np.mean(y1[k]) for k in range(40)]
        z2=[np.mean(y2[k]) for k in range(40)]
        winter=[i*12+j for j in [0,1,11] for i in range(40)]
        spring=[i*12+j for j in [2,3,4] for i in range(40)]
        summer=[i*12+j for j in [5,6,7] for i in range(40)]
        autumn=[i*12+j for j in [8,9,10] for i in range(40)]
        r1,p1=pearsonr(z1,z2)
        r2,p2=pearsonr(x1[winter],x2[winter])
        r3,p3=pearsonr(x1[spring],x2[spring])
        r4,p4=pearsonr(x1[summer],x2[summer])
        r5,p5=pearsonr(x1[autumn],x2[autumn])
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f \n'%(i,r,p,r1,p1,r2,p2,r3,p3,r4,p4,r5,p5))
        outfile.flush()
        
    outfile.close()   
    
    
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')

    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=42,linewidth=3,rotation=0)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=42,linewidth=3,rotation=0)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data0[:,11]
    m.scatter(x,y,150,marker='o',c=color,cmap='magma')
   
    cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
   # label_1 =  [2,3,4]
    #cb.set_ticks(label_1)    
    cb.ax.tick_params(labelsize=42)  
    #plt.clim(2.5,4)    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(24, 15)    

    xx=np.reshape(data[:,2],(480,8040))
    
    outfile=open(path+'corrAO_ICEtoT_N_monthly.dat','w')
    
    for mon in range(12):
        rx=[]
        px=[]
        for i in range(8040):
            print (i)
            x1=xx[:,i]
            x2=aoi  
            tx=[i*12+mon for i in range(40)]
            y1=x1[tx]
            y2=x2[tx]
            r,p=pearsonr(y1,y2)
            rx.append(r)
            px.append(p)
            outfile.write('%.6f %.6f \n'%(r,p))
            outfile.flush()
    outfile.close()
            
        regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    
        data0=np.loadtxt(path+'corrAO_ICEtoT_N.dat')
        nodes=np.arange(8040)
        m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=42,linewidth=3,rotation=0)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=42,linewidth=3,rotation=0)
               
        lats1=np.array(regrid[:,1][nodes])
        lons1=np.array(regrid[:,2][nodes])
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx
        m.scatter(x,y,150,marker='o',c=color,cmap='bwr')
       
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # label_1 =  [2,3,4]
        #cb.set_ticks(label_1)    
        cb.ax.tick_params(labelsize=42)  
        plt.clim(-0.5,0.5)
        
        signodes=[int(i) for i in range(8040) if (px[i]<0.05)]
        lats1=np.array(regrid[:,1][signodes])
        lons1=np.array(regrid[:,2][signodes])
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx
        m.scatter(x,y,150,marker='x',c='k')        
        
      
        #plt.clim(2.5,4)    
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(20,10)
        
        plt.savefig("/home/meng/fig/seaice/"+str(mon)+"_ICET_AO.png")
        plt.close()
        
        
        
def function2_sig():       
    datas=np.loadtxt(path+'sigtoAO_sy_ICET.dat')
    data=np.loadtxt(path+'sigtoAO_ICET.dat')
    wx=data[:,0]
    pwx=data[:,1]
    cx=data[:,2]
    pcx=data[:,3]
    wxs=np.reshape(datas[:,0],(100,8040))
    cxs=np.reshape(datas[:,2],(100,8040))
    pwxs=np.reshape(datas[:,1],(100,8040))
    pcxs=np.reshape(datas[:,3],(100,8040))
    
    wcut=[np.sort(wxs[:,i])[95] for i in range(8040)]
    ccut=[np.sort(cxs[:,i])[5] for i in range(8040)]

    wcut=[max(wxs[:,i]) for i in range(8040)]
    ccut=[min(cxs[:,i]) for i in range(8040)]


    outfile=open(path+'S100_r_wpos_ICET.dat','w')
    outfile1=open(path+'S100_r_cmax_ICET.dat','w')
    nw=0
    nc=0
    for i in range(8040):
        if(wx[i]>wcut[i] and pwx[i]<0.05 and wx[i]>0):
            outfile.write('%d %.6f \n'%(i,wx[i]))
            outfile.flush()
            nw+=1
        if(cx[i]<ccut[i] and pcx[i]<0.05 and cx[i]<0):
            outfile1.write('%d %.6f \n'%(i,cx[i]))
            outfile1.flush()
            nc+=1
    outfile.close()
    outfile1.close()
    nwx=[]
    ncx=[]
    for s in range(100):
        outfile=open(path+"S100_r_wpos_60N_sy_"+str(s)+".dat",'w')
        outfile1=open(path+"S100_r_cmax_60N_sy_"+str(s)+".dat",'w')
        nws=0
        ncs=0
        for i in range(8040):
            if(wxs[s][i]>wcut[i] and pwxs[s][i]<0.05 and wxs[s][i]>0):
                outfile.write('%d %.6f \n'%(i,wxs[s][i]))
                outfile.flush()
                nws+=1
            if(cxs[s][i]<ccut[i] and pcxs[s][i]<0.05 and cxs[s][i]<0):
                outfile1.write('%d %.6f \n'%(i,cxs[s][i]))
                outfile1.flush()
                ncs+=1
        nwx.append(nws)
        ncx.append(ncs)
        outfile.close()
        outfile1.close()
def function2_sig_neg():       
    datas=np.loadtxt(path+'sigtoAO_sy_ICET_neg.dat')
    data=np.loadtxt(path+'sigtoAO_ICET_neg.dat')
    wx=data[:,0]
    cx=data[:,2]
    pwx=data[:,1]
    pcx=data[:,3]

    wxs=np.reshape(datas[:,0],(100,8040))
    cxs=np.reshape(datas[:,2],(100,8040))
    pwxs=np.reshape(datas[:,1],(100,8040))
    pcxs=np.reshape(datas[:,3],(100,8040))
    
    wcut=[np.sort(wxs[:,i])[5] for i in range(8040)]
    ccut=[np.sort(cxs[:,i])[95] for i in range(8040)]

    wcut=[min(wxs[:,i]) for i in range(8040)]
    ccut=[max(cxs[:,i]) for i in range(8040)]


    outfile=open(path+'S100_r_wneg_ICET_neg.dat','w')
    outfile1=open(path+'S100_r_cmin_ICET_neg.dat','w')
    nw=0
    nc=0
    for i in range(8040):
        if(wx[i]<wcut[i] and wx[i]<0 and pwx[i]<0.05):
            outfile.write('%d %.6f \n'%(i,wx[i]))
            outfile.flush()
            nw+=1
        if(cx[i]>ccut[i] and cx[i]>0 and pcx[i]<0.05):
            outfile1.write('%d %.6f \n'%(i,cx[i]))
            outfile1.flush()
            nc+=1
    outfile.close()
    outfile1.close()
    nwx=[]
    ncx=[]
    for s in range(100):
        outfile=open(path+"S95_r_wneg_ICET_sy_"+str(s)+"_neg.dat",'w')
        outfile1=open(path+"S95_r_cmin_ICET_sy_"+str(s)+"_neg.dat",'w')
        nws=0
        ncs=0
        for i in range(8040):
            if(wxs[s][i]<wcut[i] and wxs[s][i]<0 and pwxs[s][i]<0.05):
                outfile.write('%d %.6f \n'%(i,wxs[s][i]))
                outfile.flush()
                nws+=1
            if(cxs[s][i]>ccut[i] and cxs[s][i]>0 and pcxs[s][i]<0.05):
                outfile1.write('%d %.6f \n'%(i,cxs[s][i]))
                outfile1.flush()
                ncs+=1
        nwx.append(nws)
        ncx.append(ncs)
        outfile.close()
        outfile1.close()


def plot_map_sig_wpos_wneg_s95r():
    wpx=np.loadtxt(path+'S100_r_wpos_ICET.dat')
    wnx=np.loadtxt(path+'S100_r_wneg_ICET_neg.dat')
    
    wpx=np.loadtxt(path+'wsignodesp_ICET.dat')
    wnx=np.loadtxt(path+'wsignodesn_ICET_neg.dat') 
    
    xp=np.zeros(8040)
    xn=np.zeros(8040)
    for i in range(1,101):
        wpx=np.loadtxt(path+"wsignodesp_ICET_sy_"+str(i)+".dat")
        wnx=np.loadtxt(path+"wsignodesn_ICET_sy_"+str(i)+"_neg.dat")         
        nodep=[int(j) for j in wpx[:,0]]
        noden=[int(j) for j in wnx[:,0]]      
        nodep=np.array(nodep)
        noden=np.array(noden)
        xp[nodep]+=1
        xn[noden]+=1
    outfile=open(path+'recounttime_shuffle.dat','w')
    for i in range(8040):
        outfile.write('%d %d \n'%(xp[i],xn[i]))
        outfile.flush()
    outfile.close()

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in wpx[:,0]]
    #nodes=np.arange(8040)
    #nodes=[int(i) for i in range(8040) if(xp[i]>5)]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=wpx[:,1]
    #color=xp[np.array(nodes)]
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('W positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in wnx[:,0]]
   # nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=wnx[:,1]
   # color=xn
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('W negative',fontsize=34) #annual
    
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_wpos_wneg_ICET.png") 

def calculate_sigN_sigr():    
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    outfile1=open(path+'wsignodesp_ICET.dat','w')
    outfile2=open(path+'csignodesn_ICET.dat','w')
    wp=0
    cn=0
    wps=0
    cns=0
    for i in range(8040):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            outfile1.write('%d %.6f %.6f \n'%(i,r,p))
            outfile1.flush()
            wp+=1
            if(i>=4020):
                wps+=1
                
        x=cx[:,i]
        y=aoi
        r1=pearsonr(x,y)[0]
        p1=pearsonr(x,y)[1]
        if(r1<0 and p1<0.05):
            outfile2.write('%d %.6f %.6f \n'%(i,r1,p1))
            outfile2.flush() 
            cn+=1
            if(i>=4020):
                cns+=1
    outfile1.close()
    outfile2.close()
    print (wp,cn,wps,cns)

def degree_AO():       
    datad=np.loadtxt(path+'degrees_ICET.dat')
    datad1=np.loadtxt(path+'degrees_ICET_neg.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad1[:,0],(480,8040))
    outfile=open(path+'degree_ICET_corr_AO.dat','w')
    outfile1=open(path+'wsignodesp_ICET.dat','w')
    outfile2=open(path+'wsignodesn_ICET_neg.dat','w')
    wp=0
    cn=0
    wps=0
    cns=0
    for i in range(8040):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            outfile1.write('%d %.6f %.6f \n'%(i,r,p))
            outfile1.flush()
            wp+=1
            if(i>=4020):
                wps+=1
                
        x=cx[:,i]
        y=aoi
        r1=pearsonr(x,y)[0]
        p1=pearsonr(x,y)[1]
        if(r1<0 and p1<0.05):
            outfile2.write('%d %.6f %.6f \n'%(i,r1,p1))
            outfile2.flush() 
            cn+=1
            if(i>=4020):
                cns+=1
        outfile.write('%.6f %.6f %.6f %.6f \n'%(r,p,r1,p1))
        outfile.flush()
    outfile1.close()
    outfile2.close()
    outfile.close()
    print (wp,cn,wps,cns)
def function2():       
    datad=np.loadtxt(path+'degrees_60N_neg.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    outfile1=open(path+'wsignodesp_60N_pos.dat','w')
    outfile2=open(path+'wsignodesn_60N_neg.dat','w')
    wp=0
    cn=0
    wps=0
    cns=0
    for i in range(8040):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            outfile1.write('%d %.6f %.6f \n'%(i,r,p))
            outfile1.flush()
            wp+=1
            if(i>=4020):
                wps+=1
                
        x=cx[:,i]
        y=aoi
        r1=pearsonr(x,y)[0]
        p1=pearsonr(x,y)[1]
        if(r1<0 and p1<0.05):
            outfile2.write('%d %.6f %.6f \n'%(i,r1,p1))
            outfile2.flush() 
            cn+=1
            if(i>=4020):
                cns+=1
    outfile1.close()
    outfile2.close()
    print (wp,cn,wps,cns)

def selfw():
    path='/home/meng/bupt_data/data/seaice/testtau/'
    outfile=open(path+'self.dat','w')
    x1=[]
    x2=[]
    
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            wx=[]
            for year1 in range(1980,2020):
                print (year)
                data=np.loadtxt(path+""+str(year)+"_"+str(month)+"_850t_60N_self_"+str(year1)+".dat")
                for i in range(8040):
                    wx.append(data[:,0][i])
            wx=np.reshape(wx,(40,8040))
            for node in range(8040):
                x1.append(np.mean(wx[:,node]))
                x2.append(np.std(wx[:,node]))
    regrid=np.loadtxt('/home/meng/bupt_data/data/seaice/regridcos2.5d_global.dat')

    nodes=np.arange(8040)
    #nodes=np.arange(8040)
    #nodes=[int(i) for i in range(8040) if(xp[i]>5)]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=WX
    #color=xp[np.array(nodes)]
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/Self_tt_w.png")                 

def test_tau_maxW():
    path='/home/meng/bupt_data/data/seaice/'
  
    outfile=open(path+'maxdegree_ICET_testtau.dat','w')
    for tau in range(1,61):
        print (tau)
        datad=np.loadtxt(path+"degrees_ICET_testtau_"+str(tau)+"_pn.dat")
        print (tau,max(datad[:,0][:4020]),min(datad[:,2][:4020]),max(datad[:,0][4020:]),min(datad[:,2][4020:]))
        outfile.write('%.6f %.6f %.6f %.6f \n'%(max(datad[:,0][:4020]),min(datad[:,2][:4020]),max(datad[:,0][4020:]),min(datad[:,2][4020:])))
        outfile.flush()
    outfile.close()
def test_tau_aveW():
    path='/home/meng/bupt_data/data/seaice/'
  
    outfile=open(path+'avexdegree_ICET_testtau.dat','w')
    for tau in range(1,61):
        print (tau)
        datad=np.loadtxt(path+"degrees_ICET_testtau_"+str(tau)+"_pn.dat")
        print (tau,max(datad[:,0][:4020]),min(datad[:,2][:4020]),max(datad[:,0][4020:]),min(datad[:,2][4020:]))
        outfile.write('%.6f %.6f \n'%(np.mean(datad[:,0][:]),np.mean(datad[:,2][:])))
        outfile.flush()
    outfile.close()
        


def test_tau_r():
       outfile=open(path+'testtau_ICET.dat','w')
       for tau in range(1,91):
        print (tau)
        datad=np.loadtxt(path+"degrees_ICET_testtau_"+str(tau)+"_pn.dat")      
        wx=np.reshape(datad[:,0],(480,8040))
        wnx=np.reshape(datad[:,2],(480,8040))
        
        outfile1=open(path+"wsignodesp_ICET_t"+str(tau)+".dat",'w')
        outfile2=open(path+"wsignodesn_ICET_neg_t"+str(tau)+".dat",'w')
        wp=0
        cn=0
        wps=0
        cns=0
        for i in range(8040):
            x=wx[:,i]
            y=aoi
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            if(r>0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()
                wp+=1
                if(i>=4020):
                    wps+=1
                    
            x=wnx[:,i]
            y=aoi
            r1=pearsonr(x,y)[0]
            p1=pearsonr(x,y)[1]
            if(r1<0 and p1<0.05):
                outfile2.write('%d %.6f %.6f \n'%(i,r1,p1))
                outfile2.flush() 
                cn+=1
                if(i>=4020):
                    cns+=1
        outfile1.close()
        outfile2.close()
        print (tau,wp,cn,wps,cns)
        outfile.write('%d %d %d %d \n'%(wp,cn,wps,cns))
        outfile.flush()
    outfile.close()

def plot_tau_n():
    data=np.loadtxt(path+'testtau_ICET.dat')
    taux=np.arange(1,61,1)
    wp=data[:,0][:60]
    wps=data[:,2][:60]
    wn=data[:,1][:60]
    wns=data[:,3][:60]
    wpn=[data[:,0][i]-data[:,2][i] for i in range(60)]
    wnn=[data[:,1][i]-data[:,3][i] for i in range(60)]
    
    data1=np.loadtxt(path+'maxdegree_ICET_testtau.dat')
    dpn=data1[:,0]
    dps=data1[:,2]
    dnn=data1[:,1]
    dns=data1[:,3]

 
    ax=plt.subplot(221)
    xmajorLocator = MultipleLocator(10) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(1) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(2) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.5) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
    plt.plot(taux,dps,'b-',label='south',linewidth=3)
    plt.plot(taux,dpn,'g-',label='north',linewidth=3)
    plt.axvline(x=10,color='r')
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\\tau$',fontsize=24)
    plt.ylabel('Maximal degree $W_{pos}$',fontsize=24)
    plt.legend(fontsize=24)
    plt.annotate('(a)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom') 
    ax=plt.subplot(222)
    xmajorLocator = MultipleLocator(10) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(1) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(2) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.5) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,wn,'k--',label='globe')
    plt.plot(taux,dns,'b-',label='south',linewidth=3)
    plt.plot(taux,dnn,'g-',label='north',linewidth=3)
    plt.axvline(x=10,color='r')
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\\tau$',fontsize=24)
    plt.ylabel('Minimal degree $W_{neg}$',fontsize=24)
    plt.legend(fontsize=24)
    plt.annotate('(b)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom') 

   
    ax=plt.subplot(223)
    xmajorLocator = MultipleLocator(10) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(400) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(2) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(200) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    plt.plot(taux,wp,'k-',label='globe',linewidth=3)
    plt.plot(taux,wps,'b-',label='south',linewidth=3)
    plt.plot(taux,wpn,'g-',label='north',linewidth=3)
    plt.axvline(x=10,color='r')
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\\tau$',fontsize=24)
    plt.ylabel('Number of AO affected $W_{pos}$ nodes',fontsize=24)
    plt.legend(fontsize=24)
    plt.annotate('(c)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom') 
    ax=plt.subplot(224)
    xmajorLocator = MultipleLocator(10) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(400) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(2) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(200) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    plt.plot(taux,wn,'k-',label='globe',linewidth=3)
    plt.plot(taux,wns,'b-',label='south',linewidth=3)
    plt.plot(taux,wnn,'g-',label='north',linewidth=3)
    plt.axvline(x=10,color='r')
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\\tau$',fontsize=24)
    plt.ylabel('Number of AO affected $W_{neg}$ nodes',fontsize=24)
    plt.legend(fontsize=24)
    plt.annotate('(d)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom')    


     
    plt.subplots_adjust(top = 0.95, bottom = 0.08, right = 0.95, left = 0.1, 
                hspace = 0.2, wspace = 0.25)  
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(21, 16)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/testtau_r_degree_ICET.png")   


    
def season():       
    datadn=np.loadtxt(path+'degrees_ICET_neg.dat')
    wx=np.reshape(datadn[:,0],(480,8040))
    cx=np.reshape(datadn[:,1],(480,8040))
    outfile=open(path+'sigtoao_num_mon_ICET_wneg.dat','w')
    for mon in range(12):
        outfile1=open(path+"wsignodesn_ICET_"+str(mon)+"_neg.dat",'w')
        outfile2=open(path+"csignodesp_ICET_"+str(mon)+"_neg.dat",'w')
        wp=0
        cn=0
        wps=0
        cns=0
        for i in range(8040):
            x=wx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r=pearsonr(x1[:,mon],y1[:,mon])[0]
            p=pearsonr(x1[:,mon],y1[:,mon])[1]
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()
                wp+=1
                if(i>=4020):
                    wps+=1
                    
            x=cx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r1=pearsonr(x1[:,mon],y1[:,mon])[0]
            p1=pearsonr(x1[:,mon],y1[:,mon])[1]
            if(r1>0 and p1<0.05):
                outfile2.write('%d %.6f %.6f \n'%(i,r1,p1))
                outfile2.flush() 
                cn+=1
                if(i>=4020):
                    cns+=1
        outfile1.close()
        outfile2.close()
        print (wp,cn,wps,cns)
        outfile.write('%d %d %d %d \n'%(wp,cn,wps,cns))
        outfile.flush()
    outfile.close()
    
    data1=np.loadtxt(path+'signum_mon_ICET.dat')
    datap=np.loadtxt(path+'sigtoao_num_mon_ICET_wpos.dat')
    datan=np.loadtxt(path+'sigtoao_num_mon_ICET_wneg.dat')
    xp=datap[:,0]
    xn=datan[:,0]
    xps=data1[:,0]
    xns=data1[:,1]
    xps=np.reshape(xps,(12,100))
    xns=np.reshape(xns,(12,100))
    binx=np.linspace(min(xps[2]),max(xps[2]),10)
    x,y=pdf1(xps[2],binx)
    plt.plot(x,y)
 
    xticks=[1,3,5,7,9,11]
    label=['Jan','Mar','May','Jul','Sep','Nov']
    
    ax=plt.subplot(121)
    xmajorLocator = MultipleLocator(2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(200) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(100) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=3)
    ax.tick_params(which='major', length=9)  
       
    x=[np.sort(xps[i])[95] for i in range(12)]  
    plt.plot(x,'o--',color='gray',linewidth=4,markersize=20)
    plt.plot(xp,'o--',color='r',linewidth=4,markersize=20)
    plt.xticks(xticks,labels=label,fontsize=24,rotation=-45)    
    plt.yticks(fontsize=24)
    plt.xlabel('month',fontsize=24)
    plt.ylabel('Number of sig $W_{pos}$',fontsize=24)
    #plt.legend(fontsize=24)
    
    plt.annotate('(a)', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=28 ,
                             xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                             ha='left', va='bottom')      
    
    ax=plt.subplot(122)
    xmajorLocator = MultipleLocator(2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(200) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(100) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=3)
    ax.tick_params(which='major', length=9)  
       
    x=[np.sort(xns[i])[95] for i in range(12)]  
    plt.plot(x,'o--',color='gray',linewidth=4,markersize=20)
    plt.plot(xn,'o--',color='r',linewidth=4,markersize=20)
    plt.xticks(xticks,labels=label,fontsize=24,rotation=-45)    
    plt.yticks(fontsize=24)
    plt.xlabel('month',fontsize=24)
    plt.ylabel('Number of sig $W_{neg}$',fontsize=24)
    #plt.legend(fontsize=24)
    
    plt.annotate('(b)', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=28 ,
                             xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                             ha='left', va='bottom')         
    
    
    plt.subplots_adjust(top = 0.9, bottom = 0.15, right = 0.9, left = 0.1, 
                    hspace = 0.2, wspace = 0.2)  
    figure = plt.gcf() # get current figure
                    # 
    figure.set_size_inches(22, 8)
            #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/SigNum_ICET_mon.png")  
 
    
    data=np.loadtxt(path+'degrees_ICEICE.dat')
    x=np.reshape(data[:,1],(40,12))
    ao=np.reshape(aoi,(40,12))
    px=[]
    for i in range(12):
        px.append(pearsonr(x[:,i],ao[:,i])[0])
        print (i,pearsonr(x[:,i],ao[:,i]))
    plt.plot(px,'o--')
 
def output_sigcorrao_num_mon():   
    outfile1=open(path+'sigtoao_num_mon_ICET_wposp_wnegn.dat','w')
    outfile2=open(path+'sigtoao_num_mon_ICET_cmaxn_cminn.dat','w')

    data1=np.loadtxt(path+'sigtoao_num_mon_ICET_wpos.dat')
    data2=np.loadtxt(path+'sigtoao_num_mon_ICET_wneg.dat')
    for i in range(12):
        wposp=data1[:,0][i]
        cmaxn=data1[:,1][i]
        wposp_s=data1[:,2][i]
        cmaxn_s=data1[:,3][i]
        wnegn=data2[:,0][i]
        cminp=data2[:,1][i]
        wnegn_s=data2[:,2][i]
        cminp_s=data2[:,3][i]
        outfile1.write('%d %d %d %d \n'%(wposp,wnegn,wposp_s,wnegn_s))
        outfile2.write('%d %d %d %d \n'%(cmaxn,cminp,cmaxn_s,cminp_s))
        outfile1.flush()
        outfile2.flush()
    outfile1.close()
    outfile2.close()
    
    datar=np.loadtxt(path+'sigtoao_num_mon_ICET_wposp_wnegn.dat')
    data=np.loadtxt(path+'signodesnum_sy_ICET_mon.dat')
    wposp=data[:,0]
    wnegn=data[:,3]
    wposp_s=data[:,4]
    wnegn_s=data[:,7]
    wposp=np.reshape(wposp,(100,12))
    wnegn=np.reshape(wnegn,(100,12))
    wposp_s=np.reshape(wposp_s,(100,12))
    wnegn_s=np.reshape(wnegn_s,(100,12))     
    for i in range(12):
        print (i+1,datar[i])
        print (i+1,np.sort(wposp[:,i])[95],np.sort(wnegn[:,i])[95],np.sort(wposp_s[:,i])[95],np.sort(wnegn_s[:,i])[95])

    datanumn=np.loadtxt(path+'sigNUM_ICET_sy_S_neg.dat')   
    datanump=np.loadtxt(path+'sigNUM_ICET_sy_S.dat')   
    wps=np.reshape(datanump[:,0],(100,480))
    wns=np.reshape(datanumn[:,0],(100,480))
    wpsx=[np.sort(wps[:,i])[95] for i in range(480)]
    wnsx=[np.sort(wns[:,i])[95] for i in range(480)]
    datanumn0=np.loadtxt(path+'sigNUM_ICET_S_neg.dat')   
    datanump0=np.loadtxt(path+'sigNUM_ICET_S.dat')   
    wpsx0=datanump0[:,0]
    wnsx0=datanumn0[:,0]
    
    x0=np.reshape(wpsx0,(40,12))
    y0=np.reshape(wnsx0,(40,12))
    xs=np.reshape(wpsx,(40,12))
    ys=np.reshape(wnsx,(40,12))
    
    
    
    



def mon_r_p_c_w():       
    datadn=np.loadtxt(path+'degrees_ICET_neg.dat')
    datad=np.loadtxt(path+'degrees_ICET.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    wnx=np.reshape(datadn[:,0],(480,8040))
    cnx=np.reshape(datadn[:,1],(480,8040))    
    outfile=open(path+'sigtoao_num_mon_ICET_w_c_r_p.dat','w')
    for mon in range(12):
        for i in range(8040):
            x=wx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r=pearsonr(x1[:,mon],y1[:,mon])[0]
            p=pearsonr(x1[:,mon],y1[:,mon])[1]
            
 
                    
            x=cx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r1=pearsonr(x1[:,mon],y1[:,mon])[0]
            p1=pearsonr(x1[:,mon],y1[:,mon])[1]
            
            
            x=wnx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r2=pearsonr(x1[:,mon],y1[:,mon])[0]
            p2=pearsonr(x1[:,mon],y1[:,mon])[1]
            
 
                    
            x=cnx[:,i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            r3=pearsonr(x1[:,mon],y1[:,mon])[0]
            p3=pearsonr(x1[:,mon],y1[:,mon])[1]            
            
            outfile.write('%.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f \n'%(r,r1,r2,r3,p,p1,p2,p3))
            outfile.flush()
    outfile.close()
    
    data=np.loadtxt(path+'sigtoao_num_mon_ICET_w_c_r_p.dat')
    rw=data[:,0]
    rc=data[:,1]
    rwn=data[:,2]
    rcn=data[:,3]
    print (pearsonr(rw,rc),pearsonr(rw,rwn),pearsonr(rwn,rcn),pearsonr(rc,rcn))
    outfile=open(path+'ICET_sigtoao_w_c_r_p','w')
    
    rwx=np.reshape(rw,(12,8040))
    rcx=np.reshape(rc,(12,8040))
    rwnx=np.reshape(rwn,(12,8040))
    rcnx=np.reshape(rcn,(12,8040))
    for i in range(12):
        print (i,pearsonr(rwx[i],rcx[i])[0],pearsonr(rwnx[i],rwx[i])[0],pearsonr(rwnx[i],rcnx[i])[0],pearsonr(rcx[i],rcnx[i])[0])
        outfile.write('%d %.6f %.6f %.6f %.6f \n'% (i+1,pearsonr(rwx[i],rcx[i])[0],pearsonr(rwnx[i],rwx[i])[0],pearsonr(rwnx[i],rcnx[i])[0],pearsonr(rcx[i],rcnx[i])[0]))
        outfile.flush()
    outfile.close()
            
def corr_ao():
        datads=np.loadtxt(path+"degrees_ICET.dat")
        wx=np.reshape(datads[:,0],(480,8040))
        nodess=np.loadtxt(path+"wsignodesp_ICET.dat")
        nodesS=[int(j) for j in nodess[:,0] if (j>4019)]  
        nodesN=[int(j) for j in nodess[:,0] if (j<4020)]    
        xxs=[np.mean(np.array(wx[i][nodesS])) for i in range(480)]
        rs=pearsonr(xxs,aoi)[0]
        xxn=[np.mean(np.array(wx[i][nodesN])) for i in range(480)]
        rn=pearsonr(xxn,aoi)[0]      
        cx=np.reshape(datads[:,1],(480,8040))
        nodess1=np.loadtxt(path+"csignodesn_ICET.dat")
        nodesS1=[int(j) for j in nodess1[:,0] if (j>4019)]  
        nodesN1=[int(j) for j in nodess1[:,0] if (j<4020)]    
        xxs=[np.mean(np.array(cx[i][nodesS1])) for i in range(480)]
        rs1=pearsonr(xxs,aoi)[0]
        xxn=[np.mean(np.array(cx[i][nodesN1])) for i in range(480)]
        rn1=pearsonr(xxn,aoi)[0]       
        print (len(nodesS),rs,len(nodesN),rn,len(nodesS1),rs1,len(nodesN1),rn1)
 
        datads=np.loadtxt(path+"degrees_ICET_neg.dat")
        wx=np.reshape(datads[:,0],(480,8040))
        nodess=np.loadtxt(path+"wsignodesn_ICET_neg.dat")
        nodesS=[int(j) for j in nodess[:,0] if (j>4019)]  
        nodesN=[int(j) for j in nodess[:,0] if (j<4020)]    
        xxs=[np.mean(np.array(wx[i][nodesS])) for i in range(480)]
        rs=pearsonr(xxs,aoi)[0]
        xxn=[np.mean(np.array(wx[i][nodesN])) for i in range(480)]
        rn=pearsonr(xxn,aoi)[0]      
        cx=np.reshape(datads[:,1],(480,8040))
        nodess1=np.loadtxt(path+"csignodesp_ICET_neg.dat")
        nodesS1=[int(j) for j in nodess1[:,0] if (j>4019)]  
        nodesN1=[int(j) for j in nodess1[:,0] if (j<4020)]    
        xxs=[np.mean(np.array(cx[i][nodesS1])) for i in range(480)]
        rs1=pearsonr(xxs,aoi)[0]
        xxn=[np.mean(np.array(cx[i][nodesN1])) for i in range(480)]
        rn1=pearsonr(xxn,aoi)[0]       
        print (len(nodesS),rs,len(nodesN),rn,len(nodesS1),rs1,len(nodesN1),rn1)            
 
    
def corr_ao_mon():
        datads=np.loadtxt(path+"degrees_ICET.dat")
        wx=np.reshape(datads[:,0],(480,8040))
        datads1=np.loadtxt(path+"degrees_ICET_neg.dat")
        cx=np.reshape(datads1[:,0],(480,8040))
        outfile=open(path+'corr_AO_signodes_real_ICET_mon.dat','w')
        for mon in range(12):
            nodess=np.loadtxt(path+"wsignodesp_ICET_"+str(mon)+".dat")
            nodesS=[int(j) for j in nodess[:,0] if (j>4019)]  
            nodesN=[int(j) for j in nodess[:,0] if (j<4020)]    
            xxs=[np.mean(np.array(wx[i][nodesS])) for i in range(480)]
            rs=pearsonr(xxs,aoi)[0]
            xxn=[np.mean(np.array(wx[i][nodesN])) for i in range(480)]
            rn=pearsonr(xxn,aoi)[0]     
            
    
            nodess1=np.loadtxt(path+"wsignodesn_ICET_"+str(mon)+"_neg.dat")
            nodesS1=[int(j) for j in nodess1[:,0] if (j>4019)]  
            nodesN1=[int(j) for j in nodess1[:,0] if (j<4020)]    
            xxs=[np.mean(np.array(cx[i][nodesS1])) for i in range(480)]
            rs1=pearsonr(xxs,aoi)[0]
            xxn=[np.mean(np.array(cx[i][nodesN1])) for i in range(480)]
            rn1=pearsonr(xxn,aoi)[0]       
            print (mon+1,len(nodesS),rs,len(nodesN),rn,len(nodesS1),rs1,len(nodesN1),rn1)        
            outfile.write('%d %d %.6f %d %.6f %d %.6f %d %.6f \n'%(mon+1,len(nodesS),rs,len(nodesN),rn,len(nodesS1),rs1,len(nodesN1),rn1))
            outfile.flush()
        outfile.close()
def r_p_AO():
    datad=np.loadtxt(path+'degrees_ICET_neg.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    outfile=open(path+'sigtoAO_ICET_neg.dat','w')

    for i in range(8040):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        x=cx[:,i]
        y=aoi
        r1=pearsonr(x,y)[0]
        p1=pearsonr(x,y)[1]
        outfile.write('%.6f %.6f %.6f %.6f \n'%(r,p,r1,p1))
        outfile.flush()
    outfile.close()

def plot_map_sig_wpos_wneg():
    wpx=np.loadtxt(path+'wsignodesp_ICET.dat')
    cnx=np.loadtxt(path+'wsignodesn_ICET_neg.dat')
    datat=np.loadtxt(path+'sigtime_ICET.dat')
    datat1=np.loadtxt(path+'sigtime_ICET_neg.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in wpx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=wpx[:,1]
    color=datat[:,0][np.array(nodes)]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('W positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in cnx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=cnx[:,1]
    color=datat1[:,0][np.array(nodes)]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('W negative',fontsize=34) #annual
    
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_wpos_wneg_ICET_sigtime.png") 
    
def plot_W_C_AO_ICET():
    wpx=np.loadtxt(path+'wsignodesp_ICET_11.dat')
    wnx=np.loadtxt(path+'wsignodesn_ICET_11_neg.dat')
    cax=np.loadtxt(path+'csignodesn_ICET_11.dat')
    cix=np.loadtxt(path+'csignodesp_ICET_11_neg.dat')

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    plt.subplot(221)
    ax=plt.plot()
    xx=cax
    nodes=[int(i) for i in xx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='summer')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('$C_{max}$',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(222)
    ax=plt.plot()
    xx=cix
    nodes=[int(i) for i in xx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('$C_{min}$',fontsize=34) #annual
    
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        



    plt.subplot(223)
    ax=plt.plot()
    xx=wpx
    nodes=[int(i) for i in xx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('$W_{pos}$',fontsize=34) #annual
    
    
    plt.annotate('(c)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(224)
    ax=plt.plot()
    xx=wnx
    nodes=[int(i) for i in xx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='summer')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('$W_{neg}$',fontsize=34) #annual
    
    
    plt.annotate('(d)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        

    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.2)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(60, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_ICET_Dec.png") 
    
    
    
def intersectTT_ICET():
    wpx=np.loadtxt(path+'wsignodesp_ICET.dat')
    wpx1=np.loadtxt(path+'wsignodesp_60N.dat')
    
    x=np.intersect1d(wpx[:,0],wpx1[:,0])
    y=[int(i) for i in x if (i>4019)]
    
    print (len(y))
    yt=[]
    yi=[]
    for i in range(100):
        wpx1s=np.loadtxt(path+"wsignodesp_60N_sy_"+str(i+1)+".dat")
        x=np.intersect1d(wpx1s[:,0],wpx[:,0])
        y=[int(i) for i in x if (i>4019)]       
        yi.append(len(y))
        wpxs=np.loadtxt(path+"wsignodesp_ICET_sy_"+str(i+1)+".dat")

        x=np.intersect1d(wpxs[:,0],wpx1[:,0])
        y=[int(i) for i in x if (i>4019)]       
        yt.append(len(y))   
        
        
    
        
    
    wnx=np.loadtxt(path+'wsignodesn_ICET_neg.dat')
    cax=np.loadtxt(path+'csignodesn_ICET.dat')
    cix=np.loadtxt(path+'csignodesp_ICET_neg.dat')

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    plt.subplot(221)
    ax=plt.plot()
    xx=cax
    nodes=[int(i) for i in xx[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='summer')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('$C_{max}$',fontsize=34) #annual
    
def sigtime():
    path="/home/meng/bupt_data/data/seaice/"
    datad=np.loadtxt(path+'degrees_ICET.dat')    
    datadn=np.loadtxt(path+'degrees_ICET_neg.dat')    
    
    datas=np.loadtxt(path+'siglevel_syICET.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datadn[:,0],(480,8040))
    ws=np.reshape(datas[:,0],(480,8040))
    cs=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    cs1=np.reshape(datas[:,3],(480,8040))
    outfile=open(path+'sigtime_syICET_real.dat','w')
    for i in range(8040):
        
        nw=0
        nc=0
        nw1=0
        nc1=0
        for j in range(480):
            if(wx[:,i][j]>ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]>ws1[:,i][j]):
                nw1+=1
            if(cx[:,i][j]<cs[:,i][j]):
                nc+=1
            if(cx[:,i][j]<cs1[:,i][j]):
                nc1+=1   
        print (i)
        outfile.write('%.6f %.6f %.6f %.6f \n'%(nw/480.,nc/480.,nw1/480.,nc1/480.))
        outfile.flush()
    outfile.close()
def sigNum():
    path="/home/meng/bupt_data/data/seaice/"
    path='/home/meng/bak_bupt/newproj/'
    datad=np.loadtxt(path+'degrees_icet.dat')    
    datas=np.loadtxt(path+'siglevel_stki.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    ws=np.reshape(datas[:,0],(480,8040))
    cs=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    cs1=np.reshape(datas[:,3],(480,8040))
    outfile=open(path+'sigNUM_icet_pwc.dat','w')
    
    for j in range(480):
        
        nw=0
        nc=0
        nw1=0
        nc1=0
        for i in range(8040):
            if(wx[:,i][j]>ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]>ws1[:,i][j]):
                nw1+=1
            if(cx[:,i][j]>cs[:,i][j]):
                nc+=1
            if(cx[:,i][j]>cs1[:,i][j]):
                nc1+=1   
        print (j)
        outfile.write('%.6f %.6f %.6f %.6f \n'%(nw/480.,nc/480.,nw1/480.,nc1/480.))
        outfile.flush()
    outfile.close()  
    
def maxabs(a,b):
    if(abs(a)>abs(b)):
        c=a
    else:
        c=b
    return c
    

    
def sigtime_mon():
    path="/home/meng/bupt_data/data/seaice/"
    datad=np.loadtxt(path+'degrees_ICET_neg.dat')    
    datas=np.loadtxt(path+'siglevel_sy_ICET_neg.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    ws=np.reshape(datas[:,0],(480,8040))
    cs=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    cs1=np.reshape(datas[:,3],(480,8040))
    outfile=open(path+'sigtime_ICET_neg.dat','w')
    for i in range(8040):
        
        nw=0
        nc=0
        nw1=0
        nc1=0
        for j in range(480):
            if(wx[:,i][j]<ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]<ws1[:,i][j]):
                nw1+=1
            if(cx[:,i][j]<cs[:,i][j]):
                nc+=1
            if(cx[:,i][j]<cs1[:,i][j]):
                nc1+=1   
        print (i)
        outfile.write('%.6f %.6f %.6f %.6f \n'%(nw/480.,nc/480.,nw1/480.,nc1/480.))
        outfile.flush()
    outfile.close()



def sigtime_syICET():
    path="/home/meng/bupt_data/data/seaice/"
    datad=np.loadtxt(path+'degrees_ICET.dat')    
    datadn=np.loadtxt(path+'degrees_ICET_neg.dat')
    datas=np.loadtxt(path+'siglevel_stki.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    wnx=np.reshape(datadn[:,0],(480,8040))
    ws=np.reshape(datas[:,0],(480,8040))
    wns=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    wns1=np.reshape(datas[:,3],(480,8040))
    outfile=open(path+'sigtime_stki_real.dat','w')
    for i in range(8040):
        
        nw=0
        nc=0
        nw1=0
        nc1=0
        for j in range(480):
            if(wx[:,i][j]>ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]>ws1[:,i][j]):
                nw1+=1
            if(wnx[:,i][j]<wns[:,i][j]):
                nc+=1
            if(wnx[:,i][j]<wns1[:,i][j]):
                nc1+=1   
        print (i)
        outfile.write('%.6f %.6f %.6f %.6f \n'%(nw/480.,nc/480.,nw1/480.,nc1/480.))
        outfile.flush()
    outfile.close()

    
def sigtime_ao():
    l=int(480*0.05)
    aoi=np.array(aoi)
    x=aoi.argsort()
    yh=x[-l:]
    yl=x[:l]
    mars=[11+i*12 for i in range(40)]
    yhm=[int(i) for i in range(480) if i in yh and i in mars]
    ylm=[int(i) for i in range(480) if i in yl and i in mars]
    print (len(yhm),len(ylm))
    path="/home/meng/bupt_data/data/seaice/"
    datad=np.loadtxt(path+'degrees_ICET.dat')    
    datas=np.loadtxt(path+'siglevel_sy_ICET.dat')
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad[:,1],(480,8040))
    ws=np.reshape(datas[:,0],(480,8040))
    cs=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    cs1=np.reshape(datas[:,3],(480,8040))
    outfile1=open(path+'sigtime_ICET_yh.dat','w')
    outfile2=open(path+'sigtime_ICET_yl.dat','w')
    
    for i in range(8040):
        
        nw=0
        nc=0
        nw1=0
        nc1=0
        for j in yh:
            if(wx[:,i][j]>ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]>ws1[:,i][j]):
                nw1+=1
            if(cx[:,i][j]>cs[:,i][j]):
                nc+=1
            if(cx[:,i][j]>cs1[:,i][j]):
                nc1+=1   
        print (i)
        outfile1.write('%d %d %d %d \n'%(nw,nc,nw1,nc1))
        outfile1.flush()
        nw=0
        nc=0
        nw1=0
        nc1=0
        for j in yl:
            if(wx[:,i][j]>ws[:,i][j]):
                nw+=1
            if(wx[:,i][j]>ws1[:,i][j]):
                nw1+=1
            if(cx[:,i][j]>cs[:,i][j]):
                nc+=1
            if(cx[:,i][j]>cs1[:,i][j]):
                nc1+=1   
        print (i)
        outfile2.write('%d %d %d %d \n'%(nw,nc,nw1,nc1))
        outfile2.flush()  
    outfile1.close()
    outfile2.close()
    
    
    data1=np.loadtxt(path+'sigtime_ICET_neg_yh.dat')
    data2=np.loadtxt(path+'sigtime_ICET_neg_yl.dat')
    data0=np.loadtxt(path+'sigtime_ICET_neg.dat')
    hx1=data1[:,0]
    x0=data0[:,0]
    hx2=np.array(hx1)/(np.array(x0)*480)
    
    data3=np.loadtxt(path+'wsignodesn_ICET_neg.dat')
    nodex=[int(i) for i in data3[:,0]]
    plt.hist(hx2)
    plt.hist(hx2[nodex])
    



    data4=np.loadtxt(path+'sigNUM_ICET_S_neg.dat')
    data5=np.loadtxt(path+'sigNUM_ICET_N_neg.dat')

    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=rx
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')   
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
   # m.scatter(x,y,200,marker='x',c='k')     
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)   
    plt.savefig("/home/meng/fig/sigcorrtimes_60N_wp_ao.png") 
def sy_siglevel_ao():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'siglevel_sy_ICET.dat')   
    wx=np.reshape(data[:,0],(480,8040))
    outfile1=open(path+'wsignodesp_ICET_sylevel.dat','w')
    outfile2=open(path+'csignodesn_ICET_sylevel.dat','w')
    wp=0
    wn=0
   
    for i in range(8040):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            outfile1.write('%d %.6f %.6f \n'%(i,r,p))
            outfile1.flush()
            wp+=1
        if(r<0 and p<0.05):
            outfile2.write('%d %.6f %.6f \n'%(i,r,p))
            outfile2.flush()
            wn+=1            
                
       
    outfile1.close()
    outfile2.close()
    print (wp,wn)

def sy_sigtoao_time():
    path='/home/meng/bupt_data/data/seaice/'

    xx=np.zeros(8040)
    nx=[]
    for i in range(1,101):
        print (i)
        data=np.loadtxt(path+"wsignodesn_ICET_sy_"+str(i)+"_neg.dat")
        nodes=[int(i) for i in data[:,0]]
        nodes=np.array(nodes)
        nodes1=[int(i) for i in data[:,0] if (i>4020)]
        nx.append(len(nodes1))
        xx[nodes]+=1
    outfile=open(path+'wp_sigtoao_times_syICET.dat','w')
    for i in range(8040):
        outfile.write('%d \n'%(xx[i]))
        outfile.flush()
    outfile.close()
    nsx=[]
    for i in range(1,101):
        print (i)
        data=np.loadtxt(path+"wsignodesn_ICET_sy_"+str(i)+"_neg.dat")
        nodes=[int(i) for i in data[:,0]]
        nodes=np.array(nodes)
        nx=0
        for j in nodes:
            if(xx[j]<5):
                nx+=1
        nsx.append(nx)
                
    
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    datas=np.loadtxt(path+'wp_sigtoao_times_60N.dat')
    datar=np.loadtxt(path+'wsignodesp_60N.dat')
    node=[int(i) for i in datar[:,0]]
    node=np.array(node)
    plt.hist(datas)
    plt.hist(datas[node])
    
    
    nodex=[]
    rx=[]
    for i in range(len(node)):
        ii=node[i]
        if(xx[i]<5):
            nodex.append(int(ii))  
            rx.append(datar[:,1][i])
    nodex=[int(i) for i in datar[:,0]]
            
           
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data1[:,0]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')   
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
   # m.scatter(x,y,200,marker='x',c='k')     
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)   
    plt.savefig("/home/meng/fig/sigcorrtimes_60N_wp_ao.png") 

    nodes=nodex
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[nodes]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')   
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    lats1=np.array(regrid[:,1][nodex])
    lons1=np.array(regrid[:,2][nodex])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
    m.scatter(x,y,200,marker='x',c='k')     
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)   
    plt.savefig("/home/meng/fig/sigcorrtimes_ICET_wp_ao.png")             

def sy_sigtoao_time_mon():
  path='/home/meng/bupt_data/data/seaice/'
  for mon in range(12):
    xx=np.zeros(8040)
    
    for i in range(1,101):
        print (i)
        data=np.loadtxt(path+"wsignodesp_ICET_sy_"+str(i)+"_"+str(mon)+".dat")
        nodes=[int(i) for i in data[:,0]]
        nodes=np.array(nodes)
        
        xx[nodes]+=1
    # outfile=open(path+'wp_sigtoao_times_60N.dat','w')
    # for i in range(8040):
    #     outfile.write('%d \n'%(xx[i]))
    #     outfile.flush()
    # outfile.close()
    nsx=[]
    for i in range(1,101):
        print (i)
        data=np.loadtxt(path+"wsignodesp_ICET_sy_"+str(i)+".dat")
        nodes=[int(i) for i in data[:,0]]
        nodes=np.array(nodes)
        nx=0
        for j in nodes:
            if(xx[j]<5):
                nx+=1
        nsx.append(nx)
                
    
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    
    datar=np.loadtxt(path+"wsignodesp_ICET_"+str(mon)+".dat")
    node=[int(i) for i in datar[:,0]]
    node=np.array(node)
    nodex=[]
    rx=[]
    for i in range(len(node)):
        ii=node[i]
        if(xx[i]<5):
            nodex.append(int(ii))  
            rx.append(datar[:,1][i])
    nodex=[int(i) for i in datar[:,0]]
            
           
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')   
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    lats1=np.array(regrid[:,1][nodex])
    lons1=np.array(regrid[:,2][nodex])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
    m.scatter(x,y,200,marker='x',c='k')     
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)   
    plt.savefig("/home/meng/fig/sigcorrtimes_ICET_"+str(mon+1)+"_wp_ao.png") 
    plt.close()

    nodes=nodex
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx[nodes]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')   
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    lats1=np.array(regrid[:,1][nodex])
    lons1=np.array(regrid[:,2][nodex])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=xx
    m.scatter(x,y,200,marker='x',c='k')     
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)   
    plt.savefig("/home/meng/fig/sigcorrtimes_ICET_wp_ao.png")             

        

def function4():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'sigtime_ICET.dat')

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    
    plt.subplot(211)
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,0]
    m.scatter(x,y,200,marker='o',c=color,cmap='PuRd')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('W',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(212)
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='PuRd')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('C',fontsize=34) #annual
    
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/sigtimes_ICET_95.png") 


def function5():
    data=np.loadtxt(path+'sigtime_60N.dat')

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    
    plt.subplot(211)
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)


    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,0]
    m.scatter(x,y,200,marker='o',c=color,cmap='PuRd')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('W',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    plt.subplot(212)
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='PuRd')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='sig times', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('C',fontsize=34) #annual
    
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.9, bottom = 0.05, right = 0.88, left = 0.01, 
                hspace = 0.1, wspace = 0.05)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(19, 30)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/sigtimes_60N_95_arctic.png") 

    
def functionsy():

    #wx=np.zeros(shape=(480,8040))
    #cx=np.zeros(shape=(480,8040))
    for sy in range(1,101):
        outfile=open(path+"degrees_psd75N_sy_"+str(sy)+".dat","w")
        n=0
        for year in range(1980,2020):
            print (year)
            for month in range(1,13):
                print (month)
                year=int(year)
                month=int(month)
                data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_850t_psd_75N_degree_sy_"+str(sy)+".dat")
                
                w=data[:,0]
                c=data[:,1]
                for i in range(8040):
                    outfile.write('%.6f %.6f \n'%(w[i],c[i]))
                    outfile.flush()
         #       wx[n]=w
         #       cx[n]=c
         #       n+=1        
        outfile.close()   
    
    
def function4():
    outfile=open(path+'degrees_60Ninside.dat','w')
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_850t_60Ninside_degree.dat")            
            w=data[:,0]
            c=data[:,1]
            for i in range(len(w)):
                outfile.write('%.6f %.6f \n'%(w[i],c[i]))
                outfile.flush()
    outfile.close()
    
def function5():       
    datad=np.loadtxt(path+'degrees_60Ninside.dat')
    wx=np.reshape(datad[:,0],(480,636))
    cx=np.reshape(datad[:,1],(480,636))
    outfile1=open(path+'wsignodesp_arctic.dat','w')
    outfile2=open(path+'csignodesn_arctic.dat','w')
    for i in range(636):
        x=wx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            outfile1.write('%d %.6f %.6f \n'%(i,r,p))
            outfile1.flush()
        x=cx[:,i]
        y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r<0 and p<0.05):
            outfile2.write('%d %.6f %.6f \n'%(i,r,p))
            outfile2.flush() 
    outfile1.close()
    outfile2.close()


def signum():
    path="/home/meng/bupt_data/data/seaice/"
   # path="/dssg/home/mengjun/junfile/data/data/seaice/"

    datas=np.loadtxt(path+'siglevel_syICET.dat')
    ws=np.reshape(datas[:,0],(480,8040))
    cs=np.reshape(datas[:,1],(480,8040))
    ws1=np.reshape(datas[:,2],(480,8040))
    cs1=np.reshape(datas[:,3],(480,8040))
    outfile=open(path+'sigNUM_syICET_S.dat','w')   
    outfile1=open(path+'sigNUM_syICET_N.dat','w')   


    datad=np.loadtxt(path+"degrees_ICET.dat") 
    datad1=np.loadtxt(path+"degrees_ICET_neg.dat") 
    
    wx=np.reshape(datad[:,0],(480,8040))
    cx=np.reshape(datad1[:,0],(480,8040))
    for i in range(480):
            wp=[j for j in range(4020,8040) if (wx[i,j]>ws[i,j])]
            cp=[j for j in range(4020,8040) if (cx[i,j]<cs[i,j])]
            wp1=[j for j in range(4020,8040) if (wx[i,j]>ws1[i,j])]
            cp1=[j for j in range(4020,8040) if (cx[i,j]<cs1[i,j])]
            outfile.write('%d %d %d %d \n'%(len(wp),len(cp),len(wp1),len(cp1)))
            outfile.flush()
            wp=[j for j in range(4020) if (wx[i,j]>ws[i,j])]
            cp=[j for j in range(4020) if (cx[i,j]<cs[i,j])]
            wp1=[j for j in range(4020) if (wx[i,j]>ws1[i,j])]
            cp1=[j for j in range(4020) if (cx[i,j]<cs1[i,j])]
            outfile1.write('%d %d %d %d \n'%(len(wp),len(cp),len(wp1),len(cp1)))
            outfile1.flush() 
    outfile.close()
    outfile1.close()



    nodes=np.loadtxt(path+'wsignodesp_ICET.dat')
    x=[]
    for i in range(480):
        print (i)
        n=0
        for j in nodes[:,0]:
            j=int(j)
            if(wx[i,j]>ws[i,j]):
                n+=1
        x.append(n)
        print (i,j,n)
            
            
            



def function3():
    wpx=np.loadtxt(path+'wsignodesp_60N.dat')
    cnx=np.loadtxt(path+'csignodesn_60N.dat')
    outfile=open(path+'wsignodesp_arctic_label.dat','w')
    for i in wpx[:,0]:
        outfile.write('%d \n'%(i))
        outfile.flush()
    outfile.close()
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in wpx[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=wpx[:,1]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('W',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(0.0,1.1), xycoords='axes fraction', fontsize=35 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in cnx[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
    
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=cnx[:,1]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('C',fontsize=34) #annual
    
    
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.1, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(25, 32)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_wpcn_arctic_75N.png") 
    
    
def plot_ICEICE():
    data=np.loadtxt(path+'degrees_ICEICE.dat')
    x=np.reshape(data[:,1],(40,12))
    ao=np.reshape(aoi,(40,12))
    px=[]
    for i in range(12):
        px.append(pearsonr(x[:,i],ao[:,i])[0])
        print (i,pearsonr(x[:,i],ao[:,i]))
    plt.plot(px,'o--')
        
        
def scattermap_global():
    data=Dataset('/home/meng/CLUSTER_DATA/orgindata/ERA5850/1990.nc','r',format='NETCDF4')
    lats=data.variables['latitude'][:]
    lons=data.variables['longitude'][:]
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_global.dat','w')
    nodes=0
    for i in range(0,73,1):
        lat=lats[i]
        #if(-40<lat<40):
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        y=np.arange(0,144,1*b)
        for j in y:
            lon=lons[j]
            n=i*144+j
            nodes+=1
            outfile.write('%d %.6f %.6f %d %d \n'%(n,lat,lon,i,j))
            outfile.flush()
    outfile.close()
    