#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Jan  3 12:20:51 2021

@author: meng
"""

from scipy import signal
import numpy as np
import matplotlib.pyplot as plt
from scipy.stats.stats import pearsonr
#from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from scipy import stats
import math

def logistic(x,mu):
	y = mu*x*(1.0-x)
	return y 
def chaost(n1,n2,x0,mu):
    x=x0
    z=np.linspace(0.0,1.0,n2-n1)
    for i in range(0,n1):
        x=logistic(x,mu)
    for i in range(n1,n2):
        x=logistic(x,mu)
        z[i-n1]=x
    return z
def autow(x,tau,l):
    z=[]
    for t in range(0,tau):
        x1=x[tau:l]
        x2=x[tau-t:l-t]
        r=pearsonr(x1,x2)[0]
        z.append(r)
        x1=x[tau-t:l-t]
        x2=x[tau:l]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return w
def autoc(x,tau,l):
    z=[]
    for t in range(-tau,0):
        x1=x[tau:l]
        x2=x[tau+t:l+t]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    for t in range(0,tau):
        x1=x[tau-t:l-t]
        x2=x[tau:l]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return z
# def fillit(n1,n2,x0,mu):
# 	 x = x0  # initial x value
#      z = np.linspace(0.0,1.0,n2-n1)  # create an array
# 	for i in range(0,n1):   # do n1 iterations
# 		x = logistic(x,mu)

# 	for i in range(0,n2-n1):   # fill n2-n1 iterations
# 		x = logistic(x,mu)
# 		z[i] = x
        
    
# 	return z  # returning the array
    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)
def circledis(lat1,lat2,lon1,lon2):
    r=6371#km
    lat1=lat1/180*np.pi
    lat2=lat2/180*np.pi
    lon1=lon1/180*np.pi
    lon2=lon2/180*np.pi
    xx=np.sin(lat1)*np.sin(lat2)+np.cos(lat1)*np.cos(lat2)*np.cos(np.abs(lon1-lon2))
    if(abs(xx)>1):
        xx=int(xx/abs(xx))
    a=np.arccos(xx)
    d=a*r
    return d

def cuteventh(x,cut):
    n=0
    i0=-123456789
    for i in range(len(x)):    
        if(x[i]>cut):
            if(i-i0>1):
                n+=1
            i0=i
    return n

def cuteventl(x,cut):
    n=0
    i0=-123456789
    for i in range(len(x)):    
        if(x[i]<cut):
            if(i-i0>1):
                n+=1
            i0=i
    return n

path='/home/meng/bupt_data'
#path='/dssg/home/mengjun/junfile/data'

regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
regrid1=np.loadtxt(path+'/data/seaice/regridcos2.5d.dat')
regrid2=np.loadtxt(path+'/data/seaice/nonzeroicenodes.dat')
#path="/home/meng/bupt_data/data/seaice/"
ao=np.loadtxt(path+'/data/seaice/AO.dat')
aoi=ao[:,2][360:840]  



    
def reload():
    path='/home/meng/bak_bupt/newproj/data/'
    tmp=np.loadtxt(path+'era5t8502.5d_ano_1979to2019.ano')       

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    regridi=np.loadtxt(path+'globe_726.dat')
    nodes=np.intersect1d(regridi[:,0],regrid[:,0])
    lists=list(regrid[:,0])
    indexs0=[lists.index(i) for i in nodes]
    lat1s=regrid[:,1][indexs]
    lon1s=regrid[:,2][indexs]
    lat2s=regrid[:,3][indexs]
    lon2s=regrid[:,4][indexs]
    x1=np.where(abs(regrid[:,1])>=60)[0]
    y=np.arange(0,len(x1),6)
    indexs1=x1[y]
    indexs=list(indexs0)+indexs1
    
    
    
    

    T=np.reshape(tmp,(8040,14965))
    outfile0=open(path+'globe_633_2011.dat','w')

    outfile=open(path+'globe_633_t850_2011.ano','w')
   
    nx=regrid[:,0]
    latx=regrid[:,1]
    lonx=regrid[:,2]
    latn=regrid[:,3]
    lonn=regrid[:,4]
    k1=16
    for kj in range(14965):
        outfile.write('%.6f \n'%(T[k1,kj]))
        outfile.flush()
    k2=5985
    for kj in range(14965):
        outfile.write('%.6f \n'%(T[k2,kj]))
        outfile.flush()   
    outfile0.write('%d %.1f %.1f %d %d \n'%(nx[k1],latx[k1],lonx[k1],latn[k1],lonn[k1]))
    outfile0.write('%d %.1f %.1f %d %d \n'%(nx[k2],latx[k2],lonx[k2],latn[k2],lonn[k2]))
    
    for i in indexs:
        i=int(i)
        outfile0.write('%d %.1f %.1f %d %d \n'%(nx[i],latx[i],lonx[i],latn[i],lonn[i]))

        for j in range(14965):
            outfile.write('%.6f \n'%(T[i,j]))
            outfile.flush()
 
    outfile.close()
    outfile0.close()
    
    
    regrida=np.loadtxt(path+'globe_726_new.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    outfile=open(path+'globe_732.dat','w')
    nx=[44,5337,16,5985,43,3983]
    for n1 in nx:
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            outfile.write('%.1f %.1f %d %d \n'%(lati,lona,i,j))
            outfile.flush()
    for i in range(726):
            outfile.write('%.1f %.1f %d %d \n'%(regrida[:,1][i],regrida[:,2][i],regrida[:,3][i],regrida[:,4][i]))
            outfile.flush()    
    outfile.close()

    nodes=np.loadtxt(path+'globe_732.dat')
    outfile=open(path+'TT_links_30d_tau10_distance.dat','w')
    for i in range(731):
        for j in range(i+1,732):
            lat1=nodes[:,0][i]
            lon1=nodes[:,1][i]
            lat2=nodes[:,0][j]
            lon2=nodes[:,1][j]
            dis=circledis(lat1,lat2,lon1,lon2)
            if(math.isnan(dis) is True):
                print (i,j,lat1,lat2,lon1,lon2)
            outfile.write('%.6f \n'%(dis))
            outfile.flush()
    outfile.close()
    
    
    
    
    data=np.loadtxt(path+'2011_9_TT_links_30d_tau10_distance.dat')
    data1=np.loadtxt(path+'2019_3_TT_links_30d_tau10.dat')

    



def calculate_psd():
    path='/home/meng/bak_bupt/newproj/data/'
    tmp=np.loadtxt(path+'era5t8502.5g_ano_1979to2019.ano')   


    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(8040,14965))

    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid1=np.loadtxt(path+'/data/seaice/regridcos2.5d.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    regrid1=np.loadtxt(path+'globe_726.dat')
    
    nodes1=regrid1[:,0]
    nodes2=regrid2[:,0]
    z=np.intersect1d(nodes1, nodes2)
    
    outfile=open(path+'era5t850_nonzeroicenodes.ano','w')
    for i in regrid2[:,0]:
        n=list(regrid[:,0]).index(i)
        n=int(n)
        for k in range(14965):
            outfile.write('%.6f \n'%(T[n][k]))
            outfile.flush()
    outfile.close()

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'/data/seaice/psd_3d_t850.dat','w')
    for node in range(8040):
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                #f, Pxx_den = signal.welch(x, fs, nperseg=m)
                #print (sum(Pxx_den))
                x,y=pdswelch(dataV,fs)
                ii=int(list(x).index(6))
                jj=sum(y[ii:])
                outfile.write('%.6f \n'%(jj))
                outfile.flush()
    outfile.close()
 
    
def calculate_psdsum():
    path='/dssg/home/mengjun/junfile/data'
    tmp=np.loadtxt(path+'/origin/seaice/era5t8502.5g_ano_1979to2019.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(8040,14965))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'/data/seaice/psd_sum_t850.dat','w')
    for node in range(8040):
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                #f, Pxx_den = signal.welch(x, fs, nperseg=m)
                #print (sum(Pxx_den))
                x,y=pdswelch(dataV,fs)
                z=sum(x*y)
                
             
                outfile.write('%.6f \n'%(z))
                outfile.flush()
    outfile.close() 
    
 
def calculate_psdsum_ICE():
    path='/dssg/home/mengjun/junfile/data'
    tmpI=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019_nonzero.ano')   
    path='/home/meng/bak_bupt/newproj/data/'
    tmpI=np.loadtxt(path+'era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmpI,(377,14965))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'/data/seaice/psd_sum_ICE.dat','w')
    for node in range(377):
        #print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                #f, Pxx_den = signal.welch(x, fs, nperseg=m)
                #print (sum(Pxx_den))
                x,y=pdswelch(dataV,fs)
                z=sum(x*y)
               # psdx.append(z)
                
                if(math.isnan(z) is True):
                    print (node,year,month,z)
                    
                outfile.write('%.6f \n'%(z))
                outfile.flush()
    outfile.close()     
 


def calculate_psdsum_726():
    path='/home/meng/bak_bupt/newproj/data/'
    tmp=np.loadtxt(path+'era5t85075d_ano_1979to2019_g_new_726.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(726,15695))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'psd_sum_t850_726.dat','w')
    for node in range(726):
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                #f, Pxx_den = signal.welch(x, fs, nperseg=m)
                #print (sum(Pxx_den))
                x,y=pdswelch(dataV,fs)
                z=sum(x*y)
                
                ii=int(list(x).index(6))
                jj=sum(y[ii:])
                outfile.write('%.6f \n'%(z))
                outfile.flush()
    outfile.close()     
    
    outfile=open(path+'psd_sum_t850_726_detrend.dat','w')
    data=np.loadtxt(path+'psd_sum_t850_726.dat')
    x=np.reshape(data,(726,480))
    for i in range(726):
        y=x[i]
        z=signal.detrend(y)
        for j in range(480):
            outfile.write('%.6f \n'%(z[j]))
            outfile.flush()
    outfile.close()
def calculate_mt():
    path='/dssg/home/mengjun/junfile/data'
    path='/home/meng/bak_bupt/newproj/data/'
    tmp=np.loadtxt(path+'era5t8502.5g_ano_1979to2019.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(8040,14965))
    l1=int(14965*0.95)
    l2=int(14965*0.05)
    

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'mt850.dat','w')
    for node in range(8040):
        cuth=np.sort(T[node])[l1]
        cutl=np.sort(T[node])[l2]
        cuth1=np.std(T[node])+np.mean(T[node])
        cutl1=np.mean(T[node])-np.std(T[node])
        cuth2=3*np.std(T[node])+np.mean(T[node])
        cutl2=3*np.mean(T[node])-np.std(T[node])
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                nh=cuteventh(dataV, cuth)
                nl=cuteventl(dataV, cutl)
                nh1=cuteventh(dataV,cuth1)
                nl1=cuteventl(dataV,cutl1)
                nh2=cuteventh(dataV,cuth2)
                nl2=cuteventl(dataV,cutl2)
                xx=np.where(dataV>cuth1)[0]
                yy=np.where(dataV<cutl1)[0]
                nh3=len(xx)
                nl3=len(yy)
                std=np.std(dataV)
                mt=np.mean(dataV)
                outfile.write('%.6f %.6f %d %d %d %d %d %d %d %d\n'%(mt,std,nh,nl,nh1,nl1,nh2,nl2,nh3,nl3))
                outfile.flush()
    outfile.close()


def calculate_mtdiff():
    path='/home/meng/bak_bupt/newproj/data/'

    tmp=np.loadtxt(path+'t2m_ano_377.ano')
    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,364]
    months=[31,28,31,30,31,30,31,31,30,31,30,30]
    lenth=15695#ano
    #lenth=15652#diff
    T=np.reshape(tmp,(377,lenth))
    l1=int(lenth*0.95)
    l2=int(lenth*0.05)
    
    
    

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'t2m_arctic.dat','w')
    for node in range(377):
        cuth=np.sort(T[node])[l1]
        cutl=np.sort(T[node])[l2]
        cuth1=np.std(T[node])+np.mean(T[node])
        cutl1=np.mean(T[node])-np.std(T[node])
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                nh=cuteventh(dataV, cuth)
                nl=cuteventl(dataV, cutl)
                nh1=cuteventh(dataV,cuth1)
                nl1=cuteventl(dataV,cutl1)
                xx=np.where(dataV>cuth1)[0]
                yy=np.where(dataV<cutl1)[0]
                nh2=len(xx)
                nl2=len(yy)
                std=np.std(dataV)
                mt=np.mean(dataV)
                outfile.write('%.6f %.6f %d %d %d %d %d %d \n'%(mt,std,nh,nl,nh1,nl1,nh2,nl2))
                outfile.flush()
    outfile.close()

    data=np.loadtxt(path+'mt850_arctic.dat')
    index=0
    x=np.reshape(data[:,index],(377,480))
    y=[np.mean(x[:,i]) for i in range(480)]
    z=np.reshape(y,(40,12))
    u=[np.mean(z[i]) for i in range(40)]
    ys=np.arange(40)+1980
    plt.plot(ys,u)
    

    
def example():
   path='/home/meng/bupt_data/'
   nodes=np.loadtxt(path+'/data/seaice/selectnodes_6dohigh_60N.dat')
   #nodes=np.loadtxt(path+'/data/seaice/psd_signodesp_label.dat')
   for node in nodes:
    node=int(node)
    highx=list(aoi).index(max(aoi))
    lowx=list(aoi).index(min(aoi))
    yh=highx/12+1980
    mh=highx%12
    yl=lowx/12+1980
    ml=lowx%12
    sh1=365*(yh-1979)+monthds[mh-1]
    sh2=sh1+months[mh-1]
    sl1=365*(yl-1979)+monthds[ml-1]
    sl2=sl1+months[ml-1]
    sh1=int(sh1)
    sh2=int(sh2)
    sl1=int(sl1)
    sl2=int(sl2)
    data1=T[node][sh1:sh2]
    data2=T[node][sl1:sl2]

    fs=18
    xtick=[1,2,3,6,9]
    label=['1/18d','1/9d','1/6d','1/3d','1/2d']
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # label=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']  

    x1,y1=pdswelch(data1,fs)
    x2,y2=pdswelch(data2,fs)

        
    # for i in range(len(x1)):
    #     if(y1[i]>y2[i]):
    #         plt.scatter(x1[i],y1[i],color='r')
    #     else:
    #         plt.scatter(x2[i],y2[i],color='b')
    ax1=plt.subplot(121)
    plt.ylim(0,0.55)
    plt.plot(x1,y1,'r-',label='199301')
    plt.title('199301,AO=3.50',fontsize=18)
    plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
    plt.yticks(fontsize=18)
    plt.ylabel('PSD',fontsize=18)
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    ax2=plt.subplot(122)
    plt.ylim(0,0.55)
    plt.plot(x2,y2,'b-',label='201012')
    plt.title('201012,AO=-4.27',fontsize=18)
    #plt.legend(fontsize=21)
    plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
    plt.yticks(fontsize=18)
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.2)   
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(12, 4)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/pds_example_244nodes60N_60dohigh.png")   
    
    
    
    
def autocorr_ice():
    #path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
    outfile=open(path+'autocorr_abs_ice.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+""+str(year)+"_"+str(month)+"_ICE_autocorr_abs.dat")
            
            w=data
            #c=data[:,1]
            
            for i in range(377):
                if(math.isnan(w[i]) is True):
                    a=-10000000000
                else:
                    a=w[i]
                outfile.write('%.6f \n'%(a))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()


def function_autocorr():
    #path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
    #wx=np.zeros(shape=(480,8040))
    #cx=np.zeros(shape=(480,8040))
    outfile=open(path+'autocorr_abs.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+""+str(year)+"_"+str(month)+"_TT_autocorr_abs.dat")
            
            w=data
            #c=data[:,1]
           
            for i in range(8040):
                outfile.write('%.6f \n'%(w[i]))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()

    outfile=open(path+'autocorr10512.dat','w')
    n=0
    for year in range(1980,2020):
        print (year)
        for month in range(1,13):
            print (month)
            year=int(year)
            month=int(month)
            data=np.loadtxt(path+"testtau/"+str(year)+"_"+str(month)+"_TT_autocorr10512.dat")
            
            w=data
            #c=data[:,1]
           
            for i in range(10512):
                outfile.write('%.6f \n'%(w[i]))
                outfile.flush()
     #       wx[n]=w
     #       cx[n]=c
     #       n+=1        
    outfile.close()

    data=np.loadtxt(path+'autocorr.dat')
    outfile=open(path+"autocorr_signodesp_signodes_Tabsao.dat",'w')
    outfile1=open(path+"autocorr_signodesn_signodesabsao_T.dat",'w')
    psdx=np.reshape(data,(480,8040))    
    outfile2=open(path+'autocorr_absAO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i]
            y=abs(aoi)
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()  
    
    data=np.loadtxt(path+'degrees_ICET.dat')
    data1=np.loadtxt(path+'degrees_ICET_neg.dat')
    outfile=open(path+"degrees_signodesp_signodes_ICETao.dat",'w')
    outfile1=open(path+"degrees_signodesn_signodes_ICETao.dat",'w')
#    absdegree=[max(abs(data[:,0][i]),abs(data1[:,0][i])) for i in range(len(data))]
    
    psdx=np.reshape(data1[:,0],(480,8040))    
    outfile2=open(path+'degrees_AO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i]
            y=aoi
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()      
    
    data1=np.loadtxt(path+'degrees_AO_T.dat')
    data2=np.loadtxt(path+'degrees_AO_T_neg.dat')
    outfile=open(path+'degrees_AO_T_max.dat','w')
    for i in range(8040):
        x1=data1[:,0][i]
        x2=data2[:,0][i]
        y1=data1[:,1][i]
        y2=data2[:,1][i]
        x3=0
        y3=0
        if(abs(x1)>abs(x2)):
            x3=x1
            y3=y1
        else:
            x3=-x2
            y3=y2
        
        outfile.write('%.6f %.6f \n'%(x3,y3))
        outfile.flush()
    outfile.close()

def corr_AO_ALL():
    absaoi=abs(aoi)
    xx=np.sort(absaoi)
    yy=xx[456]
    indexs=[int(i) for i in range(480) if(absaoi[i]>=yy)]
    
    datad=np.loadtxt(path+'psd_sum_t850.dat')
    outfile=open(path+"psd_signodesp_sum_signodes_t850highao.dat",'w')
    outfile1=open(path+"psd_signodesn_sum_signodes_t850highao.dat",'w')
    psdx=np.reshape(datad,(8040,480))    
    outfile2=open(path+'psd_sum_t850_highAO.dat','w')
    
    
    for i in range(8040):
            x=psdx[i][indexs]
            y=abs(aoi)[indexs]   
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()    
    
    
    
    data=np.loadtxt(path+'autocorr.dat')
    outfile=open(path+"autocorr_signodesp_signodes_Thighao.dat",'w')
    outfile1=open(path+"autocorr_signodesn_signodeshighao_T.dat",'w')
    psdx=np.reshape(data,(480,8040))    
    outfile2=open(path+'autocorr_highAO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i][indexs]
            y=abs(aoi)[indexs]
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()  
    
    data=np.loadtxt(path+'degrees_ICET.dat')
    data1=np.loadtxt(path+'degrees_ICET_neg.dat')
    outfile=open(path+"degrees_signodesp_signodes_ICEThighao.dat",'w')
    outfile1=open(path+"degrees_signodesn_signodes_ICEThighao.dat",'w')
    psdx=np.reshape(data[:,0],(480,8040))    
    outfile2=open(path+'degrees_highAO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i][indexs]
            y=abs(aoi)[indexs]
    
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()      
    

    data1=np.loadtxt(path+'degrees_highAO_T.dat')
    data2=np.loadtxt(path+'degrees_highAO_T_neg.dat')
    outfile=open(path+'degrees_highAO_T_max.dat','w')
    for i in range(8040):
        x1=data1[:,0][i]
        x2=data2[:,0][i]
        y1=data1[:,1][i]
        y2=data2[:,1][i]
        x3=0
        y3=0
        if(abs(x1)>abs(x2)):
            x3=x1
            y3=y1
        else:
            x3=-x2
            y3=y2
        
        outfile.write('%.6f %.6f \n'%(x3,y3))
        outfile.flush()
    outfile.close()
    
def corr_AO_ALL_mon():
    absaoi=abs(aoi)
    xx=np.sort(absaoi)
    yy=xx[456]
    indexs=[int(i) for i in range(480) if(absaoi[i]>=yy)]
    
    datad=np.loadtxt(path+'psd_sum_t850.dat')
    outfile=open(path+"psd_signodesp_sum_signodes_t850highao.dat",'w')
    outfile1=open(path+"psd_signodesn_sum_signodes_t850highao.dat",'w')
    psdx=np.reshape(datad,(8040,480))    
    outfile2=open(path+'psd_sum_t850_highAO.dat','w')
    
    
    for i in range(8040):
            x=psdx[i][indexs]
            y=abs(aoi)[indexs]   
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()    
    
    
    
    data=np.loadtxt(path+'autocorr.dat')
    outfile=open(path+"autocorr_signodesp_signodes_Thighao.dat",'w')
    outfile1=open(path+"autocorr_signodesn_signodeshighao_T.dat",'w')
    psdx=np.reshape(data,(480,8040))    
    outfile2=open(path+'autocorr_highAO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i][indexs]
            y=abs(aoi)[indexs]
            
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()  
    
    data=np.loadtxt(path+'degrees_ICET.dat')
    data1=np.loadtxt(path+'degrees_ICET_neg.dat')
    outfile=open(path+"degrees_signodesp_signodes_ICEThighao.dat",'w')
    outfile1=open(path+"degrees_signodesn_signodes_ICEThighao.dat",'w')
    psdx=np.reshape(data[:,0],(480,8040))    
    outfile2=open(path+'degrees_highAO_T.dat','w')
    for i in range(8040):
            x=psdx[:,i][indexs]
            y=abs(aoi)[indexs]
    
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()      
    

    data1=np.loadtxt(path+'degrees_highAO_T.dat')
    data2=np.loadtxt(path+'degrees_highAO_T_neg.dat')
    outfile=open(path+'degrees_highAO_T_max.dat','w')
    for i in range(8040):
        x1=data1[:,0][i]
        x2=data2[:,0][i]
        y1=data1[:,1][i]
        y2=data2[:,1][i]
        x3=0
        y3=0
        if(abs(x1)>abs(x2)):
            x3=x1
            y3=y1
        else:
            x3=-x2
            y3=y2
        
        outfile.write('%.6f %.6f \n'%(x3,y3))
        outfile.flush()
    outfile.close()    
    
def calculate_psd_run():
    path='/dssg/home/mengjun/junfile/data'
    tmp=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(377,14965))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    #xtick=[1,2,3]
    #fs=24
    #xtick=[1,2,3,4,6,8,12]
    # xtick=[4,6,8,12]
    #xtick=[1,2,3,4]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']  
    for i in xtick:
        dd=int(fs/i)
        print (dd)
        
        outfile=open(path+"/data/seaice/ice_psd_"+str(dd)+"do_t850.dat",'w')
        for node in range(377):
            #print (dd,node)
            #r=np.std(T[node])*0.2
            for year in range(1980,2020):
                for month in range(1,13):
                    s1=365*(year-1979)+monthds[month-1]
                    s2=s1+months[month-1]  
                   # for nodes in range(8040):
                    dataV=T[node][s1:s2]

                    x,y=pdswelch(dataV,fs)
                    ii=int(list(x).index(i))
                    jj=sum(y[ii:])#do_high
                    jj=y[ii]#do
                    if(abs(jj)>=0):
                        jj=jj
                    else:
                        jj=-1000
                   # jj=y[ii]
                    outfile.write('%.6f \n'%(jj))
                    outfile.flush()
        outfile.close()
               
#calculate_psd_run()
def plot_anual_psdtoao():       
    datad=np.loadtxt(path+'psd_6do_high_t850.dat')
    psdx=np.reshape(datad,(8040,480))
    ao=np.reshape(aoi,(40,12))
    aoy=[np.mean(ao[:,i]) for i in range(12)]
    outfile=open(path+'PSD_6dohigh_t850_annualcycletoao.dat','w')
    for i in range(8040):
        x=psdx[i]
        x=np.reshape(x,(40,12))
        y=[np.mean(x[:,i]) for i in range(12)]
        r=pearsonr(aoy,y)[0]
        p=pearsonr(aoy,y)[1]
        if(r>0 and p<0.05):
            print (i,r,p)
            outfile.write('%d %.6f %.6f \n'%(i,r,p))
            outfile.flush()
    outfile.close()

    data=np.loadtxt(path+'PSD_6dohigh_t850_annualcycletoao.dat')    
    nodes=[int(i) for i in data[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,50,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
   # plt.title('W negative',fontsize=34) #annual
    
    
           
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(20, 10)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_psd6dohigh_T_ao_anualcycle.png") 
        
def psdtoao():  
    path='/home/meng/bupt_data/data/seaice/'     
    datad=np.loadtxt(path+'psd_sum_ICE.dat')
    psdx=np.reshape(datad,(8040,480))    
    for mon in range(12):
        outfile=open(path+"psd_signodesp_sum_signodes_"+str(mon)+".dat",'w')
        outfile1=open(path+"psd_signodesn_sum_signodes_"+str(mon)+".dat",'w')

        for i in range(8040):
            x=psdx[i]
            y=aoi
            x1=np.reshape(x,(40,12))
            y1=np.reshape(y,(40,12))
            x2=x1[:,mon]
            y2=y1[:,mon]
            r=pearsonr(x2,y2)[0]
            p=pearsonr(x2,y2)[1]
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
        outfile.close()
        outfile1.close()
        
    outfile=open(path+"psd_signodesp_sum_signodes_ICE.dat",'w')
    outfile1=open(path+"psd_signodesn_sum_signodes_ICE.dat",'w')
    psdx=np.reshape(datad,(377,480))    
    outfile2=open(path+'psd_sum_ICET_validnodes.dat','w')
    for i in range(377):
            x=psdx[i]
            y=aoi
            if(sum(x)>0):
                outfile2.write('%d \n'%(i))
                outfile2.flush()
                r=pearsonr(x,y)[0]
                p=pearsonr(x,y)[1]
                if(r>0 and p<0.05):
                    outfile.write('%d %.6f %.6f \n'%(i,r,p))
                    outfile.flush()
                if(r<0 and p<0.05):
                    outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                    outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()  
    
    datad=np.loadtxt(path+'psd_sum_t850.dat')
    outfile=open(path+"psd_signodesp_sum_signodes_t850absao.dat",'w')
    outfile1=open(path+"psd_signodesn_sum_signodes_t850absao.dat",'w')
    psdx=np.reshape(datad,(8040,480))    
    outfile2=open(path+'psd_sum_t850_absAO.dat','w')
    for i in range(8040):
            x=psdx[i]
            y=abs(aoi)          
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            outfile2.write('%.6f %.6f \n'%(r,p))
            outfile2.flush()
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
            if(r<0 and p<0.05):
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()        
    outfile.close()
    outfile1.close()    
    outfile2.close()       
    
def plot_map_sig_psdsum_ao():
    path='/home/meng/bupt_data/data/seaice/'
    data1=np.loadtxt(path+'psd_signodesp_sum_signodes.dat')
    data2=np.loadtxt(path+'psd_signodesn_sum_signodes.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in data1[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data1[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    #plt.title('Positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in data2[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data2[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    #plt.title('Negative',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/850T_psdsum_AO.png")     
        


def plot_map_sig_psdsum_ao_ICE():
    path='/home/meng/bupt_data/data/seaice/'
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    data1=np.loadtxt(path+'psd_signodesp_sum_signodes_ICE.dat')
    data2=np.loadtxt(path+'psd_signodesn_sum_signodes_ICE.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in data1[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=24,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,30.),labels=[False,False,False,True],fontsize=24,linewidth=3)
    m.drawmapboundary(fill_color='w')
         
    lats1=np.array(regrid2[:,1][nodes])
    lons1=np.array(regrid2[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data1[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    #plt.title('Positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in data2[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=24,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,30.),labels=[False,False,False,True],fontsize=24,linewidth=3)
    m.drawmapboundary(fill_color='w')
           
    lats1=np.array(regrid2[:,1][nodes])
    lons1=np.array(regrid2[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data2[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    #plt.title('Negative',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/ICE_psdsum_AO.png")     

def psdtoao_run():   
    fs=24
    xtick=[1,2,3,4,6,8,12]
    labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d'] 
    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    path='/home/meng/bupt_data'
    N=377
    for i in xtick:
        dd=int(fs/i)
        print (dd)
        datad=np.loadtxt(path+"/data/seaice/ice_psd_"+str(dd)+"do_t850.dat")
        psdx=np.reshape(datad,(N,480))
        outfile=open(path+"/data/seaice/ice_psd_signodesp_"+str(dd)+"do.dat",'w')
        outfile1=open(path+"/data/seaice/ice_psd_signodesn_"+str(dd)+"do.dat",'w')

        wp=0
        wn=0
        for i in range(N):
            x=psdx[i]
            y=aoi
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
                wp+=1
            if(r<0 and p<0.05):
                wn+=1
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()
        print (wp,wn)
            
        outfile.close()
        outfile1.close()


def calculate_ice_psd_AO_run():
    path='/dssg/home/mengjun/junfile/data'
    tmp=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(377,14965))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']

    #xtick=[1,2,3]
    #fs=24
    #xtick=[1,2,3,4,6,8,12]
    # xtick=[4,6,8,12]
    #xtick=[1,2,3,4]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d'] 

        
        
    n=int(fs/2)
    posX=np.zeros(n)
    
    negX=np.zeros(n)
    for node in range(377):
            print (node)
            degreeX=[]
            for year in range(1980,2020):
                for month in range(1,13):
                    s1=365*(year-1979)+monthds[month-1]
                    s2=s1+months[month-1]  
                   # for nodes in range(8040):
                    dataV=T[node][s1:s2]

                    x,y=pdswelch(dataV,fs)
                    
                    for i in range(1,n+1):
                        if(y[i]==y[i]):
                            degreeX.append(y[i])
                        else:
                            degreeX.append(-1000)
            degreex=np.reshape(degreeX,(480,n))
            for i in range(n):
                listx=[int(j) for j in range(480) if(abs(degreex[:,i][j])>=0)]
                xx=np.array(degreex[:,i])
                aoi=np.array(aoi)
                c=pearsonr(xx[listx],aoi[listx])[0]
                p=pearsonr(xx[listx],aoi[listx])[1]
                if(p<0.05 and c>=0):
                    posX[i]+=1
                if(p<0.05 and c<=0):
                    negX[i]+=1
            
                    
    outfile=open(path+"ice_psd_ao_corsignum_"+str(fs)+".dat",'w')
    for i in range(n):
        dd=fs/(i+1.)
        outfile.write('%d %d %d %.6f \n'%(i,posX[i],negX[i],dd))
        outfile.flush()
    outfile.close()                   
                   

def calculate_psd_AO_run():
    path='/dssg/home/mengjun/junfile/data'
    ao=np.loadtxt(path+'/data/seaice/AO.dat')
    aoi=ao[:,2][360:840]    
    path='/home/meng/bupt_data'
    tmp=np.loadtxt(path+'/origin/seaice/era5t8502.5g_ano_1979to2019.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(8040,14965))

    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']

    #xtick=[1,2,3]
    #fs=24
    #xtick=[1,2,3,4,6,8,12]
    # xtick=[4,6,8,12]
    #xtick=[1,2,3,4]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d'] 

        
        
    n=int(fs/2)
    posXS=np.zeros(n)
    posXN=np.zeros(n)
    negXS=np.zeros(n)
    negXN=np.zeros(n)
    for node in range(377):
            print (node)
            degreeX=[]
            for year in range(1980,2020):
                for month in range(1,13):
                    s1=365*(year-1979)+monthds[month-1]
                    s2=s1+months[month-1]  
                   # for nodes in range(8040):
                    dataV=T[node][s1:s2]

                    x,y=pdswelch(dataV,fs)
                    
                    for i in range(1,n+1):
                        if(y[i]==y[i]):
                            degreeX.append(y[i])
                        else:
                            degreeX.append(-1000)
            degreex=np.reshape(degreeX,(480,n))
            for i in range(n):
                listx=[int(j) for j in range(480) if(abs(degreex[:,i][j])>=0)]
                xx=np.array(degreex[:,i])
                aoi=np.array(aoi)
                c=pearsonr(xx[listx],aoi[listx])[0]
                p=pearsonr(xx[listx],aoi[listx])[1]
                if(p<0.05 and c>=0 and node<4020):
                    posXN[i]+=1
                if(p<0.05 and c>=0 and node>=4020):
                    posXS[i]+=1                
                if(p<0.05 and c<=0 and node<4020):
                    negXN[i]+=1
                if(p<0.05 and c<=0 and node>=4020):
                    negXS[i]+=1            
    path='/home/meng/bupt_data/data/seaice/'           
    outfile=open(path+"ice_psd_ao_corsignum_"+str(fs)+".dat",'w')
    for i in range(n):
        dd=fs/(i+1.)
        outfile.write('%d %d %d %d %d %.6f \n'%(i,posXS[i],negXS[i],posXN[i],negXN[i],dd))
        outfile.flush()
    outfile.close()                   





def plot_signum_psd_AO_fs18():
    path='/home/meng/bupt_data'   
    tmp=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(377,14965))
    
    nodes=np.loadtxt(path+'/data/seaice/ice_psd_signodesp_6do_high.dat')
    nodes=[int(i) for i in nodes[:,0]]
    data=np.loadtxt(path+'/data/seaice/corrAO_psdsum_ice.dat')
    nodes=[data[:,0][i] for i in range(len(data)) if(data[:,2][i]<0.05)]
    cmap = plt.get_cmap('Blues')
    cmap1 = plt.get_cmap('Reds')
    N = len(nodes)
    for i, n in enumerate(np.linspace(2.0, 0, N)):
    #y = np.sin(x)*x**n
        color = cmap(float(i)/N)
        color1 = cmap1(float(i)/N)

        node=int(nodes[i])
        highx=list(aoi).index(max(aoi))
        lowx=list(aoi).index(min(aoi))
        yh=highx/12+1980
        mh=highx%12
        yl=lowx/12+1980
        ml=lowx%12
        sh1=365*(yh-1979)+monthds[mh-1]
        sh2=sh1+months[mh-1]
        sl1=365*(yl-1979)+monthds[ml-1]
        sl2=sl1+months[ml-1]
        sh1=int(sh1)
        sh2=int(sh2)
        sl1=int(sl1)
        sl2=int(sl2)
        data1=T[node][sh1:sh2]
        data2=T[node][sl1:sl2]
    
        fs=18
        xtick=[1,2,3,6,9]
        label=['1/18d','1/9d','1/6d','1/3d','1/2d']
        # fs=24
        # xtick=[1,2,3,4,6,8,12]
        # label=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']  
    
        x1,y1=pdswelch(data1,fs)
        x2,y2=pdswelch(data2,fs)
    
            
        # for i in range(len(x1)):
        #     if(y1[i]>y2[i]):
        #         plt.scatter(x1[i],y1[i],color='r')
        #     else:
        #         plt.scatter(x2[i],y2[i],color='b')
        ax1=plt.subplot(221)
        plt.ylim(0,0.8)
        plt.plot(x1,y1,'-',c=color,label='199301')
        if(i==1):
            plt.title('199301,AO=3.50',fontsize=18)
            plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
            plt.yticks(fontsize=18)
            plt.ylabel('PSD',fontsize=18)
            plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                                 xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                                 ha='left', va='bottom')    
        ax2=plt.subplot(222)
        plt.ylim(0,0.8)
        plt.plot(x2,y2,'-',c=color1,label='201012')
        if(i==1):
            plt.title('201012,AO=-4.27',fontsize=18)
            plt.ylabel('PSD',fontsize=18)
    
            #plt.legend(fontsize=21)
            plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
            plt.yticks(fontsize=18)
            plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                                 xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                                 ha='left', va='bottom')        
  
    
    
    
    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    ax3=plt.subplot(223)
    data=np.loadtxt(path+"/data/seaice/ice_psd_ao_corsignum_"+str(fs)+".dat")
    plt.plot(data[:,0],data[:,3],'o-',color='r',label='Positive (Southern nodes)')
    plt.plot(data[:,0],data[:,4],'o-',color='b',label='Negative (Southern nodes)')    
    plt.plot(data[:,0],data[:,1],'x--',color='pink',label='Positive (Northern nodes)')
    plt.plot(data[:,0],data[:,2],'x--',color='lightblue',label='Negative (Northern nodes)')    
   # plt.legend(fontsize=21)
    plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
    plt.yticks(fontsize=18)
    plt.ylabel('Number of significant nodes',fontsize=18)
    plt.title('ICE',fontsize=21)
    plt.annotate('(c)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    ax4=plt.subplot(224)
    data=np.loadtxt(path+"/data/seaice/psd_ao_corsignum_"+str(fs)+".dat")
    plt.plot(data[:,0],data[:,3],'o-',color='r',label='Positive (Southern nodes)')
    plt.plot(data[:,0],data[:,4],'o-',color='b',label='Negative (Southern nodes)')    
    plt.plot(data[:,0],data[:,1],'x--',color='pink',label='Positive (Northern nodes)')
    plt.plot(data[:,0],data[:,2],'x--',color='lightblue',label='Negative (Northern nodes)')    
    plt.legend(fontsize=18,bbox_to_anchor=(0.65, 0.75))
    plt.xticks(xtick,labels=label,fontsize=18,rotation=-45)
    plt.yticks(fontsize=18)
    plt.ylabel('Number of significant nodes',fontsize=18)
    plt.title('T',fontsize=18)
    plt.annotate('(d)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=20 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    plt.subplots_adjust(top = 0.95, bottom = 0.1, right = 0.9, left = 0.05, 
                hspace = 0.2, wspace = 0.2)   
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(20, 14)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/pds_example_AND_signodes_frequency.png")                    
#calculate_psd_AO_run()
def psdtonao_run1():   
    path="/home/meng/bupt_data"
    ao=np.loadtxt(path+'/data/seaice/AO.dat')
    aoi=ao[:,2][360:840]
    nao=np.loadtxt(path+'/data/seaice/NAO.dat')
    naoi=nao[:,2][360:840]
    fs=24
    xtick=[1,2,3,4,6,8,12]
    labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d'] 
    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    path='/home/meng/bupt_data'
    for i in xtick:
        dd=int(fs/i)
        print (dd)
        datad=np.loadtxt(path+"/data/seaice/psd_"+str(dd)+"do_high_t850.dat")
        psdx=np.reshape(datad,(8040,480))
        outfile=open(path+"/data/seaice/psd_signodesp_"+str(dd)+"do_high_AO.dat",'w')
        outfile1=open(path+"/data/seaice/psd_signodesn_"+str(dd)+"do_high_AO.dat",'w')

        wp=0
        wn=0
        for i in range(8040):
            x=psdx[i]
            y=aoi
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()
                wp+=1
            if(r<0 and p<0.05):
                wn+=1
                outfile1.write('%d %.6f %.6f \n'%(i,r,p))
                outfile1.flush()
        print (wp,wn)
            
        outfile.close()
        outfile1.close()



def psdtoao_6do_trend():      
    path='/home/meng/bupt_data'
    datad=np.loadtxt(path+'/data/seaice/psd_6do_high_t850.dat')
    ao=np.loadtxt(path+'/data/seaice/AO.dat')
    aoi=ao[:,2][360:840]

    nao=np.loadtxt(path+'/data/seaice/NAO.dat')
    naoi=nao[:,2][360:840]
    psdx=np.reshape(datad,(8040,480))
    outfile=open(path+'/data/seaice/trend_6do_high.dat','w')
    for i in range(8040):
        x=np.arange(480)
        y=psdx[i]
        slope, intercept, r, p, se =  stats.linregress(x, y)
        if(p<0.05):
            outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,slope, intercept, r, p, se))
            outfile.flush()
    outfile.close()
    
    data=np.loadtxt(path+'/data/seaice/trend_6do_high.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in data[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='slope_speed', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    #plt.title('Positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in data[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,3]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='r-value', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    #plt.title('Negative',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/strend_6do_high.png") 





    
    M=np.reshape(naoi,(40,12))
    outfile=open(path+'/data/seaice/psd_signodesp_num_shuffle_nao.dat','w')

    for st in range(100):
        y=[]
        for i in range(40):
            j=np.random.choice(40)
            y+=list(M[j])
        Np=0
        Nn=0
        Nps=0
        Nns=0
        for i in range(8040):
            x=psdx[i]
            #y=aoi
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            if(r>0 and p<0.05):
                Np+=1
                if(i>=4020):
                    Nps+=1
            if(r<0 and p<0.05):
                Nn+=1
                if(i>=4020):
                    Nns+=1
        print (Np,Nn,Nps,Nns)
        outfile.write('%d %d %d %d \n'%(Np,Nn,Nps,Nns))
        outfile.flush()
    outfile.close()
    
    
    
    y=aoi
    Np=0
    Nn=0
    Nps=0
    Nns=0
    for i in range(8040):
        x=psdx[i]
        #y=aoi
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        if(r>0 and p<0.05):
            Np+=1
            if(i>=4020):
                Nps+=1
        if(r<0 and p<0.05):
            Nn+=1
            if(i>=4020):
                Nns+=1
    print (Np,Nn,Nps,Nns)    
        
    data=np.loadtxt(path+'/data/seaice/psd_signodesp_num_shuffle.dat')
    x=np.sort(data[:,2])
    print (x[95])
    sns.displot(data[:,2], bins=50, kde=True,color='b') 

def plot_map_sig_psdsum_ao():
    path='/home/meng/bupt_data/data/seaice/'
    data1=np.loadtxt(path+'psd_signodesp_sum_signodes.dat')
    data2=np.loadtxt(path+'psd_signodesn_sum_signodes.dat')
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in data1[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data1[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    #plt.title('Positive',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in data2[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data2[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    #plt.title('Negative',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.01)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(27, 27)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/850T_psdsum_AO.png") 


def plot_PSD_AO_sig_ICE_T():
    path='/home/meng/bupt_data/data/seaice/'
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')

    sigp=np.loadtxt(path+'ice_psd_signodesp_6do_high.dat')
    sign=np.loadtxt(path+'psd_signodesp_6do_high.dat')
    
    plt.subplot(121)
    ax=plt.plot()
    nodes=[int(i) for i in sigp[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
             
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sigp[:,1]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('ICE',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.0), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(122)
    ax=plt.plot()
    nodes=[int(i) for i in sign[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sign[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('T',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.0), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.05, right = 0.95, left = 0.0, 
                hspace = 0.01, wspace = 0.21)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(49, 11)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_psd_6do_high_AO_ICE_T.png") 
    
    




def plot_PSD_AO_sig_ICE_T_mon():
    path='/home/meng/bupt_data/data/seaice/'
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    mon=0
    sigp=np.loadtxt(path+"ice_psd_signodesp_3dohigh_signodes_"+str(mon)+".dat")
    sign=np.loadtxt(path+"psd_signodesp_3dohigh_signodes_"+str(mon)+".dat")
    
    plt.subplot(121)
    ax=plt.plot()
    nodes=[int(i) for i in sigp[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
             
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sigp[:,1]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('ICE',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.0), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(122)
    ax=plt.plot()
    nodes=[int(i) for i in sign[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sign[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('T',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.0), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.95, bottom = 0.05, right = 0.95, left = 0.0, 
                hspace = 0.01, wspace = 0.21)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(49, 11)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_psd_6do_high_AO_ICE_T_Jan.png") 


 
    
def plot_ortho():
    regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    data=np.loadtxt(path+'/data/seaice/selectnodes_6do_high.dat')
    sigp=np.loadtxt(path+'/data/seaice/ice_psd_signodesp_6do_high.dat')
    sign=np.loadtxt(path+'/data/seaice/ice_psd_signodesn_6do_high.dat')
    
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in sigp[:,0]]
    #nodes=[int(i) for i in data]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
          
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=[sigp[:,1][i] for i in range(len(sigp))]
    #color=nodes
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('Positive',fontsize=34) #annual
    
    # figure = plt.gcf() # get current figure
    #             # 
    # figure.set_size_inches(10, 8)
    #     #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    # plt.savefig("/home/meng/fig/ice_signodes_psd_arctic_6do_high.png")    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in sign[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sign[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('Negative',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.9, bottom = 0.05, right = 0.88, left = 0.01, 
                hspace = 0.1, wspace = 0.05)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(19, 30)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/ice_signodes_psd_arctic_6do_high.png") 
        

def calculate_psd_ice():
    tmpice=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
   # T=np.reshape(tmp,(8040,14965))

    T=np.reshape(tmpice,(855,14965))
    fs=18
    xtick=[1,2,3,6,9]
    labels=['1/18d','1/9d','1/6d','1/3d','1/2d']
    
    # fs=24
    # xtick=[1,2,3,4,6,8,12]
    # labels=['1/24d','1/12d','1/8d','1/6d','1/4d','1/3d','1/2d']    
    outfile=open(path+'/data/seaice/psd_3d_ice.dat','w')
    for node in range(855):
        print (node)
        #r=np.std(T[node])*0.2
        for year in range(1980,2020):
            for month in range(1,13):
                s1=365*(year-1979)+monthds[month-1]
                s2=s1+months[month-1]  
               # for nodes in range(8040):
                dataV=T[node][s1:s2]
                x,y=pdswelch(dataV,fs)
                ii=int(list(x).index(6))
                jj=sum(y[ii:])
                outfile.write('%.6f \n'%(jj))
                outfile.flush()
    outfile.close()
def psdtoao_ice():       
    datad=np.loadtxt(path+'/data/seaice/psd_3d_ice.dat')
    psdx=np.reshape(datad,(855,480))
    outfile=open(path+'/data/seaice/psd_signodesp_ice.dat','w')
    for i in range(855):
        x=psdx[i]
        y=aoi
        if(sum(x)>0):
            r=pearsonr(x,y)[0]
            p=pearsonr(x,y)[1]
            if(r>0 and p<0.05):
                outfile.write('%d %.6f %.6f \n'%(i,r,p))
                outfile.flush()            
        
    outfile.close()    
    
    
def plot_ortho_ice():
    regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')

    sigp=np.loadtxt(path+'/data/seaice/psd_signodesp_ice.dat')
    sign=np.loadtxt(path+'/data/seaice/psd_signodesp.dat')
    
    plt.subplot(211)
    ax=plt.plot()
    nodes=[int(i) for i in sigp[:,0]]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
          
    lats1=np.array(regrid1[:,1][nodes])
    lons1=np.array(regrid1[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=sigp[:,1]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation W to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
    
    plt.title('Positive ice',fontsize=34) #annual
    
    
    plt.annotate('(a)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
    plt.subplot(212)
    ax=plt.plot()
    nodes=[int(i) for i in sign[:,0] if(regrid[:,1][int(i)]>=75)]
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=[sign[:,1][int(i)] for i in sign[:,0] if(regrid[:,1][int(i)]>=75)]
    m.scatter(x,y,400,marker='o',c=color,cmap='cool')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation C to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)    
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('Positive_t850',fontsize=34) #annual
    
    plt.annotate('(b)', xy=(-0.02,1.1), xycoords='axes fraction', fontsize=38 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')        
    plt.subplots_adjust(top = 0.9, bottom = 0.05, right = 0.88, left = 0.01, 
                hspace = 0.1, wspace = 0.05)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(19, 30)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/signodes_psd_arctic_ice_t_positive_75N.png")     
    
    
    
def selectnodes():
    signodes=np.loadtxt(path+'/data/seaice/psd_signodesp_6do_high.dat')
    outfile=open(path+'/data/seaice/selectnodes_6dohigh_60N.dat','w')
    for i in signodes[:,0]:
        i=int(i)
        lat=regrid[:,1][i]
        lon=regrid[:,2][i]
        if(lat>=60):
            outfile.write('%d \n'%(i))
            outfile.flush()
    outfile.close()
    
    outfile=open(path+'/data/seaice/psd_signodesp_label.dat','w')
    for i in signodes[:,0]:
        i=int(i)
        outfile.write('%d \n'%(i))
        outfile.flush()
    outfile.close()    
    
    
def stablenodes_sy_mon():
    path='/home/meng/bupt_data'
    tmp=np.loadtxt(path+'/origin/seaice/era5t8502.5g_ano_1979to2019.ano')   
    tmpi=np.loadtxt(path+'/origin/seaice/era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    T=np.reshape(tmp,(8040,14965))
    I=np.reshape(tmpi,(377,14965))    
    
    path='/home/meng/bupt_data/data/seaice/'
    outfile=open(path+'wpospwnegn_ICET_sy_corraotimes.dat','w')
    for mon in range(12):
        xx=np.zeros(8040)
        yy=np.zeros(8040)
        for i in range(1,101):
            print (i)
            data=np.loadtxt(path+"wsignodesp_ICET_sy_"+str(i)+"_"+str(mon)+".dat")
            nodes=[int(i) for i in data[:,0]]
            nodes=np.array(nodes)            
            xx[nodes]+=1    
            data=np.loadtxt(path+"wsignodesn_ICET_sy_"+str(i)+"_neg_"+str(mon)+".dat")
            nodes=[int(i) for i in data[:,0]]
            nodes=np.array(nodes)            
            yy[nodes]+=1  
        for i in range(8040):
            outfile.write('%d %d \n'%(xx[i],yy[i]))
            outfile.flush()
    outfile.close()
 
    
    nodes=np.loadtxt(path+'wsignodesp_ICET_2.dat')
    data=np.loadtxt(path+'wpospwnegn_ICET_sy_corraotimes.dat')   
    nodesp=[int(i) for i in data[:,0]]
    nodesn=[int(i) for i in data[:,1]]
    nodesp=np.reshape(nodesp,(12,8040))
    nodesn=np.reshape(nodesn,(12,8040))
    mon=2
    nodep=[i for i in range(8040) if (nodesp[mon][i]==100)]
    noden=[i for i in range(8040) if (nodesn[mon][i]==100)]  
    nodespr=[int(i) for i in nodes[:,0] if (nodesp[mon][int(i)]<5)]
    lp=np.loadtxt(path+'siglevel_sy_ICET.dat')
    ln=np.loadtxt(path+'siglevel_sy_ICET_neg.dat')
    lpw=np.reshape(lp[:,0],(480,8040))
    lnw=np.reshape(ln[:,0],(480,8040))
    degrees=np.loadtxt(path+'degrees_ICET.dat')
    dw=np.reshape(degrees[:,0],(480,8040))
    wl=lpw[:,7549]
    wr=dw[:,7549]
    wl=np.reshape(wl,(40,12))
    wr=np.reshape(wr,(40,12))
    ao=np.reshape(aoi,(40,12))
    plt.plot(wl[:,2],'b--')
    plt.plot(wr[:,2],'r--')
    plt.plot(np.array(ao[:,2])*0.05+1.7,'k-')



    n=0
    for i in range(8040):
        i=int(i)
        wl=lpw[:,i]
        wr=dw[:,i]
        r1=pearsonr(wl,wr)[0]
        p1=pearsonr(wl,wr)[1]
        r=pearsonr(wl,aoi)[0]
        p=pearsonr(wl,aoi)[1]
        r2=pearsonr(wr,aoi)[0]
        p2=pearsonr(wr,aoi)[1]
        if(p2<0.05):
            print (i,r1,r,r2)
            n+=1
            
            
        wl=np.reshape(wl,(40,12))
        wr=np.reshape(wr,(40,12))        
        ao=np.reshape(aoi,(40,12))
        r1=pearsonr(wl[:,mon],wr[:,mon])[0]
        p1=pearsonr(wl[:,mon],wr[:,mon])[1]
        r=pearsonr(wl[:,mon],ao[:,mon])[0]
        p=pearsonr(wl[:,mon],ao[:,mon])[1]
        r2=pearsonr(wr[:,mon],ao[:,mon])[0]
        p2=pearsonr(wr[:,mon],ao[:,mon])[0]
        xx=[i for i in range(40) if (wl[:,mon][i]<wr[:,mon][i])]
        
        if(p2<0.05 and len(xx)>20):
            print (i,r1,r,r2,len(xx))
            n+=1
    
    n=0
    for i in range(8040):
        i=int(i)
        wl=lpw[:,i]
        wr=dw[:,i]
        wl=np.reshape(wl,(40,12))
        wr=np.reshape(wr,(40,12))        
        ao=np.reshape(aoi,(40,12))
        r1=pearsonr(wl[:,mon],wr[:,mon])[0]
        p1=pearsonr(wl[:,mon],wr[:,mon])[1]
        r=pearsonr(wl[:,mon],ao[:,mon])[0]
        p=pearsonr(wl[:,mon],ao[:,mon])[1]
        r2=pearsonr(wr[:,mon],ao[:,mon])[0]
        p2=pearsonr(wr[:,mon],ao[:,mon])[0]
        xx=[i for i in range(40) if (wl[:,mon][i]<wr[:,mon][i])]
        
        if(p2<0.05 and len(xx)>20):
            print (i,r1,r,r2,len(xx))
            n+=1
        
    
    
    
    year=1999
    month=mon+1
    s1=365*(year-1979)+monthds[month-1]
    s2=s1+months[month-1]  
    print (nodep)    
    node=2770
    dataV=T[node][s1-10:s2]   
    plt.plot(dataV,'b--')
    ni=300
    dataI=I[ni][s1-10:s2]
    plt.plot(dataI,'r--')
    
    node=2770
    ni=0
    dataV=T[node]
    dataI=I[ni]
    x=np.reshape(dataV,(41,365))
    y=np.reshape(dataI,(41,365))
    for i in range(41):
        plt.plot(x[i])
    for i in range(41):
        plt.plot(y[i])
    

    
if __name__=="__main__":    
    calculate_psd_run()
  #  psdtoao_run() 
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
def plot_pds():
    wt=np.reshape(dataalllink[:,0],(480,8040))
    sigwwts=[np.mean(wt[i][nodesp2]) for i in range(480)]
    sigwwtn=[np.mean(wt[i][nodesp1]) for i in range(480)]
    
    wtI=np.reshape(dataalllinkI[:,2],(480,8040))
    sigwwtsI=[np.mean(wtI[i][nodesn2I]) for i in range(480)]
    sigwwtnI=[np.mean(wtI[i][nodesn1I]) for i in range(480)]   
    
    fs=60
    xtick=[1,5,10,15,20,30]
    labels=['1/5y','1/1y','1/6m','1/4m','1/3m','1/2m']
    
    fs=120
    xtick=[1,10,20,30,40,60]
    labels=['1/10y','1/1y','1/6m','1/4m','1/3m','1/2m']
        
    plt.subplot(121)
    x,y=pdswelch(aoi,fs)
    plt.semilog(x,y,color='k',label='AO',linewidth=3)
    x1,y1=pdswelch(sigwwts,fs)
    plt.semilogy(x1,y1,color='r',linestyle='--',label='T-T',linewidth=3)
    x3,y3=pdswelch(sigwwtsI,fs)
    plt.semilogy(x3,y3,color='b',linestyle='--',label='ICE-T',linewidth=3)
    plt.title('SG',fontsize='24')
   # plt.legend(fontsize='24')
    plt.xticks(xtick, labels, fontsize=24,rotation=-60)
    
    plt.axvline(x=1,color='green')
    
    plt.axvline(x=10,color='green')
    plt.axvline(x=20,color='green')
    plt.axvline(x=30,color='green')

    #plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
   # plt.xlabel('Frequency',fontsize=24)
    plt.ylabel('PSD',fontsize=24)    
    
    plt.annotate('(a)', xy=(-0.05,1.1), xycoords='axes fraction', fontsize=24,
                     xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                     ha='left', va='bottom')  
    plt.annotate('Frequency', xy=(1.0,-0.25), xycoords='axes fraction', fontsize=24,
                     xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                     ha='left', va='bottom')    
    plt.subplot(122)
    x,y=pdswelch(aoi,fs)
    plt.semilogy(x,y,color='k',label='AO',linewidth=3)
    x1,y1=pdswelch(sigwwtn,fs)
    plt.semilogy(x1,y1,color='r',linestyle='--',label='T-T',linewidth=3)
    x3,y3=pdswelch(sigwwtnI,fs)
    plt.semilogy(x3,y3,color='b',linestyle='--',label='ICE-T',linewidth=3)
    plt.title('NG',fontsize='24')
    plt.legend(fontsize=24,loc=1,bbox_to_anchor=(0.99,1.2))
    plt.xticks(xtick, labels, fontsize=24,rotation=-60)
    
    plt.axvline(x=1,color='green')
    
    plt.axvline(x=10,color='green')
    plt.axvline(x=20,color='green')
    plt.axvline(x=30,color='green')
    plt.yticks(fontsize=24)
    #plt.xlabel('Frequency',fontsize=24)
   # plt.ylabel('PSD',fontsize=24)    
    
    plt.annotate('(b)', xy=(-0.05,1.1), xycoords='axes fraction', fontsize=24,
                     xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                     ha='left', va='bottom')      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(22, 8)
    plt.savefig("/home/jingfang/fig/seaice/network/H_tau10/sy1node/PSD_"+str(fs)+".png")
                
    
#    zx=np.zeros(120)  
#    for i in range(7):
#        xx=aoi
#        s1=i*60
#        s2=s1+120
#        x1=xx[s1:s2]
#        z=np.abs(np.fft.fft(x1))**2
#        zx+=z   
#    zx=zx/max(zx)
#    plt.plot(zx[:61])
#    plt.plot(y)
#    
#    f, Pxx_den = signal.periodogram(aoi, 120)

def powerspectrum(): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    fs=120.
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
    
    fs = 100.
    N = 1000
    amp = 2*np.sqrt(2)
    freq = 5
    noise_power = 0.001 * fs / 2
    time = np.arange(N) / fs
    x = np.sin(2*np.pi*freq*time)+2*np.sin(2*np.pi*time)
    plt.plot(x)
    ps = np.abs(np.fft.fft(x))**2
    plt.plot(ps[:80])    
    import numpy as np
    import matplotlib.pyplot as plt
    
    # make a little extra space between the subplots
    plt.subplots_adjust(wspace=0.5)
    
    nfft = 256
    dt = 0.01
    t = np.arange(0, 30, dt)
    nse1 = np.random.randn(len(t))                 # white noise 1
    nse2 = np.random.randn(len(t))                 # white noise 2
    r = np.exp(-t/0.05)
    
    cnse1 = np.convolve(nse1, r, mode='same')*dt   # colored noise 1
    cnse2 = np.convolve(nse2, r, mode='same')*dt   # colored noise 2
    
    # two signals with a coherent part and a random part
    s1 = 0.01*np.sin(2*np.pi*10*t) + cnse1
    s2 = 0.01*np.sin(2*np.pi*10*t) + cnse2
    
    plt.subplot(211)
    plt.plot(t, s1, 'b-', t, s2, 'g-')
    plt.xlim(0,5)
    plt.xlabel('time')
    plt.ylabel('s1 and s2')
    plt.grid(True)
    
    plt.subplot(212)
    cxy, f = plt.cohere(s1, s2, nfft, 1./dt)
    plt.ylabel('coherence')
    plt.show()    
    
    wt=np.reshape(dataalllink[:,0],(480,8040))
    sigwwts=[np.mean(wt[i][nodesp2]) for i in range(480)]
    sigwwtn=[np.mean(wt[i][nodesp1]) for i in range(480)]
    
    wtI=np.reshape(dataalllinkI[:,2],(480,8040))
    sigwwtsI=[np.mean(wtI[i][nodesn2I]) for i in range(480)]
    sigwwtnI=[np.mean(wtI[i][nodesn1I]) for i in range(480)]    
        
    
    x=aoi
    ps = np.abs(np.fft.fft(x))**2
    plt.plot(ps)
    
    y1=80   # cyc half year
    y2=24   #cyc 1 year
    y3=20    #cyc 2 year
    y4=24    #cyc 5 year
    y5=48    #cyc 10 year
    
    plt.plot(ps[240:240+2*y1])
    
    Lamda=[480/i for i in np.arange(1.0,241.0,1.0)]
    x1=sigwwts
    ps1 = np.abs(np.fft.fft(x1))**2
    ps1=ps1/np.max(ps1[1:241])
    plt.plot(ps1[1:241])
    x=aoi
    ps = np.abs(np.fft.fft(x))**2
    ps=ps/np.max(ps[1:241])
    plt.plot(ps[1:241])
    
    x=10
    x=[i*10+1 for i in range(24)]
    
    y1=[np.mean(ps1[i:i+20]) for i in x]
    y2=[np.mean(ps[i:i+20]) for i in x]
    
    plt.plot(y1)
    plt.plot(y2)
    s1=sigwwts[:]
    s2=aoi[:]
    csdxy, fcsd = plt.csd(s1, s2)
    cxy, f = plt.cohere(s1, s2)
    plt.subplot(121)
    plt.psd(s1)
    plt.subplot(122)
    plt.psd(s2)
    f, Cxy = signal.coherence(sigwwts, aoi)
    plt.semilogy(f, Cxy)
    
    x=aoi
    fs=120.
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
    plt.semilogy(f, Pxx_den/max(Pxx_den))
    x=sigwwts
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
    plt.semilogy(f, Pxx_den/max(Pxx_den))    



    x=aoi
    fs=120.
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
    plt.semilogy(f, Pxx_den/max(Pxx_den))
    x=sigwwts
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
    plt.semilogy(f, Pxx_den/max(Pxx_den))    
    

    
def detrend():    
    
    
    from scipy import signal
    sigww1=np.array(sigww1)
    plt.plot(sigww1-1.75)
    plt.plot(signal.detrend(sigww1))
    
    x1=signal.detrend(aoi)
    x2=signal.detrend(sigww1)
    x3=signal.detrend(lnx)
    
    x=signal.detrend(aoi)
    f, Pxx_spec = signal.welch(x, 1, 'flattop', nperseg=10, scaling='spectrum')
    plt.figure()
    plt.semilogy(f, np.sqrt(Pxx_spec))
def regressiontoAO():
    psd=np.loadtxt(path+'psd_sum_t850.dat')
    auto=np.loadtxt(path+'autocorr.dat')
    degree=np.loadtxt(path+'degrees_ICET_neg.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]
    nodes=np.loadtxt(path+'wsignodesn_ICET_neg.dat')
    nodes=[int(i) for i in nodes[:,0]]
    psdx=np.reshape(psd,(8040,480))
    autox=np.reshape(auto,(480,8040))
    degreex=np.reshape(degree[:,0],(480,8040))
    
    psdy=[]
    autoy=[]
    degreey=[]

    psdz=[]
    autoz=[]
    degreez=[]
    for i in nodes:
        psdy.append(psdx[i])
        autoy.append(autox[:,i])
        degreey.append(degreex[:,i])
        x1=psdx[i]
        x2=np.reshape(x1,(40,12))
        y1=[np.mean(x2[j]) for j in range(40)]
        psdz.append(y1)
        x1=autox[:,i]
        x2=np.reshape(x1,(40,12))
        y1=[np.mean(x2[j]) for j in range(40)]
        autoz.append(y1)       
        x1=degreex[:,i]
        x2=np.reshape(x1,(40,12))
        y1=[np.mean(x2[j]) for j in range(40)]
        degreez.append(y1)       
    
    x=aoi
    y=np.arange(len(nodes))
    z=autoy
    plt.contourf(x,y,z)
    
    

    
    x1=[]
    y1=[]
    for i in range(40):
        x1+=list(abs(aoi))
        y1+=list(autoy[i])
    plt.imshow(Z, cmap=plt.cm.RdBu, extent=(min(aoi), max(aoi), 800, 0), interpolation='bilinear')
 #   plt.imshow(z, interpolation='bilinear')
    #im = imshow(z,cmap=cm.RdBu) # drawing the function

    plt.colorbar(im)  



    x1=np.reshape(aoi,(40,12))
    aoy=[np.mean(x1[i]) for i in range(40)]
    x=aoy
    y=np.arange(len(nodes))
    z=autoz
    plt.contourf(x,y,z)
    
    for i in range(10):
        plt.scatter(aoi,z[i])
        
        
    x=[]
    y=[]
    for i in range(40):
        x+=list(aoi)
        y+=list(autoy[i])
        
    plt.hexbin(x, y, gridsize=20, cmap='Blues')
    cb = plt.colorbar(label='count in bin')
    cb.set_label(label='count in bin', size=24,)
    cb.ax.tick_params(labelsize=24)      
    
    
    indexs=np.argsort(aoi)
    for i in range(10):
        x=np.array(autoy[i])
        plt.plot(x[indexs])
        
    rdax=[]
    pdax=[]
    for i in range(8040):
        x=autox[:,i]
        y=degreex[:,i]
        r=pearsonr(x,y)[0]
        p=pearsonr(x,y)[1]
        rdax.append(r)
        pdax.append(p)
        
    nodes=[int(i) for i in range(8040)]
    #nodes=np.arange(8040)
    #nodes=[int(i) for i in range(8040) if(xp[i]>5)]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=rdax
    #color=xp[np.array(nodes)]
    m.scatter(x,y,200,marker='o',c=color,cmap='Reds')
          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation degree to autocorr', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)      
    
    