#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jun 16 12:21:28 2023

@author: meng
"""



from geopy.distance import geodesic

from collections import Counter
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
import math
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy.stats import rankdata
    
from scipy.stats import gaussian_kde

import matplotlib as mpl
    
import glob
import seaborn as sns 
import os
import conda

from mpl_toolkits.basemap import Basemap
import matplotlib.pyplot as plt
from matplotlib.pyplot import MultipleLocator
import numpy as np
import pandas as pd
import networkx as nx
from geopy.distance import geodesic
from geopy.distance import great_circle as GC
from matplotlib import cm
import matplotlib.colors as colors
from matplotlib.colors import ListedColormap, LinearSegmentedColormap
import cartopy.crs as ccrs
from scipy.interpolate import griddata

from collections import Counter   



def plot_conectivity():

    ax=plt.subplot(131)
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'ICET_linksN_30d_tau20_8040_time.dat')
      #data=np.loadtxt(path+'ICET_degreesN_30d_tau20_8040_time.dat')
      
     # data=np.loadtxt(path+'ICET_degrees_30d_tau20_8040_timeX.dat')
    
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]
      
        #plt.plot(taux,dpn,'k--',label='globe')   
    yearx=np.arange(480)/12+1980
    plt.plot(yearx,data[:,0],color='#68228B',linewidth=1,label='$95\%$')
        #ax3.plot(yearx,data[:,1],color='royalblue',linewidth=1,label='$99\%$')
        
    xmajorLocator = MultipleLocator(10) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.02) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.2f') #设置y轴标签文本的格式
      #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
        
        #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.01) #将此y轴次刻度标签设置为0.1的倍数
        #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=5)  
    ax.tick_params(which='minor',length=2)
        
       # ax3.set_ylim(0,0.11)
    ax.set_xlim(1980,2020)
    ax.tick_params(axis='y', colors='k')
    yticks=[0.03,0.05,0.07,0.09,0.11]
    label=['3%','5%','7%','9%','11%']
    plt.yticks(yticks,labels=label,fontsize=48,rotation=0)
       
    ax.set_xlabel('Time',fontsize=20)
    ax.set_ylabel('Significant Link Ratio',fontsize=24,color='k',rotation=90)    
        #ax3.legend(fontsize=18)
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=24, weight='bold',
                           xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                           ha='left', va='bottom')      
    
    ax=plt.subplot(132)
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/ICET_degreesN_30d_tau20_8040_all.dat')
   
    #c=data[:,0]
    
    degree=np.reshape(data[:,0],(480,8040))
    
    avex=[np.mean(degree[:,i]) for i in range(8040)]
    stdx=[np.std(degree[:,i]) for i in range(8040)]
    
    anox=np.zeros(shape=(480,8040))
    for i in range(480):
        for j in range(8040):
            anox[i,j]=(degree[i,j]-avex[j])/stdx[j]
    
    anoxt=[]
    for i in range(480):
        xx=[degree[i][k]-avex[k] for k in range(8040)]
        anoxt.append(sum(xx))
    

    h=15000
    m = Basemap(projection='nsper',lon_0=135,lat_0=55,satellite_height=h*1000.,resolution='l')

    #m.shadedrelief(scale = 0.3)
    m.drawcoastlines(linewidth = 1,color='lightgray')
    m.drawmeridians(np.arange(-180, 180, 60),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 30),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
              
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
       
    
    
    color=zx
    a=min(color)
    b=max(color)
    m.scatter(x,y,500,marker='o',c=color,cmap='magma',vmax=b,vmin=a)
    

    
    numcols, numrows = 360, 181
    lonX = np.linspace(np.min(lons1), np.max(lons1), numcols)
    lat = np.linspace(np.max(lats1), np.min(lats1), numrows)
    lonX, lat = np.meshgrid(lonX, lat)
    
    z=color

    speed = griddata((lons1,lats1),z,(lonX,lat),method='cubic') 

    lonX = np.linspace(np.min(lons1), np.max(lons1), numcols)
    lat = np.linspace(np.max(lats1), np.min(lats1), numrows)    
    speed, lon = shiftgrid(180, speed, lonX, start=False) 
   

    lon2d, lat2d = np.meshgrid(lon, lat)
    
    x, y = m(lon2d, lat2d)
    z=speed
    
    
    levels1 = np.linspace(a,b,21)

    cs = m.contourf(x, y, z,extend='both',levels= levels1,cmap=plt.cm.magma)
   
    
 
    
    cbar = plt.colorbar(cs, orientation='horizontal',shrink=0.5,pad=0.05)
    label_1 =  np.linspace( a, b, 6)
    cbar.set_ticks(label_1)
    cbar.ax.tick_params(labelsize=30)
    cbar.ax.set_xlabel('Node Degree',fontsize=30)
  
   
    
    
    plt.annotate('a', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=38,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
           










def links8040icetsm_realvalue():
 # data1=np.loadtxt('/home/meng/bak_bupt/newproj/data/2010_2_ICET_links_30d_tau20_8040.dat')
  
  data1=np.loadtxt('/home/meng/bak_bupt/newproj/data/1985_10_ICET_links_30d_tau20_8040.dat')  
  
  n=0
  m=4020*377
  c1=data1[:,10][n:m]
  w1=data1[:,11][n:m]
  t1=data1[:,12][n:m]
  
  
  
  z1=np.where(abs(c1)<1)[0]
  z2=np.where(abs(w1)>=0)[0]
  z3=np.intersect1d(z1,z2)
  
  cxa=c1[z3]
  txa=t1[z3]
  
  
  n=4020*377
  m=len(data1)
  c1=data1[:,10][n:m]
  w1=data1[:,11][n:m]
  t1=data1[:,12][n:m]
  
  
  
  z1=np.where(abs(c1)<1)[0]
  z2=np.where(abs(w1)>=0)[0]
  z3=np.intersect1d(z1,z2)
  
  cxb=c1[z3]
  txb=t1[z3]
  
  
  
  
  cx=[]
  tx=[]
  
  cx1=[]
  tx1=[]
  for st in range(1,2):
      
      data2=np.loadtxt("/home/meng/bak_bupt/newproj/data/year/"+str(st)+"s_ICET_links_30d_tau20_8040.dat")
      
      
      n=0
      m=4020*377
      c2=data2[:,10][n:m]
      w2=data2[:,11][n:m]
      t2=data2[:,12][n:m]
      
      
      
      u1=np.where(abs(c2)<1)[0]
      u2=np.where(abs(w2)>=0)[0]
      u3=np.intersect1d(u1,u2)
      
      cx.append(c2[u3])
      tx.append(t2[u3])
      
      
      n=4020*377
      m=len(data2)
      c2=data2[:,10][n:m]
      w2=data2[:,11][n:m]
      t2=data2[:,12][n:m]
      
      
      
      u1=np.where(abs(c2)<1)[0]
      u2=np.where(abs(w2)>=0)[0]
      u3=np.intersect1d(u1,u2)
      
      cx1.append(c2[u3])
      tx1.append(t2[u3])

  ax=plt.subplot(131)
  path='/home/meng/bak_bupt/newproj/data/'
  data=np.loadtxt(path+'ICET_linksN_30d_tau20_8040_time.dat')
  #data=np.loadtxt(path+'ICET_degreesN_30d_tau20_8040_time.dat')
  
 # data=np.loadtxt(path+'ICET_degrees_30d_tau20_8040_timeX.dat')

  ao=np.loadtxt(path+'AO.dat')
  aoi=ao[:,2][360:840]
  
    #plt.plot(taux,dpn,'k--',label='globe')   
  yearx=np.arange(480)/12+1980
  plt.plot(yearx,data[:,0],color='#68228B',linewidth=1,label='$95\%$')
    #ax3.plot(yearx,data[:,1],color='royalblue',linewidth=1,label='$99\%$')
    
  xmajorLocator = MultipleLocator(5) #将x主刻度标签设置为20的倍数
  xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
  ymajorLocator = MultipleLocator(0.02) #将y轴主刻度标签设置为0.5的倍数
  ymajorFormatter = FormatStrFormatter('%.2f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
  ax.xaxis.set_major_locator(xmajorLocator)
  ax.xaxis.set_major_formatter(xmajorFormatter)
  ax.yaxis.set_major_locator(ymajorLocator)
  ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
  xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
  yminorLocator = MultipleLocator(0.01) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
  ax.xaxis.set_minor_locator(xminorLocator)
  ax.yaxis.set_minor_locator(yminorLocator) 
  ax.tick_params(which='both', width=2)
  ax.tick_params(which='major', length=5)  
  ax.tick_params(which='minor',length=2)
    
   # ax3.set_ylim(0,0.11)
  ax.set_xlim(1980,2020)
  ax.tick_params(axis='y', colors='k')
  yticks=[0.03,0.05,0.07,0.09,0.11]
  label=['3%','5%','7%','9%','11%']
  plt.yticks(yticks,labels=label,fontsize=48,rotation=0)
   
  ax.set_xlabel('Time',fontsize=20)
  ax.set_ylabel('Significant Link Ratio',fontsize=20,color='k',rotation=90)    
    #ax3.legend(fontsize=18)
  plt.xticks(fontsize=18)
  plt.yticks(fontsize=18)

  plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                       xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                       ha='left', va='bottom')      
    
  
  
  ax=plt.subplot(132)    
  
  
  import scipy.stats as st
      
  xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
  xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
  ymajorLocator = MultipleLocator(4) #将y轴主刻度标签设置为0.5的倍数
  ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
  #设置主刻度标签的位置,标签文本的格式
  ax.xaxis.set_major_locator(xmajorLocator)
  ax.xaxis.set_major_formatter(xmajorFormatter)
  ax.yaxis.set_major_locator(ymajorLocator)
  ax.yaxis.set_major_formatter(ymajorFormatter)
  
  #修改次刻度
  xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
  yminorLocator = MultipleLocator(2) #将此y轴次刻度标签设置为0.1的倍数
  #设置次刻度标签的位置,没有标签文本格式
  ax.xaxis.set_minor_locator(xminorLocator)
  ax.yaxis.set_minor_locator(yminorLocator) 
  ax.tick_params(which='both', width=4)
  ax.tick_params(which='major', length=9)  
  ax.tick_params(which='minor',length=5)
  
  x = cxa
  y = txa
  
  
  xmin, xmax = -1, 1
  ymin, ymax = -20, 20
  
  # Peform the kernel density estimate
  xx, yy = np.mgrid[xmin:xmax:10j, ymin:ymax:50j]
  positions = np.vstack([xx.ravel(), yy.ravel()])
  values = np.vstack([x, y])
  kernel = st.gaussian_kde(values)
  f = np.reshape(kernel(positions).T, xx.shape)
  #levs=[400,1200,2400]
  # Contourf plot
#  cfset = ax.contourf(xx, yy, f, cmap='Reds')
  ## Or kernel density estimate plot instead of the contourf plot
  #ax.imshow(np.rot90(f), cmap='Blues', extent=[xmin, xmax, ymin, ymax])
  # Contour plot
  
  #plt.clabel(CS, inline=1, fontsize=10, manual=manual_locations)  
  xx1=xx
  yy1=yy
  f1=f
  cset = ax.contour(xx1, yy1, f1,colors='r',linewidth=3)
  manual_locations = [(-0.9, 12),(-0.6,12),(0.6,12),(0.9,12)]
  # Label plot
 # ax.clabel(cset, inline=1,inline_spacing=-15,fontsize=20,fmt='%1.0f',colors='g',manual=manual_locations)
  ax.clabel(cset, inline=1,inline_spacing=-5,fontsize=18,fmt='%.3f',colors='r',manual=manual_locations)
  
  #[txt.set_bbox(dict(boxstyle='square,pad=0',fc='g')) for txt in cb]
  ax.set_xlabel('C',fontsize=20)
  ax.set_ylabel('$\\tau$ (days)',fontsize=20) 
  
  
  #ax=plt.subplot(111)
  
  x=cx
  y=tx
  
  #x=xd[1]
  #y=yd[1]
  # xmin, xmax = 0.01, 0.075
  # ymin, ymax = 0.02, 0.085
  
  # Peform the kernel density estimate
  xx, yy = np.mgrid[xmin:xmax:10j, ymin:ymax:50j]
  positions = np.vstack([xx.ravel(), yy.ravel()])
  values = np.vstack([x, y])
  kernel = st.gaussian_kde(values)
  f = np.reshape(kernel(positions).T, xx.shape)
  
  #fig = pl.figure()
  #ax = fig.gca()
  ax.set_xlim(xmin, xmax)
  ax.set_ylim(ymin, ymax)
  # Contourf plot
  #cfset = ax.contourf(xx, yy, f/8040., cmap='Greys')
  ## Or kernel density estimate plot instead of the contourf plot
  #ax.imshow(np.rot90(f), cmap='Blues', extent=[xmin, xmax, ymin, ymax])
  # Contour plot
  cfset = ax.contourf(xx, yy, f, cmap='Blues')
  
  cset = ax.contour(xx, yy, f, colors='b',linewidth=3)
  # Label plot
  manual_locations = [(-0.9, -12),(-0.4,-12),(0.4,-12),(0.9,-12)]
  
  ax.clabel(cset, inline=1,inline_spacing=-5,fontsize=18,fmt='%.3f',colors='b',manual=manual_locations)

  
  cut1=0.75
  cut2=-cut1
  ax.axvline(x=cut1,color='k',linewidth=4,linestyle='--')
  ax.axvline(x=cut2,color='k',linewidth=4,linestyle='--')
  xticks=np.linspace(-1,1,11)
  yticks=np.linspace(-20,20,11)
  plt.xticks(xticks,fontsize=32)
  plt.yticks(yticks,fontsize=32)    
  plt.title('Nothern Hemisphere',fontsize=18)
  
  plt.annotate('b', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=32,weight='bold',
                       xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                       ha='left', va='bottom')      
  
  figure = plt.gcf() # get current figure
              # 
  figure.set_size_inches(20, 4)
  
  ax=plt.subplot(133)    
  
  
  import scipy.stats as st
  
  xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
  xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
  ymajorLocator = MultipleLocator(4) #将y轴主刻度标签设置为0.5的倍数
  ymajorFormatter = FormatStrFormatter('%d') #设置y轴标签文本的格式
  #设置主刻度标签的位置,标签文本的格式
  ax.xaxis.set_major_locator(xmajorLocator)
  ax.xaxis.set_major_formatter(xmajorFormatter)
  ax.yaxis.set_major_locator(ymajorLocator)
  ax.yaxis.set_major_formatter(ymajorFormatter)
  
  #修改次刻度
  xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
  yminorLocator = MultipleLocator(2) #将此y轴次刻度标签设置为0.1的倍数
  #设置次刻度标签的位置,没有标签文本格式
  ax.xaxis.set_minor_locator(xminorLocator)
  ax.yaxis.set_minor_locator(yminorLocator) 
  ax.tick_params(which='both', width=4)
  ax.tick_params(which='major', length=9)  
  ax.tick_params(which='minor',length=5)
  
  x = cxb
  y = txb
  
  
  xmin, xmax = -1, 1
  ymin, ymax = -20, 20
  
  # Peform the kernel density estimate
  xx, yy = np.mgrid[xmin:xmax:10j, ymin:ymax:50j]
  positions = np.vstack([xx.ravel(), yy.ravel()])
  values = np.vstack([x, y])
  kernel = st.gaussian_kde(values)
  f = np.reshape(kernel(positions).T, xx.shape)
  #levs=[400,1200,2400]
  # Contourf plot
#  cfset = ax.contourf(xx, yy, f, cmap='Reds')
  ## Or kernel density estimate plot instead of the contourf plot
  #ax.imshow(np.rot90(f), cmap='Blues', extent=[xmin, xmax, ymin, ymax])
  # Contour plot
  
  #plt.clabel(CS, inline=1, fontsize=10, manual=manual_locations)    
  cset = ax.contour(xx, yy, f,colors='r',linewidth=3)
  manual_locations = [(-0.9, 12),(-0.6,12),(0.6,12),(0.9,12)]
  # Label plot
 # ax.clabel(cset, inline=1,inline_spacing=-15,fontsize=20,fmt='%1.0f',colors='g',manual=manual_locations)
  ax.clabel(cset, inline=1,inline_spacing=-5,fontsize=28,fmt='%.3f',colors='r',manual=manual_locations)
  
  #[txt.set_bbox(dict(boxstyle='square,pad=0',fc='g')) for txt in cb]
  ax.set_xlabel('C',fontsize=38)
  ax.set_ylabel('$\\tau$ (days)',fontsize=38) 
  
  
  
  
  x = cx1
  y = tx1
  #x=xd[1]
  #y=yd[1]
  # xmin, xmax = 0.01, 0.075
  # ymin, ymax = 0.02, 0.085
  
  # Peform the kernel density estimate
  xx, yy = np.mgrid[xmin:xmax:10j, ymin:ymax:50j]
  positions = np.vstack([xx.ravel(), yy.ravel()])
  values = np.vstack([x, y])
  kernel = st.gaussian_kde(values)
  f = np.reshape(kernel(positions).T, xx.shape)
  
  #fig = pl.figure()
  #ax = fig.gca()
  ax.set_xlim(xmin, xmax)
  ax.set_ylim(ymin, ymax)
  # Contourf plot
  #cfset = ax.contourf(xx, yy, f/8040., cmap='Greys')
  ## Or kernel density estimate plot instead of the contourf plot
  #ax.imshow(np.rot90(f), cmap='Blues', extent=[xmin, xmax, ymin, ymax])
  # Contour plot
  cfset = ax.contourf(xx, yy, f, cmap='Blues')
  
  cset = ax.contour(xx, yy, f, colors='b',linewidth=3)
  # Label plot
  manual_locations = [(-0.8, -12),(-0.4,-12),(0.4,-12),(0.8,-12)]
  
  ax.clabel(cset, inline=1,inline_spacing=-5,fontsize=28,fmt='%.3f',colors='b',manual=manual_locations)
 
 
  ax.axvline(x=cut1,color='k',linewidth=4,linestyle='--')
  ax.axvline(x=cut2,color='k',linewidth=4,linestyle='--')
  xticks=np.linspace(-1,1,11)
  yticks=np.linspace(-20,20,11)
  plt.xticks(xticks,fontsize=32)
  plt.yticks(yticks,fontsize=32)    
  plt.title('Southern Hemisphere',fontsize=38)
  
  
  plt.annotate('c', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                       xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                       ha='left', va='bottom')    
  
  plt.subplots_adjust(top = 0.9, bottom = 0.15, right = 0.95, left = 0.05, 
              hspace = 0.1, wspace = 0.3)   
  
  figure = plt.gcf() # get current figure
              # 
  figure.set_size_inches(24, 6)
      #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
  plt.savefig("/home/meng/bak_bupt/newproj/fig/1985_10_377_8040_icet_sm.png",dpi=300) 