#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 16 10:48:38 2021

@author: meng
"""
from scipy.stats.stats import pearsonr

from netCDF4 import Dataset
import numpy as np
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
def KS(x,y):
    a=max(max(x),max(y))
    b=min(min(x),min(y))
    z=np.linspace(b,a,50)
    lx=len(x)*1.0
    ly=len(y)*1.0
    zz=[]
    for i in z:
        xxx=[j for j in x if j<=i]
        yyy=[j for j in y if j<=i]
        zz.append(len(xxx)/lx-len(yyy)/ly)
    zza=[abs(i) for i in zz]
    c=zza.index(max(zza))
    return zz[c]

def dn(a,m,n):
    x=np.sqrt(-np.log(a/2.)*(m+n)/(2.*m*n))
    return x

def pdf(x,n):
    cnts, bins0 = np.histogram(x, bins=n, normed=False)    
    bins0 = (bins0[:-1] + bins0[1:]) / 2    
    cnts = cnts/len(x)
    return bins0,cnts

def pdf1(x,y):
    cnts, bins0 = np.histogram(x, bins=y, normed=False)    
    bins0 = (bins0[:-1] + bins0[1:]) / 2    
    cnts = cnts/len(x)
    for i in range(len(bins0)):
        if(sum(cnts[i:])==0):
            break
    return bins0[:i],cnts[:i]    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)
def anualave(x,n):
    x1=np.reshape(x,(n,12))
    x2=[np.mean(x1[:,i]) for i in range(12)]
    return x2
def anualstd(x,n):
    x1=np.reshape(x,(n,12))
    x2=[np.std(x1[:,i]) for i in range(12)]
    return x2

def readdata():
    path1='/home/meng/bupt_data/origin/'
    path2='/home/meng/bupt_data/data/seaice/'
    
    data1=Dataset(path1+'monthly_10mv_10mu_sst.nc','r',format='NETCDF4')
    data2=Dataset(path1+'monthly_div_geo_u_v.nc','r',format='NETCDF4')
    
    nodes=np.loadtxt(path2+'regridcos2.5d_global.dat')
    
    lats=nodes[:,3]
    lons=nodes[:,4]
    
    
    v10m=data1.variables['v10'][:492,0,:,:]
    u10m=data1.variables['u10'][:492,0,:,:]
    sst=data1.variables['sst'][:492,0,:,:]
    div=data2.variables['d'][:492,0,:,:]
    geo=data2.variables['z'][:492,0,:,:]
    u=data2.variables['u'][:492,0,:,:]
    v=data2.variables['v'][:492,0,:,:]
    xx=[]
    outfile=open(path2+'monthly_ano_div850.nc','w')
    outfile1=open(path2+'monthly_ano_div850_oceannodes.dat','w')
    xx=[]
    for k in range(len(nodes)):
        print (k)
        i=int(lats[k])
        j=int(lons[k])
        x=div[:,i,j]
       
        #print (i,j,sum(x))
        #xx.append(sum(x))
      #  print (sum(x))
        # if(sum(abs(x))>=0):
        #     #print (sum(x))
        #     outfile1.write('%d \n'%(k))
        #     outfile1.flush()
# =============================================================================
#         x1=u10m[:,i,j]
#         x2=v10m[:,i,j]
#         x=[np.sqrt(x1[i]*x1[i]+x2[i]*x2[i]) for i in range(len(x1))]
# =============================================================================
        y=anualstd(x, 41)
        z=anualave(x, 41)    
        for q in range(len(x)):
                #q1=int(q/12)
                q2=q%12
                x1=(x[q]-y[q2])/z[q2]
             
                xx.append(x1)
                outfile.write('%.6f \n'%(x1))
                outfile.flush()
    outfile.close()
    outfile1.close()
        
def corr_absAO():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'monthly_ano_div850.nc')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corr_absAO_div850.dat','w')
    outfile1=open(path+'corr_absAO_div850_monthly.dat','w')
    x=np.reshape(data,(8040,492))
    for i in range(8040):
        print (i)
        x1=x[i][12:]
        x2=abs(aoi)
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        if(r>0.4):
            break
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close()
def corrAODEGREE():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'degrees_ICET_syICE1.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_wneg850_syICE1.dat','w')
    outfile1=open(path+'corrAO_wneg850_monthly_syICE1.dat','w')
    x=np.reshape(data[:,1],(8040,480))
    for i in range(8040):
        print (i)
        x1=abs(x[i][:])
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close()            
        
def corrAO():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'degrees_ICET_neg.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_wneg850a.dat','w')
    outfile1=open(path+'corrAO_wneg850a_monthly.dat','w')
    outfile2=open(path+'corrAO_wneg850a_anual.dat','w')
    x=np.reshape(data[:,0],(480,8040))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        z1=[np.mean(y1[j]) for j in range(40)]
        z2=[np.mean(y2[j]) for j in range(40)]
        r=pearsonr(z1,z2)[0]
        p=pearsonr(z1,z2)[1]
        outfile2.write('%.6f %.6f \n'%(r,p))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close()            
    outfile2.close() 
def corrAO_sst():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'monthly_ano_mwp.nc')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_mwp.dat','w')
    outfile1=open(path+'corrAO_mwp_monthly.dat','w')
    nodes=np.loadtxt(path+'monthly_ano_mwp_oceannodes.dat')
    nodes=[int(i) for i in nodes]
    x=np.reshape(data,(len(nodes),492))
    for i in range(len(nodes)):
        print (i)
        x1=x[i][12:]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        ii=nodes[i]
        outfile.write('%d %.6f %.6f \n'%(ii,r,p))
        outfile.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close()    

def corrAO_wind():
    path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'monthly_ano_wind250.nc')
    #path='/home/meng/bak_bupt/newproj/data/'
    ##data=np.loadtxt('/home/meng/bak_bupt/newproj/data/monthly_ano_Uwind850.nc')
    
#    data=np.loadtxt(path+'monthly_ano_sst.nc')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(8040,480))
    #x=np.reshape(data,(8040,480))
    
    outfile=open(path+"corrAO_wind250.dat",'w')
    outfile1=open(path+"corrAO_wind250_monthly.dat",'w')
    outfile2=open(path+"corrAO_wind250_anual.dat",'w')        
            
    for i in range(8040):
            #print (i)
        x1=x[i][:]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        print (i,r,p)
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%d %.6f %.6f \n'%(i,r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()   
    

def corrAO_wind_season():
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'monthly_ano_Vwind250.nc')
    data=np.loadtxt(path+'monthly_ano_Uwind250.nc')

   # path='/home/meng/bak_bupt/newproj/data/'
   # data=np.loadtxt('/home/meng/bak_bupt/newproj/data/monthly_ano_Uwind850.nc')
    

    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(8040,480))
    #x=np.reshape(data,(8040,480))
    
    outfile=open(path+"corrAO_Uwind250_season.dat",'w')
    season=[[-1,0,1],[2,3,4],[5,6,7],[8,9,10]]
    for i in range(8040):
            #print (i)
        x1=x[i][:]
        x2=aoi
        for j in range(4):
            kx=[a*12+b for b in season[j] for a in range(40)]
            y1=x1[kx]
            y2=x2[kx]
            r,p=pearsonr(y1,y2)
            outfile.write('%.6f %.6f \n'%(r,p))
            outfile.flush()
    outfile.close()
    
    
    data=np.loadtxt(path+'monthly_ori_Uwind250_A.nc')
    x=np.reshape(data,(8040,480))
    season=[[-1,0,1],[2,3,4],[5,6,7],[8,9,10]]
    
    outfile=open(path+'Uwind250_season.dat','w')
    for i in range(8040):
        x1=x[i][:]
        for j in range(4):
            kx=[a*12+b for b in season[j] for a in range(40)]
            y1=x1[kx]
            wind=np.mean(y1)
            outfile.write('%.6f \n'%(wind))
            outfile.flush()
    outfile.close()


    cut1=np.percentile(aoi,95)
    cut2=np.percentile(aoi,5)
    xx=np.where(aoi>cut1)[0]
    yy=np.where(aoi<cut2)[0]
    
    outfile=open(path+'Uwind850_aoi.dat','w')
    for i in range(8040):
        x1=x[i][:]
        y1=x1[xx]
        y2=x1[yy]
        wind1=np.mean(y1)
        wind2=np.mean(y2)
        outfile.write('%.6f %.6f \n'%(wind1,wind2))
        outfile.flush()
    outfile.close()
    
    


def sumlats():
    data1=np.loadtxt(path+'corrAO_Uwind850_season.dat')
    data2=np.loadtxt(path+'corrAO_autocorr_abs_season.dat')

    rx1=np.reshape(data1[:,0],(8040,4))
    rx2=np.reshape(data2[:,0],(8040,4))
    
    plt.plot(rx1[:,2][-1000:])
    plt.plot(rx2[:,2][-1000:])
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    y1=[]
    y2=[]
    for lon in np.arange(0,360,2.5):
        x=np.where(regrid[:,2]==lon)[0]
        a=np.mean(rx1[x,0])
        b=np.mean(rx2[x,0])
        y1.append(a)
        y2.append(b)
    plt.plot(y1)
    plt.plot(y2)
    
    
def corrAO_ogl():
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'monthly_ogl_monthly.dat')
#    data=np.loadtxt(path+'monthly_ano_sst.nc')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(8040,480))
    #x=np.reshape(data,(8040,480))
    
    outfile=open(path+"corrAO_ogl.dat",'w')
    outfile1=open(path+"corrAO_ogl_monthly.dat",'w')
    outfile2=open(path+"corrAO_ogl_anual.dat",'w')        
            
    for i in range(8040):
            #print (i)
        x1=x[i][:]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        print (i,r,p)
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()    
    
def plot_corrAO():   
  
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    
    

    data=np.loadtxt(path+'corrAO_psdsum850a_monthly.dat')
    nodes=[int(i) for i in data[:,0]]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1][nodes]
    m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
   # m.scatter(x,y,150,marker='o',c=color,cmap='seismic_r')

#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
   # # cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=56)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)   
   #  c=0.25
    plt.clim(-0.4,0.4)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
   # m.scatter(x,y,150,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('TTR',fontsize=66) #annual
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(20, 16)          
    


    data=np.loadtxt(path+"corrAO_ogl_anual.dat")
    nodes=[int(i) for i in range(8040)]
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,0][nodes]
    m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
   # m.scatter(x,y,150,marker='o',c=color,cmap='seismic_r')

#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
   # # cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=56)
   #  a=abs(min(color))
   #  b=abs(max(color))
   #  c=max(a,b)   
   #  c=0.25
   # plt.clim(-0.2,0.2)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,1][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,150,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('TTR',fontsize=66) #annual
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(20, 16)   



def corrAO_psdsum():
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_psdsum850a.dat','w')
    outfile1=open(path+'corrAO_psdsum850a_monthly.dat','w')
    outfile2=open(path+'corrAO_psdsum850a_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

   # x=np.reshape(data,(480,8040))
    x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        z1=[np.mean(x1[k:k+12]) for k in range(468)]
        z2=[np.mean(x2[k:k+12]) for k in range(468)]
        r,p=pearsonr(z1,z2)
        outfile1.write('%d %.6f %.6f \n'%(i,r,p))
        outfile1.flush()
        # for j in range(12):
        #     z1=y1[:,j]
        #     z2=y2[:,j]
        #     r1=pearsonr(z1,z2)[0]
        #     p1=pearsonr(z1,z2)[1]
        #     outfile1.write('%.6f %.6f \n'%(r1,p1))
        #     outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
def corrAO_autocorr():
    path='/home/meng/bak_bupt/newproj/data/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_autocorr850_abs.dat','w')
    outfile1=open(path+'corrAO_autocorr850_abs_monthly.dat','w')
    outfile2=open(path+'corrAO_autocorr850_abs_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,8040))
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
       
    
    data1=np.loadtxt(path+'corrAO_wpos850.dat')
    data2=np.loadtxt(path+'corrAO_wneg850.dat')
    outfile=open(path+'corrAO_degree850.dat','w')
    for i in range(8040):
        x1=data1[:,1][i]
        x2=data2[:,1][i]
        y1=data1[:,2][i]
        y2=data2[:,2][i]
        if(abs(x1)>abs(x2)):
            x=x1
            y=y1
        else:
            x=-x2
            y=y2
        outfile.write('%d %.6f %.6f \n'%(i,x,y))
        outfile.flush()
    outfile.close()
def corrAO_sampenicet():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'degrees_ICETsampen21.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_sampenicet850.dat','w')
    outfile1=open(path+'corrAO_sampenicet850_monthly.dat','w')
    outfile2=open(path+'corrAO_sampenicet850_anual.dat','w')
    outfile3=open(path+'corrAO_sampenicet850_anualcyc.dat','w')
    
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,8040))
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        print (r)
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()

def corrAO_autocorr():
    path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrabsAO_autocorr850_abs.dat','w')
    outfile1=open(path+'corrabsAO_autocorr850_monthly_abs.dat','w')
    outfile2=open(path+'corrabsAO_autocorr850_anual_abs.dat','w')
    outfile3=open(path+'corrabsAO_autocorr850_anualcyc_abs.dat','w')
    
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,8040))
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=abs(aoi)
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()
    
def corrAO_autocorr_season():
    path='/home/meng/bak_bupt/newproj/data/'   

#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    #outfile=open(path+'corrAO_autocorr_ice.dat','w')
    outfile1=open(path+'corrAO_autocorr_abs_season.dat','w')
    #outfile2=open(path+'corrAO_autocorr_ice_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,8040))
    
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        if(sum(x1)>0):
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))
            spring=[i*12+2+j for i in range(40) for j in range(3)]
            summer=[i*12+5+j for i in range(40) for j in range(3)]
            autumn=[i*12+8+j for i in range(40) for j in range(3)]
            winter=[i*12+j for i in range(40) for j in range(2)]+[i*12+11 for i in range(40)]
            season=[winter,spring,summer,autumn]
            for ss in range(4):
                indexs=season[ss]
                x1=np.array(x1)
                x2=np.array(x2)
                r,p=pearsonr(x1[indexs],x2[indexs])
                outfile1.write('%.6f %.6f \n'%(r,p))
                outfile1.flush()
    outfile1.close()    


    
def corrAO_psdsum_season():
    path='/home/meng/bak_bupt/newproj/data/'   

    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    #outfile=open(path+'corrAO_autocorr_ice.dat','w')
    outfile1=open(path+'corrAO_psdsum_season.dat','w')
    #outfile2=open(path+'corrAO_autocorr_ice_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(8040,480))
    
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
        print (i)
        x1=x[i]
        if(sum(x1)>0):
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))
            spring=[i*12+2+j for i in range(40) for j in range(3)]
            summer=[i*12+5+j for i in range(40) for j in range(3)]
            autumn=[i*12+8+j for i in range(40) for j in range(3)]
            winter=[i*12+j for i in range(40) for j in range(2)]+[i*12+11 for i in range(40)]
            season=[winter,spring,summer,autumn]
            for ss in range(4):
                indexs=season[ss]
                x1=np.array(x1)
                x2=np.array(x2)
                r,p=pearsonr(x1[indexs],x2[indexs])
                outfile1.write('%.6f %.6f \n'%(r,p))
                outfile1.flush()
    outfile1.close()    


    
def corrAO_autocorr10512():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr10512.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_autocorr850_10512.dat','w')
    outfile1=open(path+'corrAO_autocorr850_monthly_10512.dat','w')
    outfile2=open(path+'corrAO_autocorr850_anual.dat_10512','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,10512))
    #x=np.reshape(data,(8040,480))
    for i in range(10512):
        print (i)
        x1=x[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
def corrAO_extremT850():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'T850_extrem_num.dat')#reshape(8040,480)  seaice_extrem_num.dat
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrabsAO_TextremP.dat','w')
    outfile1=open(path+'corrabsAO_TextremP_monthly.dat','w')
    outfile2=open(path+'corrabsAO_TextremP_anual.dat','w')
    outfile3=open(path+'corrabsAO_TextremP_anualcyc.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')
    x=data[:,0]
    N=8040
    #x=np.reshape(data,(480,8040))
    x=np.reshape(x,(N,480))
    for i in range(N):
        print (i)
        x1=x[i]
        x2=abs(aoi)
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()
    
    data1=np.loadtxt(path+'corrAO_autocorr850.dat')
    data2=np.loadtxt(path+'corrAO_TextremP.dat')
    data3=np.loadtxt(path+'corrAO_TextremN.dat')
def detrend(x,m):
    y=np.zeros(len(x))
    y[m:len(x)-m]=[np.mean(x[i:i+m]) for i in range(m,len(x)-m)]
    y[:m]=[np.mean(x[:m]) for i in range(m)]
    y[len(x)-m:]=[np.mean(x[len(x)-m:]) for i in range(m)]
    z=[x[i]-y[i] for i in range(len(x))]
    return z
    
    
    
    
def corrAO_extremT850_detrend():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'T850_extrem_num.dat')#reshape(8040,480)  seaice_extrem_num.dat
    data=np.loadtxt(path+'TextremN.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrabsAO_TextremN_detrend.dat','w')
    outfile1=open(path+'corrabsAO_TextremN_monthly_detrend.dat','w')
    outfile2=open(path+'corrabsAO_TextremN_anual_detrend.dat','w')
    outfile3=open(path+'corrabsAO_TextremN_anualcyc_detrend.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')
    x=data
    N=8040
    #x=np.reshape(data,(480,8040))
    x=np.reshape(x,(N,480))
    for i in range(N):
        print (i)
        x1=x[i]
        x2=abs(aoi)
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()



def corrAO_T850():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'monthly_t850.dat')#reshape(8040,480)  seaice_extrem_num.dat
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_T.dat','w')
    outfile1=open(path+'corrAO_T_monthly.dat','w')
    outfile2=open(path+'corrAO_T_anual.dat','w')
    outfile3=open(path+'corrAO_T_anualcyc.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')
    x=data
    N=8040
    #x=np.reshape(data,(480,8040))
    x=np.reshape(x,(N,480))
    for i in range(N):
        print (i)
        x1=x[i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()

def corr_extremT850_autocorr():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data0=np.loadtxt(path+'autocorr.dat')
    data=np.loadtxt(path+'T850_extrem_num.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corr_autocorr_T850extrem.dat','w')
    outfile1=open(path+'corr_autocorr_T850extrem_monthly.dat','w')
    outfile2=open(path+'corr_autocorr_T850extrem_anual.dat','w')
    outfile3=open(path+'corr_autocorr_T850extrem_anualcyc.dat','w')

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')
    x=data[:,1]+data[:,0]
    #x=np.reshape(data,(480,8040))
    x=np.reshape(x,(8040,480))
    y=np.reshape(data0,(480,8040))
    for i in range(8040):
        print (i)
        x1=x[i]
        x2=y[:,i]
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()


def corr_extremT850_autocorr():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data0=np.loadtxt(path+'autocorr.dat')
    data=np.loadtxt(path+'T850_extrem_num.dat')#reshape(8040,480)
    data0=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
    data1=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)

    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    px=data[:,0]
    nx=data[:,1]
    px=np.reshape(px,(8040,480))
    nx=np.reshape(nx,(8040,480))

    outfile=open(path+'corr_cneg_T850extremP.dat','w')
    outfile1=open(path+'corr_cneg_T850extremP_monthly.dat','w')
    outfile2=open(path+'corr_cneg_T850extremP_anual.dat','w')
    outfile3=open(path+'corr_cneg_T850extremP_anualcyc.dat','w')
    x=px
    y=np.reshape(data0[:,1],(480,8040))
    z=np.reshape(data1[:,1],(480,8040))

    for i in range(8040):
        print (i)
        x1=x[i]
        x2=z[:,i]
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile3.write('%.6f %.6f \n'%(r2,p2))
        outfile3.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    outfile3.close()



def corr_extrem():
    data=np.loadtxt(path+'T850_extrem_num.dat')
    px=data[:,0]
    nx=data[:,1]
    px=np.reshape(px,(8040,480))
    nx=np.reshape(nx,(8040,480))
    nodes=np.arange(1788)
    
    def corrx(x,y,m,p):
        l=len(x)
        N=0
        X=[]
        n=(l-m)/p+1
        for i in range(n):
            s1=i*p
            s2=s1+m
            x1=x[s1:s2]
            y1=y[s1:s2]
            r=pearsonr(x1,y1)[0]
            p=pearsonr(x1,y1)[1]
            if(p<0.05):
                N+=1
            X.append(r)
        return N,np.mean(x)
        
    
    
    

def corrAO_autocorr_s():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,8040))
    #x=np.reshape(data,(8040,480))
    for times in range(10):
        outfile=open(path+"corrAO_autocorr850s_"+str(times)+".dat",'w')
        outfile1=open(path+"corrAO_autocorr850_monthlys_"+str(times)+".dat",'w')
        outfile2=open(path+"corrAO_autocorr850_anuals_"+str(times)+".dat",'w')        
        y2=np.reshape(aoi,(40,12))            
        x2=[]
        ylist=np.arange(40)
        np.random.shuffle(ylist)
        for yy in ylist:
            for mm in range(12):
                x2.append(y2[yy,mm])        
        for i in range(8040):
            print (i)
            x1=x[:,i]
            
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))
            outfile.write('%d %.6f %.6f \n'%(i,r,p))
            outfile.flush()
            yy1=[np.mean(y1[:,k]) for k in range(12)]
            yy2=[np.mean(y2[:,k]) for k in range(12)]
            r2=pearsonr(yy1,yy2)[0]
            p2=pearsonr(yy1,yy2)[1]
            outfile2.write('%.6f %.6f \n'%(r2,p2))
            outfile2.flush()
            for j in range(12):
                z1=y1[:,j]
                z2=y2[:,j]
                r1=pearsonr(z1,z2)[0]
                p1=pearsonr(z1,z2)[1]
                outfile1.write('%.6f %.6f \n'%(r1,p1))
                outfile1.flush()
        outfile.close()
        outfile1.close() 
        outfile2.close()    

def corrAO_autocorr_ice():
    #path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_autocorr_ice_abs.dat','w')
    outfile1=open(path+'corrAO_autocorr_ice_abs_monthly.dat','w')
    outfile2=open(path+'corrAO_autocorr_ice_abs_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,377))
    
    #x=np.reshape(data,(8040,480))
    for i in range(377):
        print (i)
        x1=x[:,i]
        if(sum(x1)>0):
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))

            yy1=[np.mean(y1[k]) for k in range(40)]
            yy2=[np.mean(y2[k]) for k in range(40)]
            r2=pearsonr(yy1,yy2)[0]
            p2=pearsonr(yy1,yy2)[1]
            outfile.write('%d %.6f %.6f \n'%(i,r,p))
            outfile.flush()
            outfile2.write('%.6f %.6f \n'%(r2,p2))
            outfile2.flush()
            for j in range(12):
                z1=y1[:,j]
                z2=y2[:,j]
                r1=pearsonr(z1,z2)[0]
                p1=pearsonr(z1,z2)[1]
                outfile1.write('%.6f %.6f \n'%(r1,p1))
                outfile1.flush()

    outfile.close()
    outfile1.close() 
    outfile2.close()
def corrAO_psdsum_ice():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'psd_sum_ICE.dat')
   
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_psdsum_ice.dat','w')
    outfile1=open(path+'corrAO_psdsum_ice_monthly.dat','w')
    outfile2=open(path+'corrAO_psdsum_ice_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(377,480))
    
    #x=np.reshape(data,(8040,480))
    for i in range(377):
        print (i)
        x1=x[i]
        if(sum(x1)>0):
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))

            yy1=[np.mean(y1[k]) for k in range(40)]
            yy2=[np.mean(y2[k]) for k in range(40)]
            r2=pearsonr(yy1,yy2)[0]
            p2=pearsonr(yy1,yy2)[1]
            outfile.write('%d %.6f %.6f \n'%(i,r,p))
            outfile.flush()
            outfile2.write('%.6f %.6f \n'%(r2,p2))
            outfile2.flush()
            for j in range(12):
                z1=y1[:,j]
                z2=y2[:,j]
                r1=pearsonr(z1,z2)[0]
                p1=pearsonr(z1,z2)[1]
                outfile1.write('%.6f %.6f \n'%(r1,p1))
                outfile1.flush()

    outfile.close()
    outfile1.close() 
    outfile2.close()

    data=np.loadtxt(path+'corrAO_psdsum_ice_monthly.dat')
    rx=data[:,0]
    px=data[:,1]
    N=len(data)/12
    N=int(N)
    rx=np.reshape(rx,(N,12))
    px=np.reshape(px,(N,12))
    for i in range(12):
        x=np.where(px[:,i]<0.05)[0]
        print (len(x))
   
    
   
    
def corrAO_autocorr_ice_season():
    path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'   

#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    #outfile=open(path+'corrAO_autocorr_ice.dat','w')
    outfile1=open(path+'corrAO_autocorr_ice_season_abs.dat','w')
    #outfile2=open(path+'corrAO_autocorr_ice_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(480,377))
    
    #x=np.reshape(data,(8040,480))
    for i in range(377):
        print (i)
        x1=x[:,i]
        if(sum(x1)>0):
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))
            spring=[i*12+2+j for i in range(40) for j in range(3)]
            summer=[i*12+5+j for i in range(40) for j in range(3)]
            autumn=[i*12+8+j for i in range(40) for j in range(3)]
            winter=[i*12+j for i in range(40) for j in range(2)]+[i*12+11 for i in range(40)]
            season=[winter,spring,summer,autumn]
            for ss in range(4):
                indexs=season[ss]
                x1=np.array(x1)
                x2=np.array(x2)
                r,p=pearsonr(x1[indexs],x2[indexs])
                outfile1.write('%.6f %.6f \n'%(r,p))
                outfile1.flush()
    outfile1.close()
         
def corrAO_psdsum_ice_season():
    path='/home/meng/bak_bupt/newproj/data/'   
    data=np.loadtxt(path+'psd_sum_ICE.dat')
    
   
        

#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    #outfile=open(path+'corrAO_autocorr_ice.dat','w')
    outfile1=open(path+'corrAO_psdsum_ice_season.dat','w')
    #outfile2=open(path+'corrAO_autocorr_ice_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data,(377,480))
    n=0
    #x=np.reshape(data,(8040,480))
    for i in range(377):
        #print (i)
        x1=x[i]
        if(sum(x1)>0):
            n+=1
            print (i)
            x2=aoi
            r=pearsonr(x1,x2)[0]
            p=pearsonr(x1,x2)[1]
            y1=np.reshape(x1,(40,12))
            y2=np.reshape(x2,(40,12))
            spring=[i*12+2+j for i in range(40) for j in range(3)]
            summer=[i*12+5+j for i in range(40) for j in range(3)]
            autumn=[i*12+8+j for i in range(40) for j in range(3)]
            winter=[i*12+j for i in range(40) for j in range(2)]+[i*12+11 for i in range(40)]
            season=[winter,spring,summer,autumn]
            for ss in range(4):
                indexs=season[ss]
                x1=np.array(x1)
                x2=np.array(x2)
                r,p=pearsonr(x1[indexs],x2[indexs])
               
                outfile1.write('%.6f %.6f \n'%(r,p))
                outfile1.flush()
    outfile1.close()
    
    path='/home/meng/bak_bupt/newproj/data/'   
    data1=np.loadtxt(path+'psd_sum_ICE.dat')
    data2=np.loadtxt(path+'autocorr_abs_ice.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')

    x=np.reshape(data2,(480,377))
    y=np.reshape(data1,(377,480))
    x1=[]
    y1=[]
    nodes=[]
    outfile=open(path+'availnodes.dat','w')
    nodes1=[]
    nodes2=[]
    for i in range(377):
        if(sum(x[:,i])>0):
            nodes1.append(i)
        if(sum(y[i,:])>0):
            nodes2.append(i)
        
        if(sum(x[:,i])>0 and sum(y[i,:])>0):
            nodes.append(i)
            outfile.write('%d %.1f %.1f \n'%(i,regrid2[:,1][i],regrid2[:,2][i]))
            outfile.flush()
            x1+=list(x[:,i])
            y1+=list(y[i,:])
            
    outfile.close()
    
    x2=np.reshape(x1,(166,480))
    y2=np.reshape(y1,(166,480))  
    
    
    
    nodes1=[]
    nodes2=[]
    for i in range(166):
        
        
        
        r1,p1=pearsonr(x2[i],aoi)
        r2,p2=pearsonr(y2[i],aoi)
        if(p1<0.05):
            nodes1.append(i)
        if(p2<0.05):
            nodes2.append(i)
            
    nodes1=[]
    nodes2=[]    
    for mon in range(12):
        ll=[mon+12*j for j in range(12)]
        n1=0
        n2=0
        for n in range(166):
            r1,p1=pearsonr(x2[n][ll],aoi[ll])
            r2,p2=pearsonr(y2[n][ll],aoi[ll])
            if(p1<0.05):
                n1+=1
                print (r1)
            if(p2<0.05):
                n2+=1
        print (n1,n2)
        nodes1.append(n1)
        nodes2.append(n2)
            
            
    xx=[np.mean(x2[nodes1,i]) for i in range(480)]
    yy=[np.mean(y2[nodes2,i]) for i in range(480)]
    xx=np.array(xx)
    yy=np.array(yy)
    
    
    aoy=np.reshape(aoi,(40,12))
    
    z=[np.mean(aoy[i]) for i in range(40)]
    nodes1=[]
    nodes2=[]
    r1x=[]
    r2x=[]
    for i in range(166):
        xx2=np.reshape(x2[i],(40,12))
        yy2=np.reshape(y2[i],(40,12))
        xx3=[np.mean(xx2[i]) for i in range(40)]
        yy3=[np.mean(yy2[i]) for i in range(40)]


        r1,p1=pearsonr(xx3[:],z[:])
        r2,p2=pearsonr(yy3[:],z[:])
        if(p1<0.05 and r1>0):
            nodes1.append(i)
            r1x.append(r1)
        if(p2<0.05 and r2>0):
            nodes2.append(i)
            r2x.append(r2)
            if(r2>0.64):
                print (i)
           
            
            
    xx=[np.mean(x2[nodes1,i]) for i in range(480)]
    yy=[np.mean(y2[nodes2,i]) for i in range(480)]
    xx=np.array(xx)
    yy=np.array(yy)
    


    
    
    spring=[i*12+2+j for i in range(40) for j in range(3)]
    summer=[i*12+5+j for i in range(40) for j in range(3)]
    autumn=[i*12+8+j for i in range(40) for j in range(3)]
    winter=[i*12+j for i in range(40) for j in range(2)]+[i*12+11 for i in range(40)]
    season=[winter,spring,summer,autumn]
     
    for i in range(4):
        labels=season[i]
        r1,p1=pearsonr(xx[labels],aoi[labels])
        r2,p2=pearsonr(yy[labels],aoi[labels])
        print (r1,r2)
        
        n=0
        for j in range(166):
            r,p=pearsonr(x2[j,labels],aoi[labels])
            if(p<0.05):
                n+=1
        print (n)
        
    
    
    x3=[np.mean(x2[:,i]) for i in range(480)]
    y3=[np.mean(y2[:,i]) for i in range(480)]
    
    for i in range(4):
        s1=i*120
        s2=s1+120
        r,p=pearsonr(xx[s1:s2],aoi[s1:s2])
        print (r)
        n1=0
        n2=0
        for n in range(168):
            x4=x2[n,s1:s2]
            y4=y2[n,s1:s2]
            z=aoi[s1:s2]
            r1,p1=pearsonr(z,x4)
            r2,p2=pearsonr(z,y4)
            if(p1<0.05):
                n1+=1
                print (r1)
            if(p2<0.05):
                n2+=1
                print (r2)
        print (n1,n2)
                
    
def corrAO_T850():      
    path='/home/meng/bupt_data/data/seaice/'
#    datad=np.loadtxt(path+'degrees_60N_pn.dat')
    datad=np.loadtxt(path+'degrees_60N_pn.dat')
    
    wx=np.reshape(datad[:,0],(480,8040))
    wnx=np.reshape(datad[:,1],(480,8040))
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'corrAO_wneg60N.dat','w')
    outfile1=open(path+'corrAO_wneg60N_monthly.dat','w')
    outfile2=open(path+'corrAO_wneg60N_anual.dat','w')
   
    
    for i in range(8040):
        print (i)
        x1=wnx[:,i]
        x2=aoi
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()

def corr_between():
    path='/home/meng/bupt_data/data/seaice/'
    data1=np.loadtxt(path+'psd_sum_t850.dat')
    data2=np.loadtxt(path+'autocorr.dat')
    data3=np.loadtxt(path+'degrees_ICET.dat')
    data4=np.loadtxt(path+'degrees_ICET_neg.dat')
    data5=np.loadtxt(path+'degreeabs_ICET.dat')
    # outfile=open(path+'degreeabs_ICET.dat','w')
    # for i in range(len(data1)):
    #     x1=data3[:,0][i]
    #     x2=data4[:,0][i]
    #     if(abs(x1)>abs(x2)):
    #         x=x1
    #     else:
    #         x=x2
    #     outfile.write('%.6f \n'%(abs(x)))
    #     outfile.flush()
    # outfile.flush()
    
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'autocorr_wneg850.dat','w')
    outfile1=open(path+'autocorr_wneg850_monthly.dat','w')
    outfile2=open(path+'autocorr_wneg850_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data2,(480,8040))
    y=np.reshape(data4[:,0],(480,8040))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=y[:,i]
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
    
    dataa=np.loadtxt(path+'autocorr_wpos850.dat')
    datab=np.loadtxt(path+'autocorr_wneg850.dat')
    outfile=open(path+'autocorr_degree850.dat','w')
    for i in range(8040):
        x1=dataa[:,1][i]
        x2=datab[:,1][i]
        y1=dataa[:,2][i]
        y2=datab[:,2][i]
        if(abs(x1)>abs(x2)):
            x=x1
            y=y1
        else:
            x=-x2
            y=y2
        outfile.write('%d %.6f %.6f \n'%(i,x,y))
        outfile.flush()
    outfile.close()    

    dataa=np.loadtxt(path+'corrAO_wpos850_monthly.dat')
    datab=np.loadtxt(path+'corrAO_wneg850_monthly.dat')
    outfile=open(path+'corrAO_degree850_monthly.dat','w')
    x1=dataa[:,0]
    x2=datab[:,0]
    y1=dataa[:,1]
    y2=datab[:,1]
    x1=np.reshape(x1,(8040,12))
    x2=np.reshape(x2,(8040,12))
    y1=np.reshape(y1,(8040,12))
    y2=np.reshape(y2,(8040,12))
    for i in range(8040):
        for j in range(12):
            xx1=x1[i,j]
            xx2=x2[i,j]
            yy1=y1[i,j]
            yy2=y2[i,j]
            if(abs(xx1)>abs(xx2)):
                x=xx1
                y=yy1
            else:
                x=-xx2
                y=yy2
            outfile.write('%d %.6f %.6f \n'%(i,x,y))
            outfile.flush()
    outfile.close()     


def corrAO_degree():
    path='/home/meng/bupt_data/data/seaice/'
    data1=np.loadtxt(path+'psd_sum_t850.dat')
    data2=np.loadtxt(path+'autocorr.dat')
    data3=np.loadtxt(path+'degrees_ICET.dat')
    data4=np.loadtxt(path+'degrees_ICET_neg.dat')
    data5=np.loadtxt(path+'degreeabs_ICET.dat')
    outfile=open(path+'degreenormal_ICET.dat','w')
    x1=data3[:,1]
    x2=data4[:,1]
    x=data2
    y=x/max(x)
    y1=x1/max(x1)
    y2=x2/min(x2)
    z1=y1/y
    z2=y2/y
    for i in range(len(data1)):
        outfile.write('%.6f %.6f \n'%(z1[i],z2[i]))
        outfile.flush()
    outfile.flush()
    
    data=np.loadtxt(path+'degreenormal_ICET.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]   
    aao=np.loadtxt(path+'aao')
    aaoi=aao[:,2][12:492]
    outfile=open(path+'corrAO_cmax850.dat','w')
    outfile1=open(path+'corrAO_cmax850_monthly.dat','w')
    outfile2=open(path+'corrAO_cmax850_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=np.reshape(data3[:,1],(480,8040))
   # y=np.reshape(data[:,1],(480,8040))
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=aoi
        
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()  
    
    dataa=np.loadtxt(path+'corrAO_wposnormal850.dat')
    datab=np.loadtxt(path+'corrAO_wnegnormal850.dat')
    outfile=open(path+'corrAO_degreenormal850.dat','w')
    for i in range(8040):
        x1=dataa[:,1][i]
        x2=datab[:,1][i]
        y1=dataa[:,2][i]
        y2=datab[:,2][i]
        if(abs(x1)>abs(x2)):
            x=x1
            y=y1
        else:
            x=x2
            y=y2
        outfile.write('%d %.6f %.6f \n'%(i,x,y))
        outfile.flush()
    outfile.close()    
    
    
def corr_monthly():
    data1=np.loadtxt(path+'corrAO_wpos850_monthly.dat')
    data2=np.loadtxt(path+'corrAO_wneg850_monthly.dat')    
    data3=np.loadtxt(path+'corrAO_psd850_monthly.dat')
    data4=np.loadtxt(path+'corrAO_autocorr850_monthly.dat')
    data5=np.loadtxt(path+'corrAO_wind850_monthly.dat')
    data6=np.loadtxt(path+'corrAO_wind10m_monthly.dat')    
    data7=np.loadtxt(path+'corrAO_geo850_monthly.dat')
    data8=np.loadtxt(path+'corrAO_div850_monthly.dat')    
    data9=np.loadtxt(path+'corrAO_sst850_monthly.dat')    
    data10=np.loadtxt(path+'corrAO_cmax850_monthly.dat')
    data11=np.loadtxt(path+'corrAO_cmin850_monthly.dat')     
    data12=np.loadtxt(path+'corrAO_TextremN_monthly.dat')
    
    
# =============================================================================
# def scattermap_global():
#     data=Dataset('/home/meng/CLUSTER_DATA/orgindata/ERA5850/1990.nc','r',format='NETCDF4')
#     lats=data.variables['latitude'][:]
#     lons=data.variables['longitude'][:]
#     outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_global.dat','w')
#     nodes=0
#     for i in range(0,73,1):
#         lat=lats[i]
#         #if(-40<lat<40):
#         a=np.cos(lat*np.pi/180.)
#         if(a==0):
#             b=1
#         else:
#             b=int(1/a)
#         y=np.arange(0,144,1*b)
#         for j in y:
#             lon=lons[j]
#             n=i*144+j
#             nodes+=1
#             outfile.write('%d %.6f %.6f %d %d \n'%(n,lat,lon,i,j))
#             outfile.flush()
#     outfile.close()
# =============================================================================
