#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jul 11 11:56:25 2022

@author: meng
"""
from netCDF4 import Dataset
import numpy as np
import scipy.fftpack
from scipy.fftpack import fft
from scipy import signal
import numpy as np
import matplotlib.pyplot as plt
from scipy.stats.stats import pearsonr
#from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from scipy import stats
import math
from collections import Counter
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
import math
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy.stats import rankdata
    
from scipy.stats import gaussian_kde

import matplotlib as mpl
    
import glob
import seaborn as sns
def logistic(x,mu):
	y = mu*x*(1.0-x)
	return y 
def chaost(n1,n2,x0,mu):
    x=x0
    z=np.linspace(0.0,1.0,n2-n1)
    for i in range(0,n1):
        x=logistic(x,mu)
    for i in range(n1,n2):
        x=logistic(x,mu)
        z[i-n1]=x
    return z
def autow(x,tau,l):
    z=[]
    for t in range(0,tau):
        x1=x[tau:l]
        x2=x[tau-t:l-t]
        r=pearsonr(x1,x2)[0]
        z.append(r)
        x1=x[tau-t:l-t]
        x2=x[tau:l]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return w


def autowx(x,tau,l1,l2):
    z=[]
    for t in range(0,tau):
        x1=x[l1:l2]
        x2=x[l1-t:l2-t]
        #print (len(x1),len(x2))
        r=pearsonr(x1,x2)[0]
        z.append(r)
        x1=x[l1-t:l2-t]
        x2=x[l1:l2]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return w


def autoc(x,tau,l):
    z=[]
    for t in range(-tau,0):
        x1=x[tau:l]
        x2=x[tau+t:l+t]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    for t in range(0,tau):
        x1=x[tau-t:l-t]
        x2=x[tau:l]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return z


def autocx(x,tau,l1,l2):
    z=[]
    for t in range(-tau,0):
        x1=x[l1:l2]
        x2=x[l1+t:l2+t]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    for t in range(0,tau):
        x1=x[l1-t:l2-t]
        x2=x[l1:l2]
        r=pearsonr(x1,x2)[0]
        z.append(r)
    w=(1-np.mean(z))/np.std(z)
    return z


# def fillit(n1,n2,x0,mu):
# 	 x = x0  # initial x value
#      z = np.linspace(0.0,1.0,n2-n1)  # create an array
# 	for i in range(0,n1):   # do n1 iterations
# 		x = logistic(x,mu)

# 	for i in range(0,n2-n1):   # fill n2-n1 iterations
# 		x = logistic(x,mu)
# 		z[i] = x
        
    
# 	return z  # returning the array
    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m/1)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)

def acf(data,Smax):
    from numpy import array, exp
    from scipy.optimize import curve_fit
#data=np.random.rand(365)
    #print (type(data))
    PSS = []
    PCX = []
    
    N = len(data)
    #Smax = 10
    x_ave = np.average(data)
    for s in np.arange(1,Smax):
        x_ave1 = np.average(data[:N-s])
        x_ave2 = np.average(data[s:])
    
        CX=0
        for i in range(N-s):
            CX += (data[i]-x_ave1)*(data[i+s] -x_ave2)
        #outfile.write('%.6f %.6f \n'%(s,CX/(N-s)))
        PSS.append(s)
        PCX.append(CX)
   # outfile.close()
    
    def func1(x, a, b):
        return a*x**b   
  
    params, covs = curve_fit(func1, PSS, PCX)
    
    
    return params

import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-single-levels-monthly-means',
    {
        'product_type': 'monthly_averaged_reanalysis',
        'variable': [
            '2m_temperature', 'clear_sky_direct_solar_radiation_at_surface', 
            'convective_rain_rate', 'downward_uv_radiation_at_the_surface', 'evaporation',
            'large_scale_precipitation',  
            'total_precipitation',
        ],
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'format': 'netcdf',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/enso/global_monthly_1959_2021.nc')

import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-pressure-levels',
    {
        'product_type': 'reanalysis',
        'format': 'netcdf',
        'variable': 'temperature',
        'pressure_level': '1000',
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'day': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
            '13', '14', '15',
            '16', '17', '18',
            '19', '20', '21',
            '22', '23', '24',
            '25', '26', '27',
            '28', '29', '30',
            '31',
        ],
        'time': '00:00',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/enso/global_1000hpa_1959_2022_day0h.nc')


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-single-levels',
    {
        'product_type': 'reanalysis',
        'format': 'netcdf',
        'variable': '2m_temperature',
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'day': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
            '13', '14', '15',
            '16', '17', '18',
            '19', '20', '21',
            '22', '23', '24',
            '25', '26', '27',
            '28', '29', '30',
            '31',
        ],
        'time': '00:00',
        'area': [
            5, -170, -5,
            -120,
        ],
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/enso/NINO_2m_1959_2022_day0h.nc')


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-single-levels-monthly-means',
    {
        'product_type': 'monthly_averaged_reanalysis',
        'variable': [
            '10m_u_component_of_wind', '10m_v_component_of_wind', 'convective_precipitation',
            'top_net_thermal_radiation',
        ],
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'format': 'netcdf',
        'area': [
            5, -170, -5,
            -120,
        ],
    },
    '/home/meng/bak_bupt/newproj/data/nino34_10u10v_negogl_1959_2022_monthly.nc')


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-single-levels-monthly-means',
    {
        'product_type': 'monthly_averaged_reanalysis',
        'variable':  'convective_precipitation',
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'format': 'netcdf',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/nino34_cp_1959_2021_monthly.nc')


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-single-levels-monthly-means',
    {
        'product_type': 'monthly_averaged_reanalysis',
        'variable': 'sea_surface_temperature',
        'year': [
            '1959', '1960', '1961',
            '1962', '1963', '1964',
            '1965', '1966', '1967',
            '1968', '1969', '1970',
            '1971', '1972', '1973',
            '1974', '1975', '1976',
            '1977', '1978', '1979',
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019', '2020', '2021',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'format': 'netcdf',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/global_sst_1959_2021_monthly.nc')


for years in range(1979,2022):

    import cdsapi
    
    c = cdsapi.Client()
    
    c.retrieve(
        'reanalysis-era5-pressure-levels',
        {
            'product_type': 'reanalysis',
            'format': 'netcdf',
            'variable': 'temperature',
            'pressure_level': '1000',
            'year': [years], 
            
            'day': [
                '01', '02', '03',
                '04', '05', '06',
                '07', '08', '09',
                '10', '11', '12',
                '13', '14', '15',
                '16', '17', '18',
                '19', '20', '21',
                '22', '23', '24',
                '25', '26', '27',
                '28', '29', '30',
                '31',
            ],
            'time': [
                '00:00',
            ],            
            'month': [
                '01', '02', '03',
                '04', '05', '06',
                '07', '08', '09',
                '10', '11', '12',
            ],
            'grid': '2.5/2.5',
        },
        "/home/meng/bak_bupt/newproj/data/t850_"+str(years)+"_1979_2022""_h0.nc")




for years in range(1959,2022):

    import cdsapi
    
    c = cdsapi.Client()
    
    c.retrieve(
        'reanalysis-era5-pressure-levels',
        {
            'product_type': 'reanalysis',
            'format': 'netcdf',
            'variable': 'temperature',
            'pressure_level': '1000',
            'year': [years], 
            
            'day': [
                '01', '02', '03',
                '04', '05', '06',
                '07', '08', '09',
                '10', '11', '12',
                '13', '14', '15',
                '16', '17', '18',
                '19', '20', '21',
                '22', '23', '24',
                '25', '26', '27',
                '28', '29', '30',
                '31',
            ],
            'time': [
                '00:00', '01:00', '02:00',
                '03:00', '04:00', '05:00',
                '06:00', '07:00', '08:00',
                '09:00', '10:00', '11:00',
                '12:00', '13:00', '14:00',
                '15:00', '16:00', '17:00',
                '18:00', '19:00', '20:00',
                '21:00', '22:00', '23:00',
            ],
            'area': [
                5, -170, -5,
                -120,
            ],
            'month': [
                '01', '02', '03',
                '04', '05', '06',
                '07', '08', '09',
                '10', '11', '12',
            ],
            'grid': '2.5/2.5',
        },
        "/home/meng/bak_bupt/newproj/data/enso/nino34_t1000_"+str(years)+"_1959_2022""_hourly.nc")


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-pressure-levels',
    {
        'product_type': 'reanalysis',
        'format': 'netcdf',
        'variable': [
            'u_component_of_wind', 'v_component_of_wind', 'vertical_velocity',
        ],
        'pressure_level': [
            '500','850',
        ],
        'year': '2011',
        'month': '10',
        'day': '1',
        'time': '00:00',
        #'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/2011_10_1_500hpa_850hpa_wind.nc')


import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-pressure-levels-monthly-means',
    {
        'format': 'netcdf',
        'variable': [
            'u_component_of_wind', 'v_component_of_wind',
        ],
        'pressure_level': [
            '500'
        ],
        'year': [
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'product_type': 'monthly_averaged_reanalysis',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/monthlywind500hpa_1980_2019.nc')



import cdsapi

c = cdsapi.Client()

c.retrieve(
    'reanalysis-era5-pressure-levels-monthly-means',
    {
        'format': 'netcdf',
        'variable': [
            'u_component_of_wind', 'v_component_of_wind',
        ],
        'pressure_level': [
            '250', '850',
        ],
        'year': [
            '1980', '1981', '1982',
            '1983', '1984', '1985',
            '1986', '1987', '1988',
            '1989', '1990', '1991',
            '1992', '1993', '1994',
            '1995', '1996', '1997',
            '1998', '1999', '2000',
            '2001', '2002', '2003',
            '2004', '2005', '2006',
            '2007', '2008', '2009',
            '2010', '2011', '2012',
            '2013', '2014', '2015',
            '2016', '2017', '2018',
            '2019',
        ],
        'month': [
            '01', '02', '03',
            '04', '05', '06',
            '07', '08', '09',
            '10', '11', '12',
        ],
        'time': '00:00',
        'product_type': 'monthly_averaged_reanalysis',
        'grid': '2.5/2.5',
    },
    '/home/meng/bak_bupt/newproj/data/monthlywind_1980_2019.nc')

from netCDF4 import Dataset
import numpy as np
import scipy.fftpack
from scipy.fftpack import fft

#NODE_NUMBER = 7442
YEAR_NUMBER1 = 6 ##########1983


YEAR_NUMBER2 = 63

data_del_idx = 31+29-1



def oni_reload():
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/oni.txt')
    outfile=open('/home/meng/bak_bupt/newproj/data/enso/oni1980_2022.dat','w')
    for i in range(30,73):
        for j in range(1,13):
            y=1950+i+(j-1)/12.
            if(data[i,j]>-20):
                outfile.write('%.6f %.6f \n' %(y,data[i,j]))
                outfile.flush()
    outfile.close()
    
def enso_identify():
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/oni1980_2022.dat')
    fileout1=open('/home/meng/bak_bupt/newproj/data/enso/eys2022','w')
    fileout2=open('/home/meng/bak_bupt/newproj/data/enso/lys2022','w')
    temx=data[:,1]
    timex=data[:,0]
    n=-1
    pn=0
    px=[]
    py=[]
    qn=0
    qx=[]
    qy=[]
    xx=[]
    yy=[]
    
    for year in range(1980,2023):
  
        for mon in range(12):
            n+=1
            if(temx[n]>=0.45):
                pn+=1
                px.append(temx[n])
                py.append(timex[n])
            else:
                if(pn>=5):
                    xx.append(py[0])
                    yy.append(max(px))
                    zz=np.where(np.array(px)==max(px))[0]
                    a=zz[0]
                    fileout1.write('%.6f %.6f %.6f %.6f %d \n' %(py[0],max(px),py[pn-1],py[a],12*(py[pn-1]-py[0])))
                    fileout1.flush()
                px=[]
                py=[]
                pn=0
            if(temx[n]<=-0.45):
                qn+=1
                qx.append(temx[n])
                qy.append(timex[n])
            else:
                if(qn>=5):
                    xx.append(qy[0])
                    yy.append(min(qx))
                    zz=np.where(np.array(qx)==min(qx))[0]
                    a=zz[0]
                    fileout2.write('%.6f %.6f %.6f %.6f %d \n' %(qy[0],min(qx),qy[qn-1],qy[a],12*(qy[qn-1]-qy[0])))
                    fileout2.flush()
                qx=[]
                qy=[]
                qn=0
    fileout1.close()
    fileout2.close()
            
    
    
def readdata_ori():
    loopx=[59*24+i for i in range(24)]
    outfile=open('/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021_6hourly.ano','w')
    for i in range(5):
        print (i)
        for j in range(21):  
            print (j)
            for year in range(1959,2022):
               # print (year)
                data = Dataset("/home/meng/bak_bupt/newproj/data/enso/nino34_t1000_"+str(year)+"_1959_2022""_hourly.nc",'r',format='NETCDF4')
                air_data=data.variables['t'][:,i,j]
                if(len(air_data))==366*24:
                    air_data=np.delete(air_data,loopx)
                   # print (year)
                for h in range(0,365*24,6):
                    outfile.write('%.6f \n'%(air_data[h]))
                    outfile.flush()
    outfile.close()
 

################################################################################################################    

def  global_T():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/global_1000hpa_1959_2022_day0h.nc','r',format='NETCDF4')
    data = Dataset('/home/meng/bak_bupt/newproj/data/2m_temperature_global.nc')
    air_data=data.variables['t2m'][:]
    a1="/home/meng/bak_bupt/newproj/data/global_ERA5_1979to2021_1000hpa_daily_ano.ano"
    a1="/home/meng/bak_bupt/newproj/data/global_ERA5_1979to2021_t2m_daily_ano.ano"
    
    
    
    
    
    
    
    DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t'][:]
    fileout=open(path+'era5t85075d_ano_1979to2019_g_new_728.ano','w')         
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    nx=[44,5337,16,5985,43,3983]
    nx=[55,2550]
    
   # regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')

    
    for n1 in nx:
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        x.append((data1[year][day] - day_ave)/day_std)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               

    nodes=np.loadtxt(path+'globe_726_new.dat')
    for kk in range(len(nodes)):
            print (kk)
            i=int(nodes[:,3][kk])
            j=int(nodes[:,4][kk])
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               
    fileout.close()
def  global_Ta():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
  
    DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t'][:]
    fileout=open(path+'era5t85075d_ano_1979to2019_g_new_377_726.ano','w')         
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    nx=[44,5337,16,5985,43,3983]
    nx=[55,2550]
    
    regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')

    
    for n1 in range(377):
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               

    nodes=np.loadtxt(path+'globe_726_new.dat')
    for kk in range(len(nodes)):
            print (kk)
            i=int(nodes[:,3][kk])
            j=int(nodes[:,4][kk])
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               
    fileout.close()    



def  global_T():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    
    DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t'][:]
    fileout=open(path+'era5t850_726.ano','w')         
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    regrid=np.loadtxt(path+'globe_726_new.dat')

    nx=[44,5337,16,5985,43,3983]
    nx=[55,2550]
    
   # regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')

    tx=[]
    for n1 in range(726):
            print (n1)
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2-2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                       # tx.append((data1[year][day] - day_ave)/day_std)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))

               
    fileout.close()




###############################distance
def distance():
    regrida=np.loadtxt(path+'globe_726_new.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    outfile=open(path+'lat_lon_728.dat','w')
    nx=[44,5337,16,5985,43,3983]
    nx=[55,2550]

    for n1 in nx:
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            outfile.write('%.1f %.1f \n'%(lati,lona))
            outfile.flush()
    for i in range(726):
            outfile.write('%.1f %.1f \n'%(regrida[:,1][i],regrida[:,2][i]))
            outfile.flush()    
    outfile.close()

    nodes=np.loadtxt(path+'globe_732.dat')
    outfile=open(path+'TT_links_30d_tau10_distance.dat','w')
    for i in range(731):
        for j in range(i+1,732):
            lat1=nodes[:,0][i]
            lon1=nodes[:,1][i]
            lat2=nodes[:,0][j]
            lon2=nodes[:,1][j]
            dis=circledis(lat1,lat2,lon1,lon2)
            if(math.isnan(dis) is True):
                print (i,j,lat1,lat2,lon1,lon2)
            outfile.write('%.6f \n'%(dis))
            outfile.flush()
    outfile.close()
    






    
def plotmap():
    regrid=np.loadtxt(path+'globe_732.dat')
    regrid1=np.loadtxt(path+'globe_726.dat')
    ax=plt.plot()
    nodes=np.arange(len(regrid))
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,45.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=34,linewidth=3)


    lats1=np.array(regrid[:,0][nodes])      
    lons1=np.array(regrid[:,1][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
  #  color=sign[:,1]
    m.scatter(x,y,5,marker='o',c='crimson')
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(18, 16)    


def  arctic_T():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    # data = Dataset('/home/meng/bak_bupt/newproj/data/enso/global_1000hpa_1959_2022_day0h.nc','r',format='NETCDF4')
    # data = Dataset('/home/meng/bak_bupt/newproj/data/2m_temperature_global.nc')
    # air_data=data.variables['t2m'][:]
    # a1="/home/meng/bak_bupt/newproj/data/global_ERA5_1979to2021_1000hpa_daily_ano.ano"
    # a1="/home/meng/bak_bupt/newproj/data/global_ERA5_1979to2021_t2m_daily_ano.ano"
    
    
    
    path='/home/meng/bak_bupt/newproj/data/'
    DATA = Dataset('/home/meng/bak_bupt/newproj/data/2m_temperature_global.nc')
    
    regrid=np.loadtxt(path+'nonzeroicenodes.dat')

    
  #  DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t2m'][:]
    fileout=open(path+'t2m_ori_377.ano','w')         
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
 
    for n1 in range(len(regrid)):
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        # day_x = data1[:,day][20:YEAR_NUMBER2]
                        # day_ave=np.average(day_x)
                        # day_std = np.std(day_x)
                        # fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
                        fileout.write('%.6f\n' % (data1[year][day] ))

    fileout.close()

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY-1):
                        day_x = data1[:,day][year]
                        day_y = data1[:,day+1][year]
                        delta=day_y-day_x
                        fileout.write('%.6f\n' % ((np.abs(delta))))
                        fileout.flush()
                
    fileout.close()     

def  glbaol_Tdiff():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
  
    path='/home/meng/bak_bupt/newproj/data/'
    
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')

    
    DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t'][:]
    fileout=open(path+'t850_changes_8040.ano','w')         
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
 
    for n1 in range(len(regrid)):
            lati=regrid[:,1][n1]
            loni=regrid[:,2][n1]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY-1):
                        day_x = data1[:,day][year]
                        day_y = data1[:,day+1][year]
                        delta=day_y-day_x
                        fileout.write('%.6f\n' % ((np.abs(delta))))
                        fileout.flush()
                
    fileout.close()          
           
def autow_ori_global():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/global_1000hpa_1959_2022_day0h.nc','r',format='NETCDF4')
    air_data=data.variables['t'][:]
    a1="/home/meng/bak_bupt/newproj/data/enso/global_ERA5_1959to2021_1000hpa_daily_autowlag4.ano"
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4

    fileout = open(a1, "w")
    for j in range(73):
        print (j)
        for i in range(144):
            ii=i+21
            if(ii>143):
                lonx=list(np.arange(i,143))+list(np.arange(ii-144))
            else:
                lonx=np.arange(i,ii)
            if(j<36):
                jj=j+5
                latx=np.arange(j,jj)
            if(j>36):
                jj=j-5
                latx=np.arange(jj,j)
            if(j==36):
                latx=np.arange(j-2,j+2)
            datax=[]
            for iii in latx:
                for jjj in lonx:
                    data1 = np.zeros(YEAR_NUMBER2*365)
                    n=0         
                    days=0
                    for year in range(1959,2022):
                        
                        if(year%4==0 and year%100!=0) or (year%400==0):
                            months[1]=29
                            d=366
                        else:
                            months[1]=28
                            d=365
        
                       
                        days+=d
                        s1=days-d
                        s2=days
                        data=air_data[s1:s2,iii,jjj]
                        if(d==366):
                            data=np.delete(data,data_del_idx) # del the data of feb 29th
                        for x in data:
                            n+=1
                            data1[n-1]=x
                        datax.append(data1)
            yx=[]
            for node in range(105):
               # print (node)
                #r=np.std(T[node])*0.2
                zx=[]
                for year in range(1960,2021):
                    for mon in range(12):
                    #for month in range(1,13):
                        s1=365*(year-1959)+mon*30
                        s2=s1+365
                       # for nodes in range(8040):
                        dataV=datax[node][s1-taux:s2]
                        #f, Pxx_den = signal.welch(x, fs, nperseg=m)
                        #print (sum(Pxx_den))
                        jj=autowx(dataV,taux,taux,taux+365)
                        yx.append(jj)
            yx=np.reshape(yx,(105,732))
            for kk in range(732):
                fileout.write('%.6f \n'%(np.mean(yx[:,kk])))
                fileout.flush()
        
    fileout.close()


          
    
def readdata_ano():
    
    a1="/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021.ano"
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1

    fileout = open(a1, "w")
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/nino34_1000hpa_1959_2021_day0h.nc','r',format='NETCDF4')
    air_data=data.variables['t'][:]
    for i in range(5):
        print (i)
        for j in range(21):
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(YEAR_NUMBER2):
                if(year<5):
                    for day in range(DAY):
                        day_x = data1[:,day][:5]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))   
                else:
                    for day in range(DAY):
                        day_x = data1[:,day][:year+1]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               
    fileout.close()
    
    
def readdata_hpf():
    
    a1="/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021_hpf10d.ano"
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1

    fileout = open(a1, "w")
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/nino34_1000hpa_1959_2021_day0h.nc','r',format='NETCDF4')
    air_data=data.variables['t'][:]
    for i in range(5):
        print (i)
        for j in range(21):
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x



            
            fftx=np.fft.fft(data1)
            fftx[:2299]=0
            fftx[22995-2300:]=0
            data2=np.real(np.fft.ifft(fftx))
            for k in range(22995):
                fileout.write('%.6f \n'%(data2[k]))
                fileout.flush()
    fileout.close()
#################################################################################3
    loopx=[59*24+i for i in range(24)]
    outfile=open('/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021_hourly_hpf30d.ano','w')
    for i in range(5):
        print (i)
        for j in range(21):  
            print (j)
            for year in range(1959,2022):
               # print (year)
                data = Dataset("/home/meng/bak_bupt/newproj/data/enso/nino34_t1000_"+str(year)+"_1959_2022""_hourly.nc",'r',format='NETCDF4')
                air_data=data.variables['t'][:,i,j]
                if(len(air_data))==366*24:
                    air_data=np.delete(air_data,loopx)
                   # print (year)
                data1=air_data
                fftx=np.fft.fft(data1)
                fftx[:18396]=0
                fftx[22995*24-18397:]=0
                data2=np.real(np.fft.ifft(fftx))
                for h in range(365*24):
                    outfile.write('%.6f \n'%(data2[h]))
                    outfile.flush()
    outfile.close()
        


def readdata_lpf():
    
    a1="/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021_lpf25d.ano"
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1

    fileout = open(a1, "w")
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/nino34_1000hpa_1959_2021_day0h.nc','r',format='NETCDF4')
    air_data=data.variables['t'][:]
    for i in range(5):
        print (i)
        for j in range(21):
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x



            
            fftx=np.fft.fft(data1)
            fftx[919:22995-920]=0
#            fftx[:511]=0
#            fftx[22995-512:]=0
            data2=np.real(np.fft.ifft(fftx))
            for k in range(22995):
                fileout.write('%.6f \n'%(data2[k]))
                fileout.flush()
    fileout.close()



def readdata_bandpf():
    
    a1="/home/meng/bak_bupt/newproj/data/enso/NINO34_ERA5_1959to2021_45d_73d.ano"
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1

    fileout = open(a1, "w")
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    data = Dataset('/home/meng/bak_bupt/newproj/data/enso/nino34_1000hpa_1959_2021_day0h.nc','r',format='NETCDF4')
    air_data=data.variables['t'][:]
    for i in range(5):
        print (i)
        for j in range(21):
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x



            
            fftx=np.fft.fft(data1)
            fftx[511:22995-512]=0
            fftx[:315]=0
            fftx[22995-316:]=0
            data2=np.real(np.fft.ifft(fftx))
            for k in range(22995):
                fileout.write('%.6f \n'%(data2[k]))
                fileout.flush()
    fileout.close()

def readdata_monthly():
    from netCDF4 import Dataset
    import numpy as np
    
    def anualave(x,n):
        x1=np.reshape(x,(n,12))
        x2=[np.mean(x1[:,i]) for i in range(12)]
        return x2
    def anualstd(x,n):
        x1=np.reshape(x,(n,12))
        x2=[np.std(x1[:,i]) for i in range(12)]
        return x2
    
    
    
    data1=Dataset('/home/meng/bak_bupt/newproj/data/nino34_10u10v_negogl_1959_2022_monthly.nc','r',format='NETCDF4')
    
    u10x=data1.variables['u10'][:]
    v10x=data1.variables['v10'][:]
    cpx=data1.variables['cp'][:]
    oglx=data1.variables['ttr'][:]
    u10index=[np.mean(u10x[i,:,:]) for i in range(756)]
    v10index=[np.mean(v10x[i,:,:]) for i in range(756)]
    windindex=[u10index[i]*u10index[i]+v10index[i]*v10index[i] for i in range(len(u10index))]
    cpindex=[np.mean(cpx[i,:,:]) for i in range(756)]
    oglindex=[np.mean(oglx[i,:,:]) for i in range(756)]
    eys=[1963,1965,1968,1969,1972,1976,1977,1979,1982,1986,1991,1994,1997,2002,2004,2006,2009,2014,2018]
    magey=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/eys')
    mageys=magey[:,1][:]        
    eysn=[i-1960 for i in eys] 
    y0=cdirindex
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/monthly_cdir_mag_1960_2020_yearlyave.dat",'w')
    y=[]
    for yr in range(1960,2021):
        for mon in range(12):
            s1=(yr-1959)*12+mon
            s2=s1-12
            y.append(np.mean(y0[s2:s1]))
            outfile.write('%.6f %.6f \n'%(yr+mon/12.,np.mean(y0[s2:s1])))
            outfile.flush()
    outfile.close()
        
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/monthly_cdir_vs_mageys_1959_2021.dat",'w')
    rx=[]
    rx1=[]
    for mon in range(-36,13):
        z=[]
        for yr in eysn:
            n=yr*12+mon
            #print (n)
            z.append(y[n])
        r=pearsonr(z,mageys)[0]
        p=pearsonr(z,mageys)[1]
        r1=pearsonr(z[7:],mageys[7:])[0]
        p1=pearsonr(z[7:],mageys[7:])[1]
        print (mon,r,p,r1,p1)
        rx.append(pearsonr(z,mageys)[0])
        rx1.append(pearsonr(z[7:],mageys[7:])[0])
        outfile.write('%d %.6f %.6f %.6f %.6f \n'%(mon+12,r,r1,p,p1))
        outfile.flush()
    outfile.close()
    plt.plot(months,rx)    
    
    
    outfile=open('/home/meng/bak_bupt/newproj/data/nino_u10_monthly.dat','w')
    for k in range(len(nodes)):
        print (k)
        i=int(lats[k])
        j=int(lons[k])
        x=ogl[:,i,j]
        y=anualstd(x, 40)
        z=anualave(x, 40)    
        for q in range(len(x)):
            q1=int(q/12)
            q2=q%12
            x1=(x[q]-y[q2])/z[q2]
            outfile.write('%.6f \n'%(x1))
            outfile.flush()
    outfile.close()
    
    
    
    
    data1=Dataset('/home/meng/bak_bupt/newproj/data/ogl_era5_monthly.nc','r',format='NETCDF4')
    
    
    
    ogl=data1.variables['ttr'][12:492,:,:]
    
    outfile=open('/home/meng/bak_bupt/newproj/data/nino_ogl_monthly.dat','w')
    
    for i in range(34,39):
        for j in range(76,97):
            x=ogl[:,i,j]
            y=anualstd(x, 40)
            z=anualave(x, 40)    
            for q in range(len(x)):
                q1=int(q/12)
                q2=q%12
                x1=(x[q]-y[q2])/z[q2]
                outfile.write('%.6f \n'%(x1))
                outfile.flush()
    outfile.close()



############################################################################################################
def yearly_global():
    data=Dataset('/home/meng/bak_bupt/newproj/data/enso/global_monthly.nc','r',format='NETCDF4')
    t2m=data.variables['t2m'][:]    #2 metre temperature
    cp=data.variables['cp'][:]      # Convective precipitation
    sst=data.variables['sst'][:]    # Sea surface Temperature
    cdir=data.variables['cdir'][:]  #Clear-sky direct solar radiation at surface
    crr=data.variables['crr'][:]    #Convective rain rate
    uvb=data.variables['uvb'][:]   #Downward UV radiation at the surface
    ee=data.variables['e'][:]      #Evaporation
    lsp=data.variables['lsp'][:]   #Large-scale precipitation
    msl=data.variables['msl'][:]  #Mean sea level pressure
    tp=data.variables['tp'][:]   #Total precipitation
    eys=[1963,1965,1968,1969,1972,1976,1977,1979,1982,1986,1991,1994,1997,2002,2004,2006,2009,2014,2018]
    magey=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/eys')
    mageys=magey[:,1][:]        
    eysn=[i-1960 for i in eys] 
    eyonset=12*(np.array(magey[:,0])-1960)
    eyonset=np.round(eyonset)
    eyonset=np.array([int(i) for i in eyonset])
    eyp=12*(np.array(magey[:,3])-1960)
    eyp=np.round(eyp)
    eyp=np.array([int(i) for i in eyp])      

##############################################################################################    
    cdirindex=[np.mean(cdir[i,:,:]) for i in range(756)]
    uvbindex=[np.mean(uvb[i,:,:]) for i in range(756)]
    y0=uvbindex
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/monthly_lsp_mag_1960_2020_yearlyave.dat",'w')
    y=[]
    for yr in range(1960,2021):
        for mon in range(12):
            s1=(yr-1959)*12+mon
            s2=s1-12
            y.append(np.mean(y0[s2:s1]))
            outfile.write('%.6f %.6f \n'%(yr+mon/12.,np.mean(y0[s2:s1])))
            outfile.flush()
    outfile.close()
        
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/monthly_lsp_vs_mageys_1959_2021.dat",'w')
    rx=[]
    rx1=[]
    for mon in range(-36,13):
        z=[]
        for yr in eysn:
            n=yr*12+mon
            #print (n)
            z.append(y[n])
        r=pearsonr(z,mageys)[0]
        p=pearsonr(z,mageys)[1]
        r1=pearsonr(z[7:],mageys[7:])[0]
        p1=pearsonr(z[7:],mageys[7:])[1]
        print (mon,r,p,r1,p1)
        rx.append(pearsonr(z,mageys)[0])
        rx1.append(pearsonr(z[7:],mageys[7:])[0])
        outfile.write('%d %.6f %.6f %.6f %.6f \n'%(mon+12,r,r1,p,p1))
        outfile.flush()
    outfile.close()
    plt.plot(months,rx)     
    
    
####################################################################################    
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave.dat",'w')
    outfile1=open("/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mag_1960_2020.dat",'w')
    outfile2=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_vs_mag_1960_2020_period.dat",'w')
      
    for j in range(73):
        print (j)
        for  i in range(144):

            #print (i)
            ii=i+21
            if(ii>143):
                lonx=list(np.arange(i,143))+list(np.arange(ii-144))
            else:
                lonx=np.arange(i,ii)
            if(j<36):
                jj=j+5
                latx=np.arange(j,jj)
            if(j>36):
                jj=j-5
                latx=np.arange(jj,j)
            if(j==36):
                latx=np.arange(j-2,j+2)
            
            y0=[np.mean(cp[k,latx,:][:,lonx]) for k in range(756)]
            y=[]
            for yr in range(1960,2021):
                for mon in range(12):
                    s1=(yr-1959)*12+mon
                    s2=s1-12
                    y.append(np.mean(y0[s2:s1]))
                    outfile.write('%.6f \n'%(np.mean(y0[s2:s1])))
                    outfile.flush()
                    
            
         
            for mon in range(-36,13):
                z=[]
                for yr in eysn:
                    n=yr*12+mon
                    #print (n)
                    z.append(y[n])
                r=pearsonr(z,mageys)[0]
                p=pearsonr(z,mageys)[1]
                z1=[]
                for yr in eyonset:
                    n=yr+mon
                    #print (n)
                    z1.append(y[n])
                r1=pearsonr(z1,mageys)[0]
                p1=pearsonr(z1,mageys)[1]      
                z2=[]
                for yr in eyp:
                    n=yr+mon
                    #print (n)
                    z2.append(y[n])
                r2=pearsonr(z2,mageys)[0]
                p2=pearsonr(z2,mageys)[1] 
                
                
                
                outfile1.write('%.6f %.6f %.6f %.6f %.6f %.6f \n'%(r,r1,r2,p,p1,p2))
                outfile1.flush()
                
          
            
         
            for mon in range(-36,13):
                z=[]
                for yr in eysn:
                    n=yr*12+mon
                    #print (n)
                    z.append(y[n])
                r=pearsonr(z,mageys)[0]
                p=pearsonr(z,mageys)[1]
             
                r1=pearsonr(z[:10],mageys[:10])[0]
                p1=pearsonr(z[:10],mageys[:10])[1]      
              
                r2=pearsonr(z[-10:],mageys[-10:])[0]
                p2=pearsonr(z[-10:],mageys[-10:])[1] 
                
                
                outfile2.write('%.6f %.6f %.6f %.6f %.6f %.6f \n'%(r,r1,r2,p,p1,p2))
                outfile2.flush()               
                
    outfile.close()
    outfile1.close()
    outfile2.close()
        
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/glboal_covection_precipitaion_vs_mageys_1960_2020.dat')
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/glboal_mean_sea_level_pressure_vs_mageys_1960_2020.dat')    

    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/glboal_2mt_vs_mageys_1960_2020.dat')  
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave_singlenode.dat')  
    
    rx=np.reshape(data[:,0],(10512,49))
    px=np.reshape(data[:,3],(10512,49))
    rx1=np.reshape(data[:,1],(10512,49))
    px1=np.reshape(data[:,4],(10512,49))
    rx2=np.reshape(data[:,2],(10512,49))
    px2=np.reshape(data[:,5],(10512,49))

    rx = np.where(np.isnan(rx), 0, rx)
    px = np.where(np.isnan(px), 1, px)
    rx1 = np.where(np.isnan(rx1), 0, rx1)
    px1 = np.where(np.isnan(px1), 1, px1)
    rx2 = np.where(np.isnan(rx2), 0, rx2)
    px2 = np.where(np.isnan(px2), 1, px2)
    
    
    
    nodes=np.arange(10512)
    latx=[]
    lonx=[]
    for i in range(73):
        for j in range(144):
            lat=90-i*2.5
            lon=j*2.5
            latx.append(lat)
            lonx.append(lon)
    for shift in range(49):
        nodes=np.arange(10512)
        m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
        signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
               
        lats1=latx
        lons1=lonx
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx[:,shift]
        m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
    #    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # cb.set_label(label='Correlation to AO', size=34, weight='bold')
        cb.ax.tick_params(labelsize=56)
        
        plt.clim(-0.6,0.6)
        signodes=[i for i in range(10512) if (px[:,shift][i]<0.05)]
        nn=(len(signodes))
        if(len(signodes)!=0):
            lats1=np.array(latx)[signodes]
            lons1=np.array(lonx)[signodes]
            x, y = m(lons1,lats1)
            
                #lats1=np.array(lats1)
                #lons1=np.array(lons1)
            m.scatter(x,y,150,marker='x',c='k')
           # ax.colorbar(im, fraction=0.046, pad=0.04)  
            #plt.colorbar() 
        plt.title('$r_{'+str(shift-36)+'}$ and $N='+str(nn)+'$',fontsize=66) #annual
          
        
        # plt.annotate('(d)', xy=(-0.03,1.05), xycoords='axes fraction', fontsize=72,
        #                      xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
        #                      ha='left', va='bottom')  
        plt.subplots_adjust(top = 0.96, bottom = 0.04, right = 0.90, left = 0.08, 
                    hspace = 0.1, wspace = 0.3)   
        
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(30,25)
        plt.savefig("/home/meng/bak_bupt/newproj/fig/cp_vs_mag_shift"+str(shift-36)+"mon_season_singlenodes.png")
        plt.close()


#########333333333333333333333333333

    outfile2=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave_singlenode.dat",'w')

    for j in range(73):
        print (j)
        for  i in range(144):
            y=[]
            for yr in range(1960,2021):
                for mon in range(12):
                    s1=(yr-1959)*12+mon
                    s2=s1-12
                    y.append(np.mean(cp[s2:s1,j,i]))
                  
                    
            
         
            for mon in range(-36,13):
                z=[]
                for yr in eysn:
                    n=yr*12+mon
                    #print (n)
                    z.append(y[n])
                r=pearsonr(z,mageys)[0]
                p=pearsonr(z,mageys)[1]
                z1=[]
                for yr in eyonset:
                    n=yr+mon
                    #print (n)
                    z1.append(y[n])
                r1=pearsonr(z1,mageys)[0]
                p1=pearsonr(z1,mageys)[1]      
                z2=[]
                for yr in eyp:
                    n=yr+mon
                    #print (n)
                    z2.append(y[n])
                r2=pearsonr(z2,mageys)[0]
                p2=pearsonr(z2,mageys)[1] 
                
                
                outfile2.write('%.6f %.6f %.6f %.6f %.6f %.6f \n'%(r,r1,r2,p,p1,p2))
                outfile2.flush()               
                

    outfile2.close()


    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave_singlenode.dat')  
    
    rx=np.reshape(data[:,0],(10512,49))
    px=np.reshape(data[:,3],(10512,49))
    rx1=np.reshape(data[:,1],(10512,49))
    px1=np.reshape(data[:,4],(10512,49))
    rx2=np.reshape(data[:,2],(10512,49))
    px2=np.reshape(data[:,5],(10512,49))

    rx = np.where(np.isnan(rx), 0, rx)
    px = np.where(np.isnan(px), 0, px)
    rx1 = np.where(np.isnan(rx1), 0, rx1)
    px1 = np.where(np.isnan(px1), 0, px1)
    rx2 = np.where(np.isnan(rx2), 0, rx2)
    px2 = np.where(np.isnan(px2), 0, px2)
    
    
    
    nodes=np.arange(10512)
    latx=[]
    lonx=[]
    for i in range(73):
        for j in range(144):
            lat=90-i*2.5
            lon=j*2.5
            latx.append(lat)
            lonx.append(lon)
    for shift in range(49):
        nodes=np.arange(10512)
        m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
        signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
               
        lats1=latx
        lons1=lonx
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx2[:,shift]
        m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
    #    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # cb.set_label(label='Correlation to AO', size=34, weight='bold')
        cb.ax.tick_params(labelsize=56)
        
        plt.clim(-0.6,0.6)
        signodes=[i for i in range(10512) if (px2[:,shift][i]<0.05)]
        nn=(len(signodes))
        if(len(signodes)!=0):
            lats1=np.array(latx)[signodes]
            lons1=np.array(lonx)[signodes]
            x, y = m(lons1,lats1)
            
                #lats1=np.array(lats1)
                #lons1=np.array(lons1)
            m.scatter(x,y,150,marker='x',c='k')
           # ax.colorbar(im, fraction=0.046, pad=0.04)  
            #plt.colorbar() 
        plt.title('$r_{'+str(shift-36)+'}$ and $N='+str(nn)+'$',fontsize=66) #annual
          
        
        # plt.annotate('(d)', xy=(-0.03,1.05), xycoords='axes fraction', fontsize=72,
        #                      xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
        #                      ha='left', va='bottom')  
        plt.subplots_adjust(top = 0.96, bottom = 0.04, right = 0.90, left = 0.08, 
                    hspace = 0.1, wspace = 0.3)   
        
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(30,25)
        plt.savefig("/home/meng/bak_bupt/newproj/fig/singlenode_cp_vs_mag_shift"+str(shift-36)+"mon_peak.png")
        plt.close()


########################################################################################################33


    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/global_cp_vs_mag_1960_2020_period.dat')  
    
    rx=np.reshape(data[:,0],(10512,49))
    px=np.reshape(data[:,3],(10512,49))
    rx1=np.reshape(data[:,1],(10512,49))
    px1=np.reshape(data[:,4],(10512,49))
    rx2=np.reshape(data[:,2],(10512,49))
    px2=np.reshape(data[:,5],(10512,49))

    rx = np.where(np.isnan(rx), 0, rx)
    px = np.where(np.isnan(px), 1, px)
    rx1 = np.where(np.isnan(rx1), 0, rx1)
    px1 = np.where(np.isnan(px1), 1, px1)
    rx2 = np.where(np.isnan(rx2), 0, rx2)
    px2 = np.where(np.isnan(px2), 1, px2)
    
    
    
    
    
    nodes=np.arange(10512)
    latx=[]
    lonx=[]
    for i in range(73):
        for j in range(144):
            lat=90-i*2.5
            lon=j*2.5
            latx.append(lat)
            lonx.append(lon)
    for shift in range(49):
        nodes=np.arange(10512)
        m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
        signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
               
        lats1=latx
        lons1=lonx
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx1[:,shift]
        m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
    #    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # cb.set_label(label='Correlation to AO', size=34, weight='bold')
        cb.ax.tick_params(labelsize=56)
        
        plt.clim(-0.6,0.6)
        signodes=[i for i in range(10512) if (px2[:,shift][i]<0.05 and px1[:,shift][i]<0.05 and px[:,shift][i]<0.05)]
        nn=(len(signodes))
        if(len(signodes)!=0):
            lats1=np.array(latx)[signodes]
            lons1=np.array(lonx)[signodes]
            x, y = m(lons1,lats1)
            
                #lats1=np.array(lats1)
                #lons1=np.array(lons1)
            m.scatter(x,y,150,marker='x',c='k')
           # ax.colorbar(im, fraction=0.046, pad=0.04)  
            #plt.colorbar() 
        plt.title('$r_{'+str(shift-36)+'}$ and $N='+str(nn)+'$',fontsize=66) #annual
          
        
        # plt.annotate('(d)', xy=(-0.03,1.05), xycoords='axes fraction', fontsize=72,
        #                      xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
        #                      ha='left', va='bottom')  
        plt.subplots_adjust(top = 0.96, bottom = 0.04, right = 0.90, left = 0.08, 
                    hspace = 0.1, wspace = 0.3)   
        
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(30,25)
        plt.savefig("/home/meng/bak_bupt/newproj/fig/cp_vs_mag_shift"+str(shift-36)+"mon_onset_period.png")
        plt.close()

    
def monthly_global():
    data=Dataset('/home/meng/bak_bupt/newproj/data/enso/global_monthly.nc','r',format='NETCDF4')
    t2m=data.variables['t2m'][:]    #2 metre temperature
    cp=data.variables['cp'][:]      # Convective precipitation
    sst=data.variables['sst'][:]    # Sea surface Temperature
    cdir=data.variables['cdir'][:]  #Clear-sky direct solar radiation at surface
    crr=data.variables['crr'][:]    #Convective rain rate
    uvb=data.variables['uvb'][:]   #Downward UV radiation at the surface
    ee=data.variables['e'][:]      #Evaporation
    lsp=data.variables['lsp'][:]   #Large-scale precipitation
    msl=data.variables['msl'][:]  #Mean sea level pressure
    tp=data.variables['tp'][:]   #Total precipitation
    eys=[1963,1965,1968,1969,1972,1976,1977,1979,1982,1986,1991,1994,1997,2002,2004,2006,2009,2014,2018]
    magey=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/eys')
    mageys=magey[:,1][:]        
    eysn=[i-1960 for i in eys] 
    eyonset=12*(np.array(magey[:,0])-1960)
    eyonset=np.round(eyonset)
    eyonset=np.array([int(i) for i in eyonset])
    eyp=12*(np.array(magey[:,3])-1960)
    eyp=np.round(eyp)
    eyp=np.array([int(i) for i in eyp])      
    outfile=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_monthlyave.dat",'w')
    outfile1=open("/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mageys_1960_2020_monthlyave.dat",'w')
    
  
    for j in range(73):
        print (j)
        for  i in range(144):
            #print (i)
            ii=i+21
            if(ii>143):
                lonx=list(np.arange(i,143))+list(np.arange(ii-144))
            else:
                lonx=np.arange(i,ii)
            if(j<36):
                jj=j+5
                latx=np.arange(j,jj)
            if(j>36):
                jj=j-5
                latx=np.arange(jj,j)
            if(j==36):
                latx=np.arange(j-2,j+2)
            
            y0=[np.mean(cp[k,latx,:][:,lonx]) for k in range(756)]
            y=[]
            for yr in range(1960,2021):
                for mon in range(12):
                    s1=(yr-1959)*12+mon
                    y.append(y0[s1])
                    outfile.write('%.6f \n'%(y0[s1]))
                    outfile.flush()
                    
            
         
            for mon in range(-36,13):
                z=[]
                for yr in eysn:
                    n=yr*12+mon
                    #print (n)
                    z.append(y[n])
                r=pearsonr(z,mageys)[0]
                p=pearsonr(z,mageys)[1]
                z1=[]
                for yr in eyonset:
                    n=yr+mon
                    #print (n)
                    z1.append(y[n])
                r1=pearsonr(z1,mageys)[0]
                p1=pearsonr(z1,mageys)[1]      
                z2=[]
                for yr in eyp:
                    n=yr+mon
                    #print (n)
                    z2.append(y[n])
                r2=pearsonr(z2,mageys)[0]
                p2=pearsonr(z2,mageys)[1] 
                
             
                outfile1.write('%.6f %.6f %.6f %.6f %.6f %.6f \n'%(r,r1,r2,p,p1,p2))
                outfile1.flush()
    outfile.close()
    outfile1.close()
        
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mageys_1960_2020_monthlyave.dat')
    
    
    rx=np.reshape(data[:,0],(10512,49))
    px=np.reshape(data[:,3],(10512,49))
    rx1=np.reshape(data[:,1],(10512,49))
    px1=np.reshape(data[:,4],(10512,49))
    rx2=np.reshape(data[:,2],(10512,49))
    px2=np.reshape(data[:,5],(10512,49))

    rx = np.where(np.isnan(rx), 0, rx)
    px = np.where(np.isnan(px), 0, px)
    rx1 = np.where(np.isnan(rx1), 0, rx1)
    px1 = np.where(np.isnan(px1), 0, px1)
    rx2 = np.where(np.isnan(rx2), 0, rx2)
    px2 = np.where(np.isnan(px2), 0, px2)
    
    
    nodes=np.arange(10512)
    latx=[]
    lonx=[]
    for i in range(73):
        for j in range(144):
            lat=90-i*2.5
            lon=j*2.5
            latx.append(lat)
            lonx.append(lon)
    for shift in range(49):
        nodes=np.arange(10512)
        m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
        signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
               
        lats1=latx
        lons1=lonx
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx[:,shift]
        m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
    #    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # cb.set_label(label='Correlation to AO', size=34, weight='bold')
        cb.ax.tick_params(labelsize=56)
        
        plt.clim(-0.8,0.8)
        signodes=[i for i in range(10512) if (px[:,shift][i]<0.05)]
        print (len(signodes))
        lats1=np.array(latx)[signodes]
        lons1=np.array(lonx)[signodes]
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        m.scatter(x,y,150,marker='x',c='k')
           # ax.colorbar(im, fraction=0.046, pad=0.04)  
            #plt.colorbar() 
        plt.title('$r_{'+str(shift-36)+'N'+str(len(signodes))+'}$',fontsize=66) #annual
          
        
        # plt.annotate('(d)', xy=(-0.03,1.05), xycoords='axes fraction', fontsize=72,
        #                      xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
        #                      ha='left', va='bottom')  
        plt.subplots_adjust(top = 0.96, bottom = 0.04, right = 0.90, left = 0.08, 
                    hspace = 0.1, wspace = 0.3)   
        
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(30,25)
        plt.savefig("/home/meng/bak_bupt/newproj/fig/cp_vs_mag_shift"+str(shift-36)+"mon_season_monthlyave.png")
        plt.close()



def yearly_global_shuffle():
    data=Dataset('/home/meng/bak_bupt/newproj/data/enso/global_monthly.nc','r',format='NETCDF4')
    t2m=data.variables['t2m'][:]    #2 metre temperature
    cp=data.variables['cp'][:]      # Convective precipitation
    sst=data.variables['sst'][:]    # Sea surface Temperature
    cdir=data.variables['cdir'][:]  #Clear-sky direct solar radiation at surface
    crr=data.variables['crr'][:]    #Convective rain rate
    uvb=data.variables['uvb'][:]   #Downward UV radiation at the surface
    ee=data.variables['e'][:]      #Evaporation
    lsp=data.variables['lsp'][:]   #Large-scale precipitation
    msl=data.variables['msl'][:]  #Mean sea level pressure
    tp=data.variables['tp'][:]   #Total precipitation
    eys=[1963,1965,1968,1969,1972,1976,1977,1979,1982,1986,1991,1994,1997,2002,2004,2006,2009,2014,2018]
    magey=np.loadtxt('/home/meng/bak_bupt/newproj/data/enso/eys')
    mageys=magey[:,1][:]        
    eysn=[i-1960 for i in eys] 
    eyonset=12*(np.array(magey[:,0])-1960)
    eyonset=np.round(eyonset)
    eyonset=np.array([int(i) for i in eyonset])
    eyp=12*(np.array(magey[:,3])-1960)
    eyp=np.round(eyp)
    eyp=np.array([int(i) for i in eyp])  
    outfile0=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave_shuffle_sign.dat",'w')
    nx=[]
    for stime in range(100):   
        print (stime)
       # outfile=open("/home/meng/bak_bupt/newproj/data/enso/global_cp_mag_1960_2020_yearlyave_shuffle"+str(stime)+".dat",'w')
       # outfile1=open("/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mageys_1960_2020_shuffle"+str(stime)+"_SIGN.dat",'w')

        np.random.shuffle(mageys)
        for mon in range(1):
            print (mon)
            N=0
            N1=0
            N2=0
            rx=[]
            px=[]
            for j in range(0,73,5):
                print (j)
                for  i in range(0,144,10):
                    #print (i)
                    ii=i+21
                    if(ii>143):
                        lonx=list(np.arange(i,143))+list(np.arange(ii-144))
                    else:
                        lonx=np.arange(i,ii)
                    if(j<36):
                        jj=j+5
                        latx=np.arange(j,jj)
                    if(j>36):
                        jj=j-5
                        latx=np.arange(jj,j)
                    if(j==36):
                        latx=np.arange(j-2,j+2)
                    
                    y0=[np.mean(cp[k,latx,:][:,lonx]) for k in range(756)]
                    y=[]
                    for yr in range(1960,2021):
                        for mons in range(12):
                            s1=(yr-1959)*12+mons
                            s2=s1-12
                            y.append(np.mean(y0[s2:s1]))
                         #   outfile.write('%.6f \n'%(np.mean(y0[s2:s1])))
                          #  outfile.flush()
                        
                
             
              #  for mon in range(-36,13):
                    z=[]
                    for yr in eysn:
                        n=yr*12+mon
                        #print (n)
                        z.append(y[n])
                    r=pearsonr(z,mageys)[0]
                    p=pearsonr(z,mageys)[1]
                    rx.append(r)
                    px.append(p)
                    if(p<0.05):
                        N+=1
                    z1=[]
                    for yr in eyonset:
                        n=yr+mon
                        #print (n)
                        z1.append(y[n])
                    r1=pearsonr(z1,mageys)[0]
                    p1=pearsonr(z1,mageys)[1]      
                    if(p1<0.05):
                        N1+=1
                    z2=[]
                    for yr in eyp:
                        n=yr+mon
                        #print (n)
                        z2.append(y[n])
                    r2=pearsonr(z2,mageys)[0]
                    p2=pearsonr(z2,mageys)[1] 
                    if(p2<0.05):
                        N2+=1
                    
            print (N,N1,N2)      
            nx.append(N)
            outfile0.write('%d %d %d %d \n'%(mon,N,N1,N2))
            outfile0.flush()
    outfile0.close()
        
        data=np.loadtxt("/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mageys_1960_2020_shuffle.dat"+str(stime)+"")
        
      
        
        rx=np.reshape(data[:,0],(10512,49))
        px=np.reshape(data[:,3],(10512,49))
        rx1=np.reshape(data[:,1],(10512,49))
        px1=np.reshape(data[:,4],(10512,49))
        rx2=np.reshape(data[:,2],(10512,49))
        px2=np.reshape(data[:,5],(10512,49))
        
        rx = np.where(np.isnan(rx), 0, rx)
        px = np.where(np.isnan(px), 0, px)
        rx1 = np.where(np.isnan(rx1), 0, rx1)
        px1 = np.where(np.isnan(px1), 0, px1)
        rx2 = np.where(np.isnan(rx2), 0, rx2)
        px2 = np.where(np.isnan(px2), 0, px2)
        
        x=[np.mean(abs(rx[:,i])) for i in range(49)]
        x1=[np.mean(abs(rx1[:,i])) for i in range(49)]
        x2=[np.mean(abs(rx2[:,i])) for i in range(49)]
        for kk in range(49):
            outfile0.write('%.6f %.6f %.6f \n'%(x[kk],x1[kk],x2[kk]))
            outfile0.flush()
    outfile.close()
            
    
    data=np.loadtxt("/home/meng/bak_bupt/newproj/data/enso/glboal_cp_vs_mageys_1960_2020_shuffle.dat"+str(stime)+"")
        
      
        
    rx=np.reshape(data[:,0],(10512,49))
    px=np.reshape(data[:,3],(10512,49))
    rx1=np.reshape(data[:,1],(10512,49))
    px1=np.reshape(data[:,4],(10512,49))
    rx2=np.reshape(data[:,2],(10512,49))
    px2=np.reshape(data[:,5],(10512,49))
        
    rx = np.where(np.isnan(rx), 0, rx)
    px = np.where(np.isnan(px), 0, px)
    rx1 = np.where(np.isnan(rx1), 0, rx1)
    px1 = np.where(np.isnan(px1), 0, px1)
    rx2 = np.where(np.isnan(rx2), 0, rx2)
    px2 = np.where(np.isnan(px2), 0, px2)    
    nodes=np.arange(10512)
    latx=[]
    lonx=[]
    for i in range(73):
        for j in range(144):
            lat=90-i*2.5
            lon=j*2.5
            latx.append(lat)
            lonx.append(lon)
    for shift in range(49):
        nodes=np.arange(10512)
        m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m.drawcoastlines(linewidth = 3)
        
        m.drawparallels(np.arange(-90.,120.,45.),labels=[True,False,False,False],fontsize=56,linewidth=3,rotation=-45)
        m.drawmeridians(np.arange(0.,360.,120.),labels=[False,False,False,True],fontsize=56,linewidth=3,rotation=20)
        signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
               
        lats1=latx
        lons1=lonx
        x, y = m(lons1,lats1)
        
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
        color=rx2[:,shift]
        m.scatter(x,y,150,marker='o',c=color,cmap='RdBu')
    #    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
        cb=plt.colorbar(fraction=0.025,pad=0.06,extend='both')
       # cb.set_label(label='Correlation to AO', size=34, weight='bold')
        cb.ax.tick_params(labelsize=56)
        
        plt.clim(-0.6,0.6)
        signodes=[i for i in range(10512) if (px2[:,shift][i]<0.05)]
        nn=len(signodes)
        if(len(signodes)!=0):

            lats1=np.array(latx)[signodes]
            lons1=np.array(lonx)[signodes]
            x, y = m(lons1,lats1)
            
                #lats1=np.array(lats1)
                #lons1=np.array(lons1)
            m.scatter(x,y,150,marker='x',c='k')
           # ax.colorbar(im, fraction=0.046, pad=0.04)  
            #plt.colorbar() 
        plt.title('$r_{'+str(shift-36)+'}$ and $N='+str(nn)+'$',fontsize=66) #annual
          
        
        # plt.annotate('(d)', xy=(-0.03,1.05), xycoords='axes fraction', fontsize=72,
        #                      xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
        #                      ha='left', va='bottom')  
        plt.subplots_adjust(top = 0.96, bottom = 0.04, right = 0.90, left = 0.08, 
                    hspace = 0.1, wspace = 0.3)   
        
        figure = plt.gcf() # get current figure
                    # 
        figure.set_size_inches(30,25)
        plt.savefig("/home/meng/bak_bupt/newproj/fig/cp_vs_mag_shift"+str(shift-36)+"mon_peak_shuffle.png")
        plt.close()
      
import numpy as np
import pandas as pd
from scipy import signal
import matplotlib.pyplot as plt

def sine_generator(fs, sinefreq, duration):
    T = duration
    n = fs * T
    w = 2. * np.pi * sinefreq
    t_sine = np.linspace(0, T, n, endpoint = False)
    y_sine = np.sin(w * t_sine)
    result = pd.DataFrame({"data" : y_sine} ,index = t_sine)
    return result

def butter_highpass(cutoff, fs, order=5):
    nyq = 0.5 * fs
    normal_cutoff = cutoff / nyq
    b, a = signal.butter(order, normal_cutoff, btype = "high", analog = False)
    return b, a

def butter_highpass_filter(data, cutoff, fs, order=5):
    b, a = butter_highpass(cutoff, fs, order=order)
    y = signal.filtfilt(b, a, data)
    return y

n=np.arange(100,1100,1)
x=np.cos(n*2*np.pi/500)
y=0.7*np.cos(n*2*np.pi/10)+0.3*x



fps = 30
sine_fq = 10
duration = 10
sine_5Hz = sine_generator(fps,sine_fq,duration)
sine_fq = 1
duration = 10
sine_1Hz = sine_generator(fps,sine_fq,duration)
sine = sine_5Hz + sine_1Hz
filtered_sine = butter_highpass_filter(sine.data, 10, fps)
plt.figure(figsize = (20, 10))
plt.subplot(211)
plt.plot(range(len(sine)), sine)
plt.title("Generated Signal")
plt.subplot(212)
plt.plot(range(len(filtered_sine)), filtered_sine)
plt.title("Filtered Signal")
plt.show()