#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jun 16 11:13:48 2023

@author: meng
"""
from netCDF4 import Dataset
import numpy as np
import glob
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import os
os.environ['PROJ_LIB'] = r'/home/jingfang/anaconda2/share/proj'
from scipy import signal
import matplotlib
#matplotlib.use('Agg')  # Or any other X11 back-end
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
#from mpl_toolkits.basemap import Basemap
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.patches import Polygon
import math
from numpy import random

import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
from scipy import stats

from scipy.interpolate import interp2d
from matplotlib.colors import LogNorm    
from scipy.stats.stats import pearsonr

from netCDF4 import Dataset

from scipy.stats import rankdata

from scipy.stats import gaussian_kde

import glob

import seaborn as sns
from scipy.interpolate import griddata

def plot_region_indexA():
    path='/home/meng/bak_bupt/newproj/data/'

    data0=np.loadtxt(path+'iceage_regions_12.dat')
    icex0=np.reshape(data0,(34,12))
            
    data1=np.loadtxt(path+'iceage_regions_fresh_12.dat',)
    icex1=np.reshape(data1[:,0],(34,12))
    
    #icex1=icex0

    icex2=np.reshape(data1[:,1],(34,12))


    data2=np.loadtxt(path+'psd_regions.dat')
    psdx=np.reshape(data2,(12,34))
    
    data3=np.loadtxt(path+'acf_regions.dat')    
    acfx=np.reshape(data3,(12,34))
    
    def vx(x):
        a=np.mean(x)
        b=max(x)
        c=np.std(x)
        y=x/(c)
        return y
    
    
    iceagen=np.loadtxt(path+'divide_arctic_iceage_12.dat')
    
    ax=plt.subplot2grid((3,4), (0,0))
    i=0
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    
    plt.ylim(-0.1,1.1)
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    



    plt.title('Sea of Okhotsk',fontsize=38)
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,1))
    i=1
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Bering Sea',fontsize=38)
    
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (0,2))
    i=2
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Hudson Bay',fontsize=38)
    
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,3))
    i=3
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='Ratio of Thin Ice')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Baffin Bay',fontsize=38)
    plt.legend(fontsize=38,loc=1,bbox_to_anchor=(1.0,1.62))
    
    plt.annotate('d', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    
    
    ax=plt.subplot2grid((3,4), (1,0))
    i=4
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
  #  plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Greenland Sea',fontsize=38)

    plt.annotate('$m_{i}=0.001$', xy=(0.6,0.04), xycoords='axes fraction', fontsize=32,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     
    plt.annotate('$m_{p}=0.002$', xy=(0.6,0.11), xycoords='axes fraction', fontsize=32,
                         xytext=(0, -12), textcoords='offset points',color='r',rotation=0,
                         ha='left', va='bottom')      
    plt.annotate('e', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     


    ax=plt.subplot2grid((3,4), (1,1))
    i=5
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Barents-Kara Sea',fontsize=38)
    plt.annotate('$m_{i}=0.001$', xy=(0.6,0.04), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    
    plt.annotate('f', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (1,2))
    i=6
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Central Arctic',fontsize=38)
    plt.annotate('$m_{i}=0.013$', xy=(0.6,0.04), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    plt.annotate('$m_{p}=0.007$', xy=(0.6,0.18), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='r',rotation=0,
                         ha='left', va='bottom') 
    plt.annotate('$m_{a}=0.005$', xy=(0.6,0.11), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='b',rotation=0,
                         ha='left', va='bottom')   


    
    plt.annotate('g', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (1,3))
    i=7
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')


    plt.title('Canadian Arctic',fontsize=38)
    
    plt.annotate('h', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,0))
    i=8
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    #plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Beaufort Sea',fontsize=38)
    plt.annotate('$m_{i}=0.005$', xy=(0.6,0.03), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
   

    
    plt.annotate('i', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,1))
    i=9
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Chukchi Sea',fontsize=38)
    plt.annotate('$m_{i}=0.014$', xy=(0.6,0.03), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    plt.annotate('$m_{p}=0.004$', xy=(0.6,0.1), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='r',rotation=0,
                         ha='left', va='bottom') 
 

    
    plt.annotate('j', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,2))
    i=10
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('E. Siberian Sea',fontsize=38)
    
    plt.annotate('$m_{i}=0.015$', xy=(0.6,0.03), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    # plt.annotate('$m_{i}=0.004$', xy=(0.1,0.1), xycoords='axes fraction', fontsize=32, 
    #                      xytext=(0, -12), textcoords='offset points',color='r',rotation=0,
    #                      ha='left', va='bottom') 
    # plt.annotate('$m_{i}=0.003$', xy=(0.1,0.17), xycoords='axes fraction', fontsize=32, 
    #                      xytext=(0, -12), textcoords='offset points',color='b',rotation=0,
    #                      ha='left', va='bottom')     

    
    plt.annotate('k', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    plt.annotate('Year', xy=(-0.15,-0.15), xycoords='axes fraction', fontsize=38, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    

    ax=plt.subplot2grid((3,4), (2,3))
    i=11
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
  #  plt.ylim(0.38,1.02)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Laptev Sea',fontsize=38)

    plt.annotate('$m_{i}=0.002$', xy=(0.6,0.04), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    plt.annotate('$m_{p}=0.004$', xy=(0.6,0.18), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='r',rotation=0,
                         ha='left', va='bottom') 
    plt.annotate('$m_{a}=0.003$', xy=(0.6,0.11), xycoords='axes fraction', fontsize=32, 
                         xytext=(0, -12), textcoords='offset points',color='b',rotation=0,
                         ha='left', va='bottom')     
    
    plt.annotate('l', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    
    figure = plt.gcf() # get current figure
    plt.subplots_adjust(top = 0.86, bottom = 0.04, right = 0.99, left = 0.03, 
                hspace = 0.25, wspace = 0.2)  
                # 
    figure.set_size_inches(36, 24)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
   
    #plt.show()
    plt.savefig("/home/meng/bak_bupt/newproj/fig/indexesA.pdf",format='pdf',dpi=300)#,bbox_inches='tight')



def plot_region_indexB():
    path='/home/meng/bak_bupt/newproj/data/'

    data0=np.loadtxt(path+'iceage_regions_12.dat')
    icex0=np.reshape(data0,(34,12))
            
    data1=np.loadtxt(path+'iceage_regions_fresh_12.dat',)
    icex1=np.reshape(data1[:,3],(34,12))
    
    #icex1=icex0

    icex2=np.reshape(data1[:,1],(34,12))


    data2=np.loadtxt(path+'psd_regions.dat')
    psdx=np.reshape(data2,(12,34))
    
    data3=np.loadtxt(path+'acf_regions.dat')    
    acfx=np.reshape(data3,(12,34))
    
    def vx(x):
        a=np.mean(x)
        b=max(x)
        c=np.std(x)
        y=x/(c)
        return y
    
    
    iceagen=np.loadtxt(path+'divide_arctic_iceage_12.dat')
    
    ax=plt.subplot2grid((3,4), (0,0))
    i=0
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    
    plt.ylim(-0.1,1.1)
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    



    plt.title('Sea of Okhotsk',fontsize=38)
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,1))
    i=1
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Bering Sea',fontsize=38)
    
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (0,2))
    i=2
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Hudson Bay',fontsize=38)
    
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,3))
    i=3
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='Ratio of multi-year Ice')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Baffin Bay',fontsize=38)
    plt.legend(fontsize=38,loc=1,bbox_to_anchor=(1.0,1.62))
    
    plt.annotate('d', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    
    
    ax=plt.subplot2grid((3,4), (1,0))
    i=4
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
  #  plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Greenland Sea',fontsize=38)
    
    plt.annotate('e', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     


    ax=plt.subplot2grid((3,4), (1,1))
    i=5
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    #plt.plot(murange,icey,'--',color='k')
    plt.title('Barents-Kara Sea',fontsize=38)
    
    plt.annotate('f', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (1,2))
    i=6
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Central Arctic',fontsize=38)
    
    plt.annotate('g', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (1,3))
    i=7
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')


    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    # slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    # psdy=slope*murange+intercept
    # slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    # acfy=slope*murange+intercept
    # plt.plot(murange,acfy,'--',color='b')
    # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    
  
    plt.title('Canadian Arctic',fontsize=38)
    
    plt.annotate('h', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,0))
    i=8
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    #plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Beaufort Sea',fontsize=38)
    
    plt.annotate('i', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,1))
    i=9
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Chukchi Sea',fontsize=38)
    
    plt.annotate('j', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,2))
    i=10
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('E. Siberian Sea',fontsize=38)
    
    plt.annotate('k', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    plt.annotate('Year', xy=(-0.15,-0.15), xycoords='axes fraction', fontsize=38, 
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    

    ax=plt.subplot2grid((3,4), (2,3))
    i=11
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=32)
    plt.yticks(fontsize=32)
  #  plt.ylim(0.38,1.02)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i]*30,color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey*30,'--',color='k')
    plt.title('Laptev Sea',fontsize=38)
    
    plt.annotate('l', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=38, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    
    figure = plt.gcf() # get current figure
    plt.subplots_adjust(top = 0.86, bottom = 0.04, right = 0.99, left = 0.03, 
                hspace = 0.25, wspace = 0.2)  
                # 
    figure.set_size_inches(36, 24)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
   
    #plt.show()
    plt.savefig("/home/meng/bak_bupt/newproj/fig/indexesB.pdf",format='pdf',dpi=300)#,bbox_inches='tight')


def plot_trend_ice3():
    
    path='/home/meng/bak_bupt/newproj/data/'
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
   
    data1=np.loadtxt(path+'trend_psdsum_ice_anuala.dat')
    data2=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')

    data=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')
    nodes=[int(i) for i in data[:,0]]

    N=166
    month=5
    data1=np.loadtxt(path+'trend_autocorr_ice_monthly_abs.dat')
    rx1=np.reshape(data1[:,1],(N,12))
    px1=np.reshape(data1[:,2],(N,12))
    data2=np.loadtxt(path+'trend_psdsum_ice_monthly.dat')
    rx2=np.reshape(data2[:,1],(N,12))
    px2=np.reshape(data2[:,2],(N,12))
    nodes1=[nodes[i] for i in range(len(nodes)) if(px1[:,month][i]<0.05)]
    nodes2=[nodes[i] for i in range(len(nodes)) if(px2[:,month][i]<0.05)]
    signodes=nodes1+nodes2
    
    
    dataa=np.loadtxt(path+'iceage_1985_week22.dat')

    datab=np.loadtxt(path+'iceage_2019_week22.dat')


 
    fig = plt.figure()
    
   # ax3 = plt.subplot2grid(shape=(21, 23), loc=(13, 0), colspan=10,rowspan=10)
    ax = fig.add_subplot(131)

    data=dataa
   # nodes=[int(i) for i in range(0,len(data),50) if (data[:,2][i]<20)]
   
  #  nodes1=[int(i) for i in range(0,len(data),50) if (data[:,2][i]==0)]
    nodes=[int(i) for i in range(0,len(data),10) if (data[:,2][i] in np.arange(1,20))]
    
   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='gray',ocean_color='midnightblue',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    #m.drawmapboundary(fill_color='gray')
   # m.fillcontinents(color='gray',lake_color='cyan')
    lats1=np.array(data[:,0][nodes])
    lons1=np.array(data[:,1][nodes])
    x, y = m(lons1,lats1)
    
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
    color=data[:,2][nodes]
  

    cm=m.scatter(x,y,15,marker='o',c=color,cmap='Blues_r',vmin=0, vmax=6)   
 
    plt.clim(1,6)
    
   
    lats1=np.array(regrid2[:,1][signodes])
    lons1=np.array(regrid2[:,2][signodes])
    x, y = m(lons1,lats1)
    
    

    m.scatter(x,y,150,facecolors='none', edgecolors='deeppink',marker='o',linewidth=2)





   
    plt.title('$June\ 3-10,\ 1985$',fontsize=48) #annual
      
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=48,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  


    #ax4 = plt.subplot2grid(shape=(21, 23), loc=(13, 11), colspan=10,rowspan=10)
    ax = fig.add_subplot(132)
   
    data=datab
    nodes=[int(i) for i in range(0,len(data),10) if (data[:,2][i] in np.arange(1,20))]
   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
    m.drawlsmask(land_color='gray',ocean_color='midnightblue',lakes=True)

    m.drawcoastlines(linewidth = 1)
    
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
   # m.drawmapboundary(fill_color='gray')
   # m.fillcontinents(color='gray',lake_color='cyan')
    lats1=np.array(data[:,0][nodes])
    lons1=np.array(data[:,1][nodes])
    x, y = m(lons1,lats1)
    
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
    color=data[:,2][nodes]


    cm=m.scatter(x,y,35,marker='o',c=color,cmap='Blues_r',vmin=0, vmax=6)
   

    cb=plt.colorbar(cm,fraction=0.05,pad=0.06,extend='both')
    cb.set_label(label='Sea Ice Age (year)', size=45,rotation=90)
    cb.ax.tick_params(labelsize=45) 
    #m.scatter(x,y,150,marker='o',c=color,cmap='seismic_r')       
   # cb=plt.colorbar(fraction=0.025,pad=0.06)
   # cb.set_label(label='r', size=24, weight='bold')
    #cb.ax.tick_params(labelsize=24)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)   
    c=0.25
    plt.clim(1,6)
 
    lats1=np.array(regrid2[:,1][signodes])
    lons1=np.array(regrid2[:,2][signodes])
    x, y = m(lons1,lats1)
    
    

    m.scatter(x,y,150,facecolors='none', edgecolors='deeppink',marker='o',linewidth=2)
   
    plt.title('$June\ 3-10,\ 2019$',fontsize=48) #annual
      
    
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=48,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  


    ax=plt.subplot(133)
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='mistyrose',ocean_color='k',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    path='/home/meng/bak_bupt/newproj/data/'

    data=np.loadtxt(path+'divide_arctic_12.dat')
    nodes=np.where(data[:,1]>0)[0]
    lats1=data[:,2][nodes]
    lonsx=data[:,3][nodes]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data[:,1][nodes]
    
    m.scatter(x,y,350,marker='o',c=color,cmap='tab20')


    ax.annotate('1', xy=(0.15, 0.7), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('2', xy=(0.15, 0.48), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('3', xy=(0.5, 0.15), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('4', xy=(0.7, 0.18), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('5', xy=(0.65, 0.45), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('6', xy=(0.55, 0.62), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('7', xy=(0.48, 0.48), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('8', xy=(0.44, 0.35), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('9', xy=(0.36, 0.38), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('10', xy=(0.3, 0.45), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('11', xy=(0.31, 0.53), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('12', xy=(0.39, 0.6), xycoords='axes fraction', fontsize=45 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    
    
    ax.annotate('1 Sea of Okhotsk', xy=(1.05, 1.0), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('2 Bering Sea', xy=(1.05, 0.95), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('3 Hudson Bay', xy=(1.05,0.9), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('4 Baffin Bay', xy=(1.05,0.85), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('5 Greenland Sea', xy=(1.05,0.8), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')  
    ax.annotate('6 Barents-Kara Sea', xy=(1.05,0.75), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('7 Central Arctic', xy=(1.05,0.7), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('8 Canadian Arctic', xy=(1.05,0.65), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('9 Beaufort Sea', xy=(1.05,0.6), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')     
    ax.annotate('10 Chukchi Sea', xy=(1.05,0.55), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')     
    ax.annotate('11 E. Siberian Sea', xy=(1.05,0.5), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('12 Laptev Sea', xy=(1.05,0.45), xycoords='axes fraction', fontsize=45 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')  

    
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=48,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  



       
    plt.subplots_adjust(top = 0.99, bottom = 0.01, right = 0.99, left = 0.01, 
                hspace = 0.2, wspace = 0.00001)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(40, 10)
    #plt.savefig("/home/meng/paper/trends_ice2.png",bbox_inches='tight')        
    plt.savefig("/home/meng/bak_bupt/newproj/fig/trends_ice3.pdf",bbox_inches='tight',dpi=300)    
