import numpy as np

def linkcut():
    outfile=open('/public3/home/sc52351/mengjun/arctic/data/ICET_30d_tau20_8040_linkcut.dat','w')
    
    cx0=np.zeros(shape=(100,3031080))
    for i in range(1,101):
        data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(i)+"s_ICET_links_30d_tau20_8040.dat")
        cmaxx=data[:,8]
        cminx=data[:,9]
        cx=[max(abs(cmaxx[k]),abs(cminx[k])) for k in range(len(cmaxx))]
        cx0[i-1]=cx
    for i in range(3031080):
        xx=cx0[:,i]
        y=np.where(cx0[:,i]<1)[0]
        x=xx[y]
        cut95=np.percentile(x,95)
        cut99=np.percentile(x,99)
        outfile.write('%.6f %.6f \n'%(cut95,cut99))
        outfile.flush()
    outfile.close()

def siglink():
    datas=np.loadtxt('/public3/home/sc52351/mengjun/arctic/data/ICET_30d_tau20_8040_linkcut.dat')
    cut95=datas[:,0]
    cut99=datas[:,1]
    for year in range(1980,2020):
        for mon in range(1,13):
            outfile=open("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat",'w')
            data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_links_30d_tau20_8040.dat")
            cabs=abs(data[:,10])
            zz=np.where(cabs>1)[0]
            cabs[zz]=0
            cx=cabs-cut95
            cy=np.where(cx>0,1,0)
            ccx=cabs-cut99
            ccy=np.where(ccx>0,1,0)
            cz=np.reshape(cy,(8040,377))
            ccz=np.reshape(ccy,(8040,377))
            cabsx=np.reshape(data[:,10],(8040,377))
            for i in range(8040):
                cw=np.where(cz[i]==1)[0]
                ccw=np.mean(cabsx[i][cw])
                cabsy=cabsx[i][cw]
                outfile.write('%d %d %.6f \n'%(sum(cz[i])/len(cw),sum(ccz[i])/len(ccw),ccw))
                outfile.flush()                
            outfile.close()            
def degree():
    outfile1=open('/public3/home/sc52351/mengjun/arctic/data/ICET_degrees_30d_tau20_8040_space.dat','w')
    outfile2=open('/public3/home/sc52351/mengjun/arctic/data/ICET_degrees_30d_tau20_8040_time.dat','w')
    
    
    n95x=np.zeros(shape=(480,8040))
    n99x=np.zeros(shape=(480,8040))
    k=-1
    for year in range(1980,2020):
        for mon in range(12):
            data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat")
            n95=data[:,0]
            n99=data[:,1]
            k+=1
            n95x[k]=n95
            n99x[k]=n99
            
    for i in range(8040):
        outfile1.write('%.6f %.6f \n'%(np.mean(n95x[:,i]),np.mean(n99x[:,i])))
        outfile1.flush()
    outfile1.close()
    
    for i in range(480):
        outfile2.write('%.6f %.6f \n'%(np.mean(n95x[i]),np.mean(n99x[i])))
        outfile2.flush()
    outfile2.close()            
 

def linkcut726():
    outfile=open('/public3/home/sc52351/mengjun/arctic/data/ICET_30d_tau20_726_linkcut.dat','w')
    
    cx0=np.zeros(shape=(100,377*726))
    wx0=np.zeros(shape=(100,377*726))

    for i in range(1,101):
        data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(i+1980)+"_1_ICET_links_40y_tau20_726_sy.dat")
        cabsx=data[:,10]
        wabsx=data[:,11]
        tabsx=data[:,12]
        cx0[i-1]=cabsx
        wx0[i-1]=wabsx
        
    for i in range(377*726):
        xx=cx0[:,i]
        y=np.where(cx0[:,i]<1)[0]
        x=xx[y]
        cut95=np.percentile(x,95)
        cut99=np.percentile(x,99)
        
        xx=wx0[:,i]
        y=np.where(wx0[:,i]<1)[0]
        x=xx[y]
        cut95w=np.percentile(x,95)
        cut99w=np.percentile(x,99)
        
        outfile.write('%.6f %.6f %.6f %.6f \n'%(cut95,cut99,cut95w,cut99w))
        outfile.flush()
    outfile.close()



def linkcut8040():
    outfile=open('/public3/home/sc52351/mengjun/arctic/data/ICET_10y_tau20_8040_linkcut.dat','w')
    
    cx0=np.zeros(shape=(100,377*8040))
    wx0=np.zeros(shape=(100,377*8040))

    for i in range(100):
        data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(i+1980)+"_1_ICET_links_10y_tau20_8040_sy.dat")
        cabsx=abs(data[:,10])
        wabsx=abs(data[:,11])
        cx0[i]=cabsx
        wx0[i]=wabsx
        
    for i in range(377*8040):
        xx=cx0[:,i]
        y=np.where(cx0[:,i]<1)[0]
        x=xx[y]
        cut95=np.percentile(x,95)
        cut99=np.percentile(x,99)
        
        xx=wx0[:,i]
        x=xx[y]
        cut95w=np.percentile(x,95)
        cut99w=np.percentile(x,99)
        
        outfile.write('%.6f %.6f %.6f %.6f \n'%(cut95,cut99,cut95w,cut99w))
        outfile.flush()
    outfile.close()

def readdegree8040_shuffle():                
    N=8040
    path='/public3/home/sc52351/mengjun/arctic/data/'
    datas=np.loadtxt(path+'ICET_40y_tau20_8040_linkcut.dat')
    cut95=datas[:,0]
    cut99=datas[:,1]
    cut95w=datas[:,2]
    cut99w=datas[:,3]
    outfile=open(path+'ICET_degrees_40y_tau20_8040_sy.dat','w')
    
    for i in range(100):
        data=np.loadtxt(path+"year/"+str(i+1980)+"_1_ICET_links_40y_tau20_8040_sy.dat")
        

        #outfile=open(path+"year/"+str(i+1980)+"_1_ICET_degrees_40y_tau20_8040_sy.dat",'w')
        cabs=abs(data[:,10])
        zz=np.where(cabs>1)[0]
        cabs[zz]=0
        cx=cabs-cut95
        cy=np.where(cx>0,1,0)
        ccx=cabs-cut99
        ccy=np.where(ccx>0,1,0)
        cz=np.reshape(cy,(N,377))
        ccz=np.reshape(ccy,(N,377))
        cabsx=np.reshape(data[:,10],(N,377))
        wabsx=np.reshape(data[:,11],(N,377))
        tabsx=np.reshape(data[:,12],(N,377))
        for i in range(N):
            cw=np.where(cz[i]==1)[0]
            ccw=np.mean(cabsx[i][cw])
            cccw=np.mean(wabsx[i][cw])    
            ccccw=np.mean(tabsx[i][cw])
            outfile.write('%d %d %.6f %.6f %d \n'%(sum(cz[i]),sum(ccz[i]),ccw,cccw,ccccw))
            outfile.flush()                
    outfile.close()


def siglinkx():
    path='public3/home/sc52351/mengjun/arctic/data/'
    datas=np.loadtxt('/public3/home/sc52351/mengjun/arctic/data/ICET_30d_tau20_8040_linkcut.dat')
    cut95=datas[:,0]
    cut99=datas[:,1]
    for year in range(1980,2020):
        for mon in range(12):
            outfile=open("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat",'w')
            data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_links_30d_tau20_8040.dat")
            cabs=abs(data[:,10])
            zz=np.where(cabs>1)[0]
            yy=np.where(cabs<1)[0]
            cabs[zz]=0
            cx=cabs-cut95
            cy=np.where(cx>0,1,0)
            ccx=cabs-cut99
            ccy=np.where(ccx>0,1,0)
            cz=np.reshape(cy,(8040,377))
            ccz=np.reshape(ccy,(8040,377))
            cabsx=np.reshape(data[:,10],(8040,377))
            cabsy=cabs
            cabsy[yy]=1
            cabsy=np.reshape(cabsy,(8040,377))
            for i in range(8040):
                cw=np.where(cz[i]==1)[0]
               # ccw=np.mean(cabsx[i][cw])
                q=len(cabsy[i])
                if(q>0):                    
                    outfile.write('%.6f %.6f \n'%(sum(cz[i])/sum(cabsy[i]),sum(ccz[i])/sum(cabsy[i])))
                    outfile.flush() 
                else:
                    outfile.write('%.6f %.6f \n'%(sum(cz[i])/1,sum(ccz[i])/1))
                    outfile.flush()                     
            outfile.close()

def siglinky():
    path='/public3/home/sc52351/mengjun/arctic/data/'
    datas=np.loadtxt(path+'ICET_30d_tau20_8040_linkcut.dat')
    cut95=datas[:,0]
    cut99=datas[:,1]
    outfile=open(path+'ICET_30d_tau20_8040_sigtime.dat','w')
    z=np.zeros(len(cut95))
    z1=np.zeros(len(cut99))
    for year in range(1980,2020):
        for mon in range(12):
           # outfile=open(path+"year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat",'w')
            data=np.loadtxt(path+"year/"+str(year)+"_"+str(mon)+"_ICET_links_30d_tau20_8040.dat")
            cabs=abs(data[:,10])
            zz=np.where(cabs>1)[0]
            cabs[zz]=0
            cx=cabs-cut95
            cy=np.where(cx>0,1,0)
            ccx=cabs-cut99
            ccy=np.where(ccx>0,1,0)
            z+=cy
            z1+=ccy
            print (z[0])    
    for i in range(len(cut95)):
        print (z[i],z1[i])
        outfile.write('%d %d \n'%(z[i],z1[i]))
        outfile.flush()
    outfile.close()

def degreeX():
    outfile1=open('/public3/home/sc52351/mengjun/arctic/data/ICET_degrees_30d_tau20_8040_space.dat','w')
    outfile2=open('/public3/home/sc52351/mengjun/arctic/data/ICET_degrees_30d_tau20_8040_time.dat','w')
    outfile3=open('/public3/home/sc52351/mengjun/arctic/data/ICET_degrees_30d_tau20_8040_all.dat','w')
    
    
    n95x=np.zeros(shape=(480,8040))
    n99x=np.zeros(shape=(480,8040))
    k=-1
    for year in range(1980,2020):
        for mon in range(12):
            data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat")
            n95=data[:,0]
            n99=data[:,1]
            k+=1
            n95x[k]=n95
            n99x[k]=n99
            for i in range(8040):
                outfile3.write('%.6f %.6f \n'%(n95[i],n99[i]))
                outfile3.flush()
    outfile3.close()
            
    for i in range(8040):
        outfile1.write('%.6f %.6f \n'%(np.mean(n95x[:,i]),np.mean(n99x[:,i])))
        outfile1.flush()
    outfile1.close()
    
    for i in range(480):
        outfile2.write('%.6f %.6f \n'%(np.mean(n95x[i]),np.mean(n99x[i])))
        outfile2.flush()
    outfile2.close()    

def degree():
    path='/public3/home/sc52351/mengjun/arctic/data/'
    datas=np.loadtxt(path+'ICET_30d_tau20_8040_linkcut.dat')
    cut95=datas[:,0]
    cut99=datas[:,1]
    outfile=open(path+'ICET_30d_tau20_8040_weight.dat','w')

    for year in range(1980,2020):
        for mon in range(12):
           # outfile=open(path+"year/"+str(year)+"_"+str(mon)+"_ICET_degrees_30d_tau20_8040.dat",'w')
            data=np.loadtxt(path+"year/"+str(year)+"_"+str(mon)+"_ICET_links_30d_tau20_8040.dat")
            cabs=abs(data[:,10])
            
            zz=np.where(cabs>1)[0]
            cabs[zz]=0
            cx=cabs-cut95
            cy=np.where(cx>0,1,0)
            ccx=cabs-cut99
            ccy=np.where(ccx>0,1,0)
           
            weightx=np.reshape(data[:,10],(8040,377))
            linkx=np.reshape(cy,(8040,377))
            for i in range(8040):
                x=np.where(linkx[i]==1)[0]
                if(len(x)>0):
                    a=np.mean(weightx[i][x])
                else:
                    a=0
                outfile.write('%.6f \n'%(a))
                outfile.flush()
    outfile.close()
def selectlinks():    
    
    N=8040
    path='/public3/home/sc52351/mengjun/arctic/data/'
    
    data=np.loadtxt(path+'1980_1_ICET_links_40y_tau20_8040.dat')
    datas=np.loadtxt(path+'ICET_40y_tau20_8040_linkcut.dat')

    weight=np.reshape(data[:,10],(N,377))
    weights=np.reshape(datas[:,0],(N,377))
    
    # datad=np.loadtxt(path+'ICET_degrees_30d_tau20_8040_all.dat')
    # xx=np.reshape(datad[:,0],(480,8040))
    
    datadd=np.loadtxt(path+'ICET_degrees_40y_tau20_8040.dat')
    datass=np.loadtxt(path+'ICET_30d_tau20_8040_linkcut.dat')
    cs=np.reshape(datass[:,0],(N,377))
    
    
    tmp0=np.loadtxt(path+'era5t8502.5g_ano_1979to2019.ano')
    tmp1=np.loadtxt(path+'era5t85075d_ano_1979to2019_g_new_377.ano')
    tmpice=np.loadtxt(path+'era5ice2.5d_ano_1979to2019_nonzero.ano')#original path='/home/meng/CLUSTER_DATA/CODE/Python/arctic/DATA/'

    t2xx=np.reshape(tmp0,(8040,14965))
    t1xx=np.reshape(tmp1,(377,15695))
    tixx=np.reshape(tmpice,(377,14965))

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    
    regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/regridcos2.5d_global.dat')
    lats=regrid[:,1]
    lons=regrid[:,2]
    #regridi0=np.loadtxt(path+'regridcos2.5d.dat')
    regridi=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')
    
    cutd=np.percentile(datadd[:,0],95)
    outfile=open(path+'fingsiglink.dat','w')
    for i in range(2000,8040):
        if(datadd[:,0][i]>cutd):
            for j in range(100):
                if(weight[i,j]>weights[i,j] or weight[i,j]<-weights[i,j]):
                    print (i,j,weight[i,j])
                    ni=j
                    nt=i

                    for year in range(1980,2020):
                      for month in range(1,13):
                        T1=t1xx[ni]
                        T2=t2xx[nt]
                        I1=tixx[ni]
                               
                              
                        ss1=365*(year-1979)+monthds[month-1]
                        ss2=ss1+30
                        s1=ss1
                        s2=ss2
                        ICE1T2=[]
                        ICE1T1=[]
                        T1T2=[]
                        taus=[]
                        for tau in range(20,-1,-1):
                                    taus.append(-tau)
                                    t1=T1[s1:s2]
                                    t2=T2[s1:s2]
                                    i1=I1[s1-tau:s2-tau]
                                    # i1=signal.detrend(i1)
                                    # t1=signal.detrend(t1)
                                    # t2=signal.detrend(t2)
                                    ICE1T1.append(pearsonr(i1,t1)[0])
                                    ICE1T2.append(pearsonr(i1,t2)[0])
                                    tt1=T1[s1-tau:s2-tau]
                                    T1T2.append(pearsonr(tt1,t2)[0])
                                   #print (pearsonr(i1,t2)[0],tau)
                        for tau in range(1,21):
                                    taus.append(tau)
                                    t1=T1[s1-tau:s2-tau]
                                    t2=T2[s1-tau:s2-tau]
                                    i1=I1[s1:s2]
                                    # i1=signal.detrend(i1)
                                    # t1=signal.detrend(t1)
                                    # t2=signal.detrend(t2)
                                    ICE1T1.append(pearsonr(i1,t1)[0])
                                    ICE1T2.append(pearsonr(i1,t2)[0])
                                    tt1=T1[s1:s2]
                                    T1T2.append(pearsonr(tt1,t2)[0])
                                    
                        cmax11,cmin11,wp11,wn11,tmax11,tmin11,cabs11,wabs11,tabs11=link(ICE1T1)
                        cmax12,cmin12,wp12,wn12,tmax12,tmin12,cabs12,wabs12,tabs12=link(ICE1T2)
                        Tcmax12,Tcmin12,Twp12,Twn12,Ttmax12,Ttmin12,Tcabs12,Twabs12,Ttabs12=link(T1T2)
                        if(cabs12>cs[i,j]):
                        
                            if(abs(cabs12)>0.8 and abs(Tcabs12)>0.8 and -10<tabs12<10 and -10<Ttabs12<10):
                                print (ni,nt,year,month)
                                print (cabs11,cabs12,Tcabs12,tabs11,tabs12,Ttabs12)    
                                outfile.write('%d %d %d %d %.6f %.6f %.6f %d %d %d %.6f %d \n'%(ni,nt,year,month,cabs11,cabs12,Tcabs12,tabs11,tabs12,Ttabs12,weight[i,j],datadd[:,0][i]))
                                outfile.flush()
    outfile.close()

def linkn():

    outfile1=open('/public3/home/sc52351/mengjun/arctic/data/ICET_linksN_30d_tau20_8040_space_30y.dat','w')
    outfile2=open('/public3/home/sc52351/mengjun/arctic/data/ICET_linksN_30d_tau20_8040_space_20y.dat','w')
    outfile3=open('/public3/home/sc52351/mengjun/arctic/data/ICET_linksN_30d_tau20_8040_space_10y.dat','w')
    outfile4=open('/public3/home/sc52351/mengjun/arctic/data/ICET_linksN_30d_tau20_8040_space_1y.dat','w')    
    
    n95x=np.zeros(shape=(480,8040))
    n99x=np.zeros(shape=(480,8040))
    k=-1
    for year in range(1980,2020):
        for mon in range(1,13):
            data=np.loadtxt("/public3/home/sc52351/mengjun/arctic/data/year/"+str(year)+"_"+str(mon)+"_ICET_linksN_30d_tau20_8040.dat")
            n95=data[:,0]/data[:,2]
            n99=data[:,1]/data[:,2]
            k+=1
            n95x[k]=n95
            n99x[k]=n99
            
    for i in range(8040):
        outfile1.write('%.6f %.6f \n'%(np.mean(n95x[120:,i]),np.mean(n99x[120:,i])))
        outfile1.flush()
        outfile2.write('%.6f %.6f \n'%(np.mean(n95x[240:,i]),np.mean(n99x[240:,i])))
        outfile2.flush()
        outfile3.write('%.6f %.6f \n'%(np.mean(n95x[360:,i]),np.mean(n99x[360:,i])))
        outfile3.flush()
        outfile4.write('%.6f %.6f \n'%(np.mean(n95x[456:,i]),np.mean(n99x[456:,i])))
        outfile4.flush()
    outfile1.close()
    outfile2.close()
    outfile3.close()
    outfile4.close()
linkn()
#siglinkx()  
            
#readdegree8040_shuffle()                         
